#ifndef _DAQNAVI_CONST_H
#define _DAQNAVI_CONST_H

#define MAX_TRIG_COUNT     4
#define MAX_DIO_TRIG_COUNT 2

// Property id map of Trigger0 and Trigger1
const PropertyId feat_id_trigAction[]     = {CFG_FeatureTriggerActions,             CFG_FeatureTrigger1Actions,             CFG_FeatureTrigger2Actions,             CFG_FeatureTrigger3Actions            };
const PropertyId feat_id_trigDlyRng[]     = {CFG_FeatureTriggerDelayCountRange,     CFG_FeatureTrigger1DelayCountRange,     CFG_FeatureTrigger2DelayCountRange,     CFG_FeatureTrigger3DelayCountRange    };
const PropertyId feat_id_trigSrc[]        = {CFG_FeatureTriggerSources,             CFG_FeatureTrigger1Sources,             CFG_FeatureTrigger2Sources,             CFG_FeatureTrigger3Sources            };
const PropertyId feat_id_trigSrcVrg[]     = {CFG_FeatureTriggerSourceVRG,           CFG_FeatureTrigger1SourceVRG,           CFG_FeatureTrigger2SourceVRG,           CFG_FeatureTrigger3SourceVRG          };
const PropertyId feat_id_trigHystIdxMax[] = {CFG_FeatureTriggerHysteresisIndexMax,  CFG_FeatureTrigger1HysteresisIndexMax,  CFG_FeatureTrigger2HysteresisIndexMax,  CFG_FeatureTrigger3HysteresisIndexMax };
const PropertyId feat_id_trigHystStep[]   = {CFG_FeatureTriggerHysteresisIndexStep, CFG_FeatureTrigger1HysteresisIndexStep, CFG_FeatureTrigger2HysteresisIndexStep, CFG_FeatureTrigger3HysteresisIndexStep};

const PropertyId prop_id_trigDelay[]         = {CFG_TriggerDelayCount,       CFG_Trigger1DelayCount,       CFG_Trigger2DelayCount,       CFG_Trigger3DelayCount       };
const PropertyId prop_id_trigSrc[]           = {CFG_TriggerSource,           CFG_Trigger1Source,           CFG_Trigger2Source,           CFG_Trigger3Source           };
const PropertyId prop_id_trigEdge[]          = {CFG_TriggerSourceEdge,       CFG_Trigger1SourceEdge,       CFG_Trigger2SourceEdge,       CFG_Trigger3SourceEdge       };
const PropertyId prop_id_trigLevel[]         = {CFG_TriggerSourceLevel,      CFG_Trigger1SourceLevel,      CFG_Trigger2SourceLevel,      CFG_Trigger3SourceLevel      };
const PropertyId prop_id_trigAction[]        = {CFG_TriggerAction,           CFG_Trigger1Action,           CFG_Trigger2Action,           CFG_Trigger3Action           };
const PropertyId prop_id_trigHystIdx[]       = {CFG_TriggerHysteresisIndex,  CFG_Trigger1HysteresisIndex,  CFG_Trigger2HysteresisIndex,  CFG_Trigger3HysteresisIndex  }; 
const PropertyId prop_id_trigFltType[]       = {CFG_TriggerFilterType,       CFG_Trigger1FilterType,       CFG_Trigger2FilterType,       CFG_Trigger3FilterType       }; 
const PropertyId prop_id_trigFltCutoffFreq[] = {CFG_TriggerFilterCutoffFreq, CFG_Trigger1FilterCutoffFreq, CFG_Trigger2FilterCutoffFreq, CFG_Trigger3FilterCutoffFreq }; 

const PropertyId feat_id_di_trigAction[]     = {CFG_FeatureDiTriggerActions,             CFG_FeatureDiTrigger1Actions             };
const PropertyId feat_id_di_trigDlyRng[]     = {CFG_FeatureDiTriggerDelayCountRange,     CFG_FeatureDiTrigger1DelayCountRange     };
const PropertyId feat_id_di_trigSrc[]        = {CFG_FeatureDiTriggerSources,             CFG_FeatureDiTrigger1Sources             };
const PropertyId feat_id_di_trigHystIdxMax[] = {CFG_FeatureDiTriggerHysteresisIndexMax,  CFG_FeatureDiTrigger1HysteresisIndexMax  };
const PropertyId feat_id_di_trigHystStep[]   = {CFG_FeatureDiTriggerHysteresisIndexStep, CFG_FeatureDiTrigger1HysteresisIndexStep };

const PropertyId feat_id_do_trigAction[]     = {CFG_FeatureDoTriggerActions,             CFG_FeatureDoTrigger1Actions         };
const PropertyId feat_id_do_trigDlyRng[]     = {CFG_FeatureDoTriggerDelayCountRange,     CFG_FeatureDoTrigger1DelayCountRange };
const PropertyId feat_id_do_trigSrc[]        = {CFG_FeatureDoTriggerSources,             CFG_FeatureDoTrigger1Sources         };
const PropertyId feat_id_do_trigHystIdxMax[] = {CFG_FeatureDoTriggerHysteresisIndexMax,  CFG_FeatureDoTrigger1HysteresisIndexMax  };
const PropertyId feat_id_do_trigHystStep[]   = {CFG_FeatureDoTriggerHysteresisIndexStep, CFG_FeatureDoTrigger1HysteresisIndexStep };

const PropertyId prop_id_di_trigDelay[]      = {CFG_DiTriggerDelayCount,       CFG_DiTrigger1DelayCount       };
const PropertyId prop_id_di_trigSrc[]        = {CFG_DiTriggerSource,           CFG_DiTrigger1Source           };
const PropertyId prop_id_di_trigEdge[]       = {CFG_DiTriggerSourceEdge,       CFG_DiTrigger1SourceEdge       };
const PropertyId prop_id_di_trigLevel[]      = {CFG_DiTriggerSourceLevel,      CFG_DiTrigger1SourceLevel      };
const PropertyId prop_id_di_trigAction[]     = {CFG_DiTriggerAction,           CFG_DiTrigger1Action           };
const PropertyId prop_id_di_trigHystIdx[]    = {CFG_DiTriggerHysteresisIndex,  CFG_DiTrigger1HysteresisIndex  }; 

const PropertyId prop_id_do_trigDelay[]      = {CFG_DoTriggerDelayCount,       CFG_DoTriggerDelayCount        };
const PropertyId prop_id_do_trigSrc[]        = {CFG_DoTriggerSource,           CFG_DoTrigger1Source           };
const PropertyId prop_id_do_trigEdge[]       = {CFG_DoTriggerSourceEdge,       CFG_DoTrigger1SourceEdge       };
const PropertyId prop_id_do_trigLevel[]      = {CFG_DoTriggerSourceLevel,      CFG_DoTrigger1SourceLevel      };
const PropertyId prop_id_do_trigAction[]     = {CFG_DoTriggerAction,           CFG_DoTrigger1Action           };
const PropertyId prop_id_do_trigHystIdx[]    = {CFG_DoTriggerHysteresisIndex,  CFG_DoTrigger1HysteresisIndex  }; 


// Event Id supported by controls
const EventId dev_ctl_events[] = {EvtDeviceRemoved, EvtDeviceReconnected, EvtPropertyChanged};

const EventId bfd_ai_events[] = {
                                 EvtBufferedAiDataReady, EvtBufferedAiOverrun, EvtBufferedAiCacheOverflow, 
                                 EvtBufferedAiStopped, EvtBufferedAiBurnOut};
const EventId wav_ai_events[] = {
                                 EvtBufferedAiDataReady, EvtBufferedAiOverrun, EvtBufferedAiCacheOverflow, 
                                 EvtBufferedAiStopped, EvtBufferedAiBurnOut,   EvtBufferedAiTimeStampOverrun, 
                                 EvtBufferedAiTimeStampCacheOverflow, EvtBufferedAiMarkOverrun};

const EventId bfd_ao_events[] = {
                                 EvtBufferedAoDataTransmitted, EvtBufferedAoUnderrun, EvtBufferedAoCacheEmptied, 
                                 EvtBufferedAoTransStopped, EvtBufferedAoStopped };

const EventId inst_di_events[] = {EvtDiInterrupt, EvtDiStatusChange, EvtDiPatternMatch};

const EventId bfd_di_events[] = {EvtBufferedDiDataReady, EvtBufferedDiOverrun, EvtBufferedDiCacheOverflow, EvtBufferedDiStopped};

const EventId bfd_do_events[] = {
                                 EvtBufferedDoDataTransmitted, EvtBufferedDoUnderrun, EvtBufferedDoCacheEmptied, 
                                 EvtBufferedDoTransStopped, EvtBufferedDoStopped };

const EventId bfd_ci_events[] = {EvtCiDataReady, EvtCiOverrun, EvtCiCacheOverflow, EvtCntrStopped};

const EventId bfd_co_events[] = {EvtCoDataTransmitted, EvtCoUnderrun, EvtCoCacheEmptied, EvtCoTransStopped, EvtCntrStopped};

#endif
