#ifndef _DAQNAVI_AI_CHANNEL_IMPL_H
#define _DAQNAVI_AI_CHANNEL_IMPL_H

class AiCtrlBaseImpl;

//*****
// CAUTION: SHARED WITH DN3, DONOT CHANGE THE CLASS LAYOUT AND METHODS(NAME,
// PARAMETERS, etc.). BUT YOU CAN APPEND NEW METHODS TO THE CLASS, IF NECESSARY.
//*****
class AiChannelImpl
{
public:
   virtual int32          BDAQCALL getChannel();
   virtual ValueRange     BDAQCALL getValueRange();
   virtual ErrorCode      BDAQCALL setValueRange(ValueRange value);
   virtual AiSignalType   BDAQCALL getSignalType();
   virtual ErrorCode      BDAQCALL setSignalType(AiSignalType value);
   virtual BurnoutRetType BDAQCALL getBurnoutRetType();
   virtual ErrorCode      BDAQCALL setBurnoutRetType(BurnoutRetType value);
   virtual double         BDAQCALL getBurnoutRetValue();
   virtual ErrorCode      BDAQCALL setBurnoutRetValue(double value);

   // DN4 new properties
   virtual FilterType     BDAQCALL getFilterType();
   virtual ErrorCode      BDAQCALL setFilterType(FilterType value);
   virtual double         BDAQCALL getFilterCutoffFreq();
   virtual ErrorCode      BDAQCALL setFilterCutoffFreq(double value);
   virtual double         BDAQCALL getFilterCutoffFreq1();
   virtual ErrorCode      BDAQCALL setFilterCutoffFreq1(double value);
   virtual int32          BDAQCALL getLogicalNumber();

   //new : Couping & IEPE & Impedance
   virtual CouplingType   BDAQCALL getCouplingType();
   virtual ErrorCode      BDAQCALL setCouplingType(CouplingType value);
   virtual IepeType       BDAQCALL getIepeType();
   virtual ErrorCode      BDAQCALL setIepeType(IepeType value);
   virtual ImpedanceType  BDAQCALL getImpedanceType();
   virtual ErrorCode      BDAQCALL setImpedanceType(ImpedanceType value);

   //new : Sensor Scaling
   virtual ErrorCode      BDAQCALL getSensorDescription(int32 &size, wchar_t desc[]);
   virtual ErrorCode      BDAQCALL setSensorDescription(int32 size, wchar_t desc[]);
                   
   //new : sensor status detect
   virtual double         BDAQCALL getBurnShortRetValue();
   virtual ErrorCode      BDAQCALL setBurnShortRetValue(double value);

   // new: scale table
   virtual ErrorCode      BDAQCALL getScaleTable(int32 &size, MapFuncPiece table[]);
   virtual ErrorCode      BDAQCALL setScaleTable(int32  size, MapFuncPiece table[]);

public:            
   AiChannelImpl(AiCtrlBaseImpl * owner = NULL, int tag = -1)
   {
      m_owner = owner;
      m_tag   = tag;
   }

   void setOwner(AiCtrlBaseImpl * owner, int tag) 
   {
      m_owner = owner;
      m_tag   = tag;
   }

protected:
   AiCtrlBaseImpl *m_owner;
   int32           m_tag;
};

#endif
