#ifndef _DAQNAVI_INSTANT_AI_CTRL_IMPL_H
#define _DAQNAVI_INSTANT_AI_CTRL_IMPL_H

class InstantAiCtrlImpl : public AiCtrlBaseImpl
{
public:
   //********************************************************************************
   // method
   //--------------------------------------------------------------------------------
   ErrorCode ReadAny(int32 chStart, int32 chCount, void *dataRaw, double *dataScaled)
   {
      ErrorCode ret = ModuleRef().ReadSamples(chStart, chCount, dataRaw, dataScaled);
      return ret;
   }

   //********************************************************************************
   // property
   //--------------------------------------------------------------------------------
   CjcSettingImpl * getCjc()
   {
      if (getInitialized() && getFeatures()->getThermoSupported()) {
         return &m_cjc;
      }
      return NULL;
   }

   double getAutoConvertClockRate()
   {
      double val = 0;
      ModProp().Get(CFG_SaiAutoConvertClockRate, val);
      return val;
   }
   ErrorCode setAutoConvertClockRate(double value)
   {
      return ModProp().Set(CFG_SaiAutoConvertClockRate, value);
   }
   int32 getAutoConvertChannelStart()
   {
      int32 val = 0;
      ModProp().Get(CFG_SaiAutoConvertChannelStart, val);
      return val;
   }
   ErrorCode setAutoConvertChannelStart(int32 value)
   {
      return ModProp().Set(CFG_SaiAutoConvertChannelStart, value);
   }
   int32 getAutoConvertChannelCount()
   {
      int32 val = 0;
      ModProp().Get(CFG_SaiAutoConvertChannelCount, val);
      return val;
   }
   ErrorCode setAutoConvertChannelCount(int32 value)
   {
      return ModProp().Set(CFG_SaiAutoConvertChannelCount, value);
   }

public: // ctor & dtor
   InstantAiCtrlImpl()          { m_cjc.setOwner(this); }
   virtual ~InstantAiCtrlImpl() { }

private:
   CjcSettingImpl  m_cjc;
};

#endif
