#ifndef _DAQNAVI_AO_CHANNEL_IMPL_H
#define _DAQNAVI_AO_CHANNEL_IMPL_H

class AoCtrlBaseImpl;

//*****
// CAUTION: SHARED WITH DN3, DONOT CHANGE THE CLASS LAYOUT AND METHODS(NAME,
// PARAMETERS, etc.). BUT YOU CAN APPEND NEW METHODS TO THE CLASS, IF NECESSARY.
//*****
class AoChannelImpl
{
public:
   virtual int32      BDAQCALL getChannel();
   virtual ValueRange BDAQCALL getValueRange();
   virtual ErrorCode  BDAQCALL setValueRange(ValueRange value);

   // DN4: external reference of each channel
   virtual double     BDAQCALL getExtRefBipolar();
   virtual ErrorCode  BDAQCALL setExtRefBipolar(double value);
   virtual double     BDAQCALL getExtRefUnipolar();
   virtual ErrorCode  BDAQCALL setExtRefUnipolar(double value);
  
   // new: scale table
   virtual ErrorCode  BDAQCALL getScaleTable(int32 &size, MapFuncPiece table[]);
   virtual ErrorCode  BDAQCALL setScaleTable(int32  size, MapFuncPiece table[]);

public:
   AoChannelImpl(AoCtrlBaseImpl * owner = NULL, int tag = -1)
   {
      m_owner = owner;
      m_tag   = tag;
   }

   void setOwner(AoCtrlBaseImpl * owner, int tag) 
   {
      m_owner = owner;
      m_tag   = tag;
   }

protected:
   AoCtrlBaseImpl *m_owner;
   int32          m_tag;
};

#endif
