#ifndef _DAQNAVI_AO_FEATURE_IMPL_H
#define _DAQNAVI_AO_FEATURE_IMPL_H

class AoCtrlBaseImpl;

class AoFeaturesImpl
{
public:
   // DAC features
   int32 getResolution();
   int32 getDataSize();
   int32 getDataMask();

   // channel features
   int32                  getChannelCountMax();
   ArrayImpl<ValueRange>* getValueRanges();
   bool                   getExternalRefAntiPolar();
   void                   getExternalRefRange(MathInterval &x);

   // buffered ao->basic features
   bool                   getBufferedAoSupported();
   SamplingMethod         getSamplingMethod();
   int32                  getChannelStartBase();
   int32                  getChannelCountBase();

   // buffered ao->conversion clock features
   ArrayImpl<SignalDrop>* getConvertClockSources();
   void                   getConvertClockRange(MathInterval &x);

   // buffered ao->trigger features
   int32                     getTriggerCount();
   bool                      getRetriggerable();
   ArrayImpl<SignalDrop>*    getTriggerSources(int32 trigger);
   ArrayImpl<TriggerAction>* getTriggerActions(int32 trigger);
   void                      getTriggerDelayRange(int32 trigger, MathInterval &x) ;

public:
   AoFeaturesImpl(AoCtrlBaseImpl * owner = NULL) 
   { 
      m_owner = owner; 
   }
   void setOwner(AoCtrlBaseImpl * owner) 
   {  
      assert(owner);  
      m_owner = owner;
   }

private:
   AoCtrlBaseImpl * m_owner;
};

#endif
