#ifndef _DAQNAVI_BFD_CNTR_RECORD_IMPL_H
#define _DAQNAVI_BFD_CNTR_RECORD_IMPL_H

// -----------------------------------------------------------------
// implementation of ScanChannel
// -----------------------------------------------------------------

class CntrCtrlBaseImpl;

class BfdCntrRecordImpl : public RecordImpl
{
public:
   // Record
   virtual int32     getSectionLength();
   virtual ErrorCode setSectionLength(int32 value);
   virtual int32     getSectionCount();
   virtual ErrorCode setSectionCount(int32 value);
   virtual int32     getCycles();
   virtual ErrorCode setCycles(int32 value);

public:
   BfdCntrRecordImpl(CntrCtrlBaseImpl *owner = NULL) 
   { 
      m_cycles        = 1;
      m_sectionLength = 1024;
      m_sectionCount  = 0;
      m_owner         = owner; 
   }
   void setOwner(CntrCtrlBaseImpl *owner) 
   { 
      m_owner = owner; 
   }

protected:
   CntrCtrlBaseImpl * m_owner;

private:
   int32 m_cycles;
   int32 m_sectionLength;
   int32 m_sectionCount;
};

#endif

