#ifndef _DAQNAVI_CONVERSION_IMPL_H
#define _DAQNAVI_CONVERSION_IMPL_H

// -----------------------------------------------------------------
// implementation of ScanChannel
// -----------------------------------------------------------------

class DaqCtrlBase;

class ConversionImpl
{
public:
   // Clock
   SignalDrop getClockSource();
   ErrorCode  setClockSource(SignalDrop value);
   double     getClockRate();
   ErrorCode  setClockRate(double value);

   // Channel
   int32      getChannelStart();
   ErrorCode  setChannelStart(int32 value);
   int32      getChannelCount();
   ErrorCode  setChannelCount(int32 value);
   void       getChannelMap(int32 count, int8 *data);
   ErrorCode  setChannelMap(int32 count, int8 *data);

public:
   ConversionImpl(DaqCtrlBaseImpl *owner = NULL) 
   { 
      m_owner = owner; 
   }
   void setOwner(DaqCtrlBaseImpl *owner) 
   { 
      m_owner = owner; 
   }

protected:
   DaqCtrlBaseImpl * m_owner;
};


#endif
