#ifndef _DAQNAVI_CONVERT_CLOCK_IMPL_H
#define _DAQNAVI_CONVERT_CLOCK_IMPL_H

// -----------------------------------------------------------------
// implementation of ConvertClock
// -----------------------------------------------------------------

class DaqCtrlBaseImpl;

//*****
// CAUTION: SHARED WITH DN3, DONOT CHANGE THE CLASS LAYOUT AND METHODS(NAME,
// PARAMETERS, etc.). BUT YOU CAN APPEND NEW METHODS TO THE CLASS, IF NECESSARY.
//*****
class ConvertClockImpl
{
public:
   virtual SignalDrop BDAQCALL getSource();
   virtual ErrorCode  BDAQCALL setSource(SignalDrop value);
   virtual double     BDAQCALL getRate();
   virtual ErrorCode  BDAQCALL setRate(double value);

public:
   ConvertClockImpl(DaqCtrlBaseImpl *owner = NULL, bool isDio = false) 
   { 
      m_owner = owner; 
      m_isDio = isDio;
   }
   void setOwner(DaqCtrlBaseImpl *owner, bool isDio = false) 
   { 
      m_owner = owner; 
      m_isDio = isDio;
   }

protected:
   DaqCtrlBaseImpl * m_owner;
   bool              m_isDio;
};

#endif
