#ifndef _DAQNAVI_SCAN_CHANNEL_IMPL_H
#define _DAQNAVI_SCAN_CHANNEL_IMPL_H

// -----------------------------------------------------------------
// implementation of ScanChannel
// -----------------------------------------------------------------

class DaqCtrlBase;

//*****
// CAUTION: SHARED WITH DN3, DONOT CHANGE THE CLASS LAYOUT AND METHODS(NAME,
// PARAMETERS, etc.). BUT YOU CAN APPEND NEW METHODS TO THE CLASS, IF NECESSARY.
//*****
class ScanChannelImpl
{
public:
   virtual int32     BDAQCALL getChannelStart();
   virtual ErrorCode BDAQCALL setChannelStart(int32 value);
   virtual int32     BDAQCALL getChannelCount();
   virtual ErrorCode BDAQCALL setChannelCount(int32 value);
   virtual int32     BDAQCALL getSamples();
   virtual ErrorCode BDAQCALL setSamples(int32 value);
   virtual int32     BDAQCALL getIntervalCount();
   virtual ErrorCode BDAQCALL setIntervalCount(int32 value);

public:
   ScanChannelImpl(DaqCtrlBaseImpl *owner = NULL, bool useExt = false) 
   { 
      m_owner = owner; 
      m_useExt = useExt;
      m_samplesPerChan = 0;
      m_sectionPerChan = 0;
   }
   void setOwner(DaqCtrlBaseImpl *owner, bool useExt) 
   { 
      m_owner = owner; 
      m_useExt = useExt;
   }

   void adjustSamples(int32 value) 
   { 
      m_samplesPerChan = value;
   }

   void adjustIntervalCount(int32 value)
   {
      m_sectionPerChan = value;
   }
protected:
   DaqCtrlBaseImpl * m_owner;
   bool     m_useExt;
   int      m_samplesPerChan;   // cached value which can not be mapped directly to a driver define property.
   int      m_sectionPerChan;   // cached value which can not be mapped directly to a driver define property.

};


#endif

