#ifndef _DAQNAVI_SCAN_CLOCK_IMPL_H
#define _DAQNAVI_SCAN_CLOCK_IMPL_H

// -----------------------------------------------------------------
// implementation of ScanClock
// -----------------------------------------------------------------

class DaqCtrlBase;

//*****
// CAUTION: SHARED WITH DN3, DONOT CHANGE THE CLASS LAYOUT AND METHODS(NAME,
// PARAMETERS, etc.). BUT YOU CAN APPEND NEW METHODS TO THE CLASS, IF NECESSARY.
//*****
class ScanClockImpl
{
public:
   virtual SignalDrop BDAQCALL getSource();
   virtual ErrorCode  BDAQCALL setSource(SignalDrop value);
   virtual double     BDAQCALL getRate();
   virtual ErrorCode  BDAQCALL setRate(double value);
   virtual int32      BDAQCALL getScanCount();
   virtual ErrorCode  BDAQCALL setScanCount(int32 value);

public:
   ScanClockImpl(DaqCtrlBaseImpl *owner = NULL) 
   { 
      m_owner = owner; 
   }
   void setOwner(DaqCtrlBaseImpl *owner) 
   { 
      m_owner = owner; 
   }

protected:
   DaqCtrlBaseImpl * m_owner;
};

#endif

