/*
 * DAQNAVI4 CSCL ANSI-C IMPLEMENTATION
 *
 *  Created on: 2014-12-11
 *      Author: rocky
 */
#include <std_decl.h>

#include <ai/ai_features.h>
#include <ai/ai_channel.h>
#include <ai/cjc_setting.h>
#include <ai/ai_ctrl_base.h>
#include <ai/instant_ai_ctrl.h>
#include <ai/buffered_ai_ctrl.h>
#include <ai/waveform_ai_ctrl.h>

#include <ao/ao_features.h>
#include <ao/ao_channel.h>
#include <ao/ao_ctrl_base.h>
#include <ao/instant_ao_ctrl.h>
#include <ao/buffered_ao_ctrl.h>

#include <dio/dio_features.h>
#include <dio/dio_port.h>
#include <dio/scan_port.h>
#include <dio/dio_trigger.h>
#include <dio/dio_convert_clock.h>
#include <dio/dio_ctrl_base.h>
#include <dio/di_int_channel.h>
#include <dio/di_cosint_port.h>
#include <dio/di_pmint_port.h>
#include <dio/instant_di_ctrl.h>
#include <dio/instant_do_ctrl.h>
#include <dio/buffered_di_ctrl.h>
#include <dio/buffered_do_ctrl.h>

#include <cntr/cntr_channel.h>
#include <cntr/cntr_features.h>
#include <cntr/cntr_ctrl_base.h>
#include <cntr/event_counter_ctrl.h>
#include <cntr/freq_meter_ctrl.h>
#include <cntr/oneshot_ctrl.h>
#include <cntr/pw_meter_ctrl.h>
#include <cntr/pw_modulator_ctrl.h>
#include <cntr/timer_pulse_ctrl.h>
#include <cntr/ud_counter_ctrl.h>

#include <cntr/bfd_event_counter_ctrl.h>
#include <cntr/bfd_pw_meter_ctrl .h>
#include <cntr/bfd_ud_counter_ctrl.h>
#include <cntr/bfd_pw_modulator_ctrl.h>

#include <cali/cali_ctrl.h>
#include <fw/fw_ctrl.h>

#include "bdaq_ctrl_ansi.h"

// *******************************************************************************
//
// ------------------------ DAQNAVI4 CSCL ANSI-C API STUB ------------------------  
//
// *******************************************************************************

// ----------------------------------------------------------
// common classes : Array
// ----------------------------------------------------------
void              BDAQCALL TArray_Dispose(TArray obj)              { obj->Dispose();            }
int32             BDAQCALL TArray_getLength(TArray obj)            { return obj->getLength();   }
void*             BDAQCALL TArray_getItem(TArray obj, int32 index) { return obj->getItem(index);}

// ----------------------------------------------------------
// common classes : ScanChannel
// ----------------------------------------------------------
int32             BDAQCALL TScanChannel_getChannelStart(TScanChannel obj)               { return obj->getChannelStart();        }
ErrorCode         BDAQCALL TScanChannel_setChannelStart(TScanChannel obj, int32 value)  { return obj->setChannelStart(value);   }
int32             BDAQCALL TScanChannel_getChannelCount(TScanChannel obj)               { return obj->getChannelCount();        }
ErrorCode         BDAQCALL TScanChannel_setChannelCount(TScanChannel obj, int32 value)  { return obj->setChannelCount(value);   }
int32             BDAQCALL TScanChannel_getIntervalCount(TScanChannel obj)              { return obj->getIntervalCount();       }
ErrorCode         BDAQCALL TScanChannel_setIntervalCount(TScanChannel obj, int32 value) { return obj->setIntervalCount(value);  }
int32             BDAQCALL TScanChannel_getSamples(TScanChannel obj)                    { return obj->getSamples();             }
ErrorCode         BDAQCALL TScanChannel_setSamples(TScanChannel obj, int32 value)       { return obj->setSamples(value);        }

// ----------------------------------------------------------
// common classes : ConvertClock
// ----------------------------------------------------------
SignalDrop        BDAQCALL TConvertClock_getSource(TConvertClock obj)                  { return obj->getSource();      }
ErrorCode         BDAQCALL TConvertClock_setSource(TConvertClock obj, SignalDrop value){ return obj->setSource(value); }
double            BDAQCALL TConvertClock_getRate(TConvertClock obj)                    { return obj->getRate();        }
ErrorCode         BDAQCALL TConvertClock_setRate(TConvertClock obj, double value)      { return obj->setRate(value);   }

// ----------------------------------------------------------
// common classes : ScanClock
// ----------------------------------------------------------
SignalDrop        BDAQCALL TScanClock_getSource(TScanClock obj)                    { return obj->getSource();         }
ErrorCode         BDAQCALL TScanClock_setSource(TScanClock obj, SignalDrop value)  { return obj->setSource(value);    }
double            BDAQCALL TScanClock_getRate(TScanClock obj)                      { return obj->getRate();           }
ErrorCode         BDAQCALL TScanClock_setRate(TScanClock obj, double value)        { return obj->setRate(value);      }
int32             BDAQCALL TScanClock_getScanCount(TScanClock obj)                 { return obj->getScanCount();      }
ErrorCode         BDAQCALL TScanClock_setScanCount(TScanClock obj, int32 value)    { return obj->setScanCount(value); }
                     
// ----------------------------------------------------------
// common classes : Trigger
// ----------------------------------------------------------
SignalDrop        BDAQCALL TTrigger_getSource(TTrigger obj)                            { return obj->getSource();               }
ErrorCode         BDAQCALL TTrigger_setSource(TTrigger obj,SignalDrop value)           { return obj->setSource(value);          }
ActiveSignal      BDAQCALL TTrigger_getEdge(TTrigger obj)                              { return obj->getEdge();                 }
ErrorCode         BDAQCALL TTrigger_setEdge(TTrigger obj, ActiveSignal value)          { return obj->setEdge(value);            }
double            BDAQCALL TTrigger_getLevel(TTrigger obj)                             { return obj->getLevel();                }
ErrorCode         BDAQCALL TTrigger_setLevel(TTrigger obj, double value)               { return obj->setLevel(value);           }
TriggerAction     BDAQCALL TTrigger_getAction(TTrigger obj)                            { return obj->getAction();               }
ErrorCode         BDAQCALL TTrigger_setAction(TTrigger obj, TriggerAction value)       { return obj->setAction(value);          }
int32             BDAQCALL TTrigger_getDelayCount(TTrigger obj)                        { return obj->getDelayCount();           }
ErrorCode         BDAQCALL TTrigger_setDelayCount(TTrigger obj, int32 value)           { return obj->setDelayCount(value);      }
double            BDAQCALL TTrigger_getHysteresisIndex(TTrigger obj)                   { return obj->getHysteresisIndex();      }
ErrorCode         BDAQCALL TTrigger_setHysteresisIndex(TTrigger obj, double value)     { return obj->setHysteresisIndex(value); }
FilterType        BDAQCALL TTrigger_getFilterType(TTrigger obj)                        { return obj->getFilterType();           }
ErrorCode         BDAQCALL TTrigger_setFilterType(TTrigger obj, FilterType value)      { return obj->setFilterType(value);      }
double            BDAQCALL TTrigger_getFilterCutoffFreq(TTrigger obj)                  { return obj->getFilterCutoffFreq();     }
ErrorCode         BDAQCALL TTrigger_setFilterCutoffFreq(TTrigger obj, double value)    { return obj->setFilterCutoffFreq(value);}
// ----------------------------------------------------------
// common classes : NosFltChannel
// ----------------------------------------------------------
int32             BDAQCALL TNosFltChannel_getChannel(TNosFltChannel obj)             { return obj->getChannel();      }
int8              BDAQCALL TNosFltChannel_getEnabled(TNosFltChannel obj)             { return obj->getEnabled();      }
ErrorCode         BDAQCALL TNosFltChannel_setEnabled(TNosFltChannel obj, int8 value) { return obj->setEnabled(!!value); }

// ----------------------------------------------------------
// common classes : Conversion
// ----------------------------------------------------------
SignalDrop        BDAQCALL TConversion_getClockSource(TConversion obj)                         { return obj->getClockSource();      }
ErrorCode         BDAQCALL TConversion_setClockSource(TConversion obj, SignalDrop value)       { return obj->setClockSource(value); }
double            BDAQCALL TConversion_getClockRate(TConversion obj)                           { return obj->getClockRate();        }
ErrorCode         BDAQCALL TConversion_setClockRate(TConversion obj, double value)             { return obj->setClockRate(value);   }
int32             BDAQCALL TConversion_getChannelStart(TConversion obj)                        { return obj->getChannelStart();     }
ErrorCode         BDAQCALL TConversion_setChannelStart(TConversion obj, int32 value)           { return obj->setChannelStart(value);}
int32             BDAQCALL TConversion_getChannelCount(TConversion obj)                        { return obj->getChannelCount();     }
ErrorCode         BDAQCALL TConversion_setChannelCount(TConversion obj, int32 value)           { return obj->setChannelCount(value);}
void              BDAQCALL TConversion_getChannelMap(TConversion obj, int32 count, int8 *chMap){ return obj->getChannelMap(count, chMap); } 
ErrorCode         BDAQCALL TConversion_setChannelMap(TConversion obj, int32 count, int8 *chMap){ return obj->setChannelMap(count, chMap); } 

// ----------------------------------------------------------
// common classes : Record
// ----------------------------------------------------------
int32             BDAQCALL TRecord_getSectionLength(TRecord obj)                       { return obj->getSectionLength();     }
ErrorCode         BDAQCALL TRecord_setSectionLength(TRecord obj, int32 value)          { return obj->setSectionLength(value);}
int32             BDAQCALL TRecord_getSectionCount(TRecord obj)                        { return obj->getSectionCount();      }
ErrorCode         BDAQCALL TRecord_setSectionCount(TRecord obj, int32 value)           { return obj->setSectionCount(value); }
int32             BDAQCALL TRecord_getCycles(TRecord obj)                              { return obj->getCycles();            }
ErrorCode         BDAQCALL TRecord_setCycles(TRecord obj, int32 value)                 { return obj->setCycles(value);       }

// **********************************************************
// ctrl class : device ctrl class
// ----------------------------------------------------------
// Event
void              BDAQCALL TDeviceCtrl_addEventHandler(TDeviceCtrl obj, EventId id, DeviceEventProc proc, void *userParam)    { obj->addEventHandler(id, proc, userParam);   } 
void              BDAQCALL TDeviceCtrl_removeEventHandler(TDeviceCtrl obj, EventId id, DeviceEventProc proc, void *userParam) { obj->removeEventHandler(id, proc, userParam);}

// Method
ErrorCode         BDAQCALL TDeviceCtrl_Refresh(TDeviceCtrl obj)                                                           { return obj->Refresh();                                  }
ErrorCode         BDAQCALL TDeviceCtrl_ReadRegister(TDeviceCtrl obj, int32 space, int32 offset, int32 length, void *data) { return obj->ReadRegister(space, offset, length, data);  }
ErrorCode         BDAQCALL TDeviceCtrl_WriteRegister(TDeviceCtrl obj, int32 space, int32 offset, int32 length, void *data){ return obj->WriteRegister(space, offset, length, data); }
ErrorCode         BDAQCALL TDeviceCtrl_ReadPrivateRegion(TDeviceCtrl obj, int32 signature, int32 length, uint8 *data)     { return obj->ReadPrivateRegion(signature, length, data); } 
ErrorCode         BDAQCALL TDeviceCtrl_WritePrivateRegion(TDeviceCtrl obj, int32 signature, int32 length, uint8 *data)    { return obj->WritePrivateRegion(signature, length, data);}
ErrorCode         BDAQCALL TDeviceCtrl_SynchronizeTimebase(TDeviceCtrl obj)                                               { return obj->SynchronizeTimebase();                      }
double            BDAQCALL TDeviceCtrl_CalculateAbsoluteTime(TDeviceCtrl obj, double relativeTime)                        { return obj->CalculateAbsoluteTime(relativeTime);        } 

// property
int32             BDAQCALL TDeviceCtrl_getDeviceNumber(TDeviceCtrl obj)                             { return obj->getDeviceNumber(); }
ErrorCode         BDAQCALL TDeviceCtrl_getDescription(TDeviceCtrl obj, int32 length, wchar_t *desc) { return obj->getDescription(length, desc); }
ErrorCode         BDAQCALL TDeviceCtrl_setDescription(TDeviceCtrl obj, int32 length, wchar_t *desc) { return obj->setDescription(length, desc); }
AccessMode        BDAQCALL TDeviceCtrl_getAccessMode(TDeviceCtrl obj)                               { return obj->getAccessMode();   }
ProductId         BDAQCALL TDeviceCtrl_getProductId(TDeviceCtrl obj)                                { return obj->getProductId();    }
int32             BDAQCALL TDeviceCtrl_getBoardId(TDeviceCtrl obj)                                  { return obj->getBoardId();      }
ErrorCode         BDAQCALL TDeviceCtrl_setBoardId(TDeviceCtrl obj, int32 value)                     { return obj->setBoardId(value); }
ErrorCode         BDAQCALL TDeviceCtrl_getBoardVersion(TDeviceCtrl obj, int32 length, wchar_t *ver) { return obj->getBoardVersion(length, ver); }
ErrorCode         BDAQCALL TDeviceCtrl_getDriverVersion(TDeviceCtrl obj, int32 length, wchar_t *ver){ return obj->getDriverVersion(length, ver); }
ErrorCode         BDAQCALL TDeviceCtrl_getDllVersion(TDeviceCtrl obj, int32 length, wchar_t *ver)   { return obj->getDllVersion(length, ver); }
ErrorCode         BDAQCALL TDeviceCtrl_getLocation(TDeviceCtrl obj, int32 length, wchar_t *loc)     { return obj->getLocation(length, loc); }
int32             BDAQCALL TDeviceCtrl_getPrivateRegionLength(TDeviceCtrl obj)                      { return obj->getPrivateRegionLength(); }
int32             BDAQCALL TDeviceCtrl_getHotResetPreventable(TDeviceCtrl obj)                      { return obj->getHotResetPreventable(); }
           
int32             BDAQCALL TDeviceCtrl_getBusSlot(TDeviceCtrl obj)                                  { return obj->getBusSlot();               }
TArray            BDAQCALL TDeviceCtrl_getBaseAddresses(TDeviceCtrl obj)                            { return (TArray)obj->getBaseAddresses(); }
TArray            BDAQCALL TDeviceCtrl_getInterrupts(TDeviceCtrl obj)                               { return (TArray)obj->getInterrupts();    }
TArray            BDAQCALL TDeviceCtrl_getSupportedTerminalBoard(TDeviceCtrl obj)                   { return (TArray)obj->getSupportedTerminalBoard();}
TArray            BDAQCALL TDeviceCtrl_getSupportedEvents(TDeviceCtrl obj)                          { return (TArray)obj->getSupportedEvents();       } 

TerminalBoard     BDAQCALL TDeviceCtrl_getTerminalBoard(TDeviceCtrl obj)                            { return obj->getTerminalBoard();       }
ErrorCode         BDAQCALL TDeviceCtrl_setTerminalBoard(TDeviceCtrl obj, TerminalBoard value)       { return obj->setTerminalBoard(value);  }
ErrorCode         BDAQCALL TDeviceCtrl_setLocateEnabled(TDeviceCtrl obj, int32 value)               { return obj->setLocateEnabled(value);  }

int32             BDAQCALL TDeviceCtrl_getSupportedScenarios(TDeviceCtrl obj)                       { return obj->getSupportedScenarios();  }
HANDLE            BDAQCALL TDeviceCtrl_getDevice(TDeviceCtrl obj)                                   { return (HANDLE)obj->getDevice();      }

// HW specific property
ErrorCode         BDAQCALL TDeviceCtrl_getHwSpecific(TDeviceCtrl obj, wchar_t const *name, int32 *size, void *buffer){ return obj->getHwSpecific(name, size, buffer); }
ErrorCode         BDAQCALL TDeviceCtrl_setHwSpecific(TDeviceCtrl obj, wchar_t const *name, int32 size, void *buffer) { return obj->setHwSpecific(name, size, buffer); }

// Property for fusion device
TArray            BDAQCALL TDeviceCtrl_getSupportedFusionTypes(TDeviceCtrl obj)                     { return (TArray)obj->getSupportedFusionTypes();  } 

// Features & properties for PFP pins
TArray            BDAQCALL TDeviceCtrl_getProgrammableSignals(TDeviceCtrl obj)                                               { return (TArray)obj->getProgrammableSignals(); }
ErrorCode         BDAQCALL TDeviceCtrl_getProgrammableSignalsDirection(TDeviceCtrl obj, int32 length, SignalDirection dir[]) { return obj->getProgrammableSignalsDirection(length, dir); }
ErrorCode         BDAQCALL TDeviceCtrl_setProgrammableSignalsDirection(TDeviceCtrl obj, int32 length, SignalDirection dir[]) { return obj->setProgrammableSignalsDirection(length, dir); }

// Features & properties for signal routing
TArray            BDAQCALL TDeviceCtrl_getRtSignalEndpoints(TDeviceCtrl obj)                                  { return (TArray)obj->getRtSignalEndpoints();                  }
TArray            BDAQCALL TDeviceCtrl_getRtEndpointXSupportedSources(TDeviceCtrl obj, int32 epIndex)         { return (TArray)obj->getRtEndpointXSupportedSources(epIndex); }
SignalDrop        BDAQCALL TDeviceCtrl_getRtEndpointXSource(TDeviceCtrl obj, int32 epIndex)                   { return obj->getRtEndpointXSource(epIndex);                   }
ErrorCode         BDAQCALL TDeviceCtrl_setRtEndpointXSource(TDeviceCtrl obj, int32 epIndex, SignalDrop source){ return obj->setRtEndpointXSource(epIndex, source);           }

// dispose
void BDAQCALL TDeviceCtrl_Dispose(TDeviceCtrl obj)
{
   if (obj->getDisposable()) {
      obj->Deinitialize();
      delete obj;
   }
}

// static:   
TDeviceCtrl BDAQCALL TDeviceCtrl_Create(int32 deviceNumber, wchar_t const *description, AccessMode mode)
{
   TDeviceCtrl ctrl = new DeviceCtrlImpl(true);
   ErrorCode ret = ctrl->Initialize(deviceNumber, description, mode);
   if (ret != Success) {
      TDeviceCtrl_Dispose(ctrl);
      ctrl = NULL;
   }
   return ctrl;
}

TArray BDAQCALL TDeviceCtrl_getInstalledDevices()
{
   return DeviceCtrlImpl::getInstalledDevices();
}

// **********************************************************
// ctrl class : daq ctrl base 
// ----------------------------------------------------------
/* Methods & Properties */
void              BDAQCALL TDaqCtrlBase_addEventHandler(TDaqCtrlBase obj, EventId id, DaqEventProc proc, void *userParam)    { obj->addEventHandler(id, proc, userParam);    }
void              BDAQCALL TDaqCtrlBase_removeEventHandler(TDaqCtrlBase obj, EventId id, DaqEventProc proc, void *userParam) { obj->removeEventHandler(id, proc, userParam); }
void              BDAQCALL TDaqCtrlBase_Cleanup(TDaqCtrlBase obj)                                       { obj->Cleanup();                            }
void              BDAQCALL TDaqCtrlBase_getSelectedDevice(TDaqCtrlBase obj, DeviceInformation *x)       { obj->getSelectedDevice(*x);                }
ErrorCode         BDAQCALL TDaqCtrlBase_setSelectedDevice(TDaqCtrlBase obj, DeviceInformation const *x) { return obj->setSelectedDevice(*x);         }
ControlState      BDAQCALL TDaqCtrlBase_getState(TDaqCtrlBase obj)                                      { return obj->getState();                    }
HANDLE            BDAQCALL TDaqCtrlBase_getDevice(TDaqCtrlBase obj)                                     { return obj->getDevice();                   }
TArray            BDAQCALL TDaqCtrlBase_getSupportedDevices(TDaqCtrlBase obj)                           { return (TArray)obj->getSupportedDevices(); }
TArray            BDAQCALL TDaqCtrlBase_getSupportedModes(TDaqCtrlBase obj)                             { return (TArray)obj->getSupportedModes();   }
HANDLE            BDAQCALL TDaqCtrlBase_getModule(TDaqCtrlBase obj)                                     { return (HANDLE)obj->getModule();           }
ErrorCode         BDAQCALL TDaqCtrlBase_LoadProfile(TDaqCtrlBase obj, wchar_t const *fileName)          { return obj->LoadProfile(fileName);         }

// dispose the control object
void BDAQCALL TDaqCtrlBase_Dispose(TDaqCtrlBase obj) 
{ 
   if (obj) {
      obj->Cleanup(); 
      delete obj;        
   }
}

/* creator */
TDaqCtrlBase BDAQCALL TDaqCtrlBase_Create(Scenario type)
{
   TDaqCtrlBase ctrl;
   switch(type)
   {
   default:              ctrl = NULL;                      break;
   case SceInstantAi:    ctrl = new InstantAiCtrlImpl();   break;
   case SceBufferedAi:   ctrl = new BufferedAiCtrlImpl();  break;
   case SceWaveformAi:   ctrl = new WaveformAiCtrlImpl();  break;
   case SceInstantAo:    ctrl = new InstantAoCtrlImpl();   break;
   case SceBufferedAo:   ctrl = new BufferedAoCtrlImpl();  break;
   case SceInstantDi:    ctrl = new InstantDiCtrlImpl();   break;
   case SceInstantDo:    ctrl = new InstantDoCtrlImpl();   break;
   case SceEventCounter: ctrl = new EventCounterCtrlImpl();break;
   case SceFreqMeter:    ctrl = new FreqMeterCtrlImpl();   break;
   case SceOneShot:      ctrl = new OneShotCtrlImpl();     break;
   case SceTimerPulse:   ctrl = new TimerPulseCtrlImpl();  break;
   case ScePwMeter:      ctrl = new PwMeterCtrlImpl();     break;
   case ScePwModulator:  ctrl = new PwModulatorCtrlImpl(); break;
   case SceUdCounter:    ctrl = new UdCounterCtrlImpl();   break;
   case SceBufferedEventCounter: ctrl = new BfdEventCounterCtrlImpl(); break;
   case SceBufferedPwMeter:      ctrl = new BfdPwMeterCtrlImpl();      break;
   case SceBufferedUdCounter:    ctrl = new BfdUdCounterCtrlImpl();    break;
   case SceBufferedPwModulator:  ctrl = new BfdPwModulatorCtrlImpl();  break;
   case SceBufferedDi:   ctrl = new BufferedDiCtrlImpl();  break;
   case SceBufferedDo:   ctrl = new BufferedDoCtrlImpl();  break;
   case SceCalibration:  ctrl = new CalibrationCtrlImpl(); break;
   case SceFirmware:     ctrl = new FirmwareCtrlImpl();    break;
   }

   if (ctrl) { 
      ctrl->setOuter(ctrl); // set outer object as itself
   } 
   return ctrl;
}

// **********************************************************
// ctrl class : AI related
// ----------------------------------------------------------
// AiChannel
// ----------------------------------------------------------
int32             BDAQCALL TAiChannel_getChannel(TAiChannel obj)                              { return obj->getChannel();      }
int32             BDAQCALL TAiChannel_getLogicalNumber(TAiChannel obj)                        { return obj->getLogicalNumber();}
ValueRange        BDAQCALL TAiChannel_getValueRange(TAiChannel obj)                           { return obj->getValueRange();     }
ErrorCode         BDAQCALL TAiChannel_setValueRange(TAiChannel obj, ValueRange value)         { return obj->setValueRange(value);}
AiSignalType      BDAQCALL TAiChannel_getSignalType(TAiChannel obj)                           { return obj->getSignalType();     }
ErrorCode         BDAQCALL TAiChannel_setSignalType(TAiChannel obj, AiSignalType value)       { return obj->setSignalType(value);}
BurnoutRetType    BDAQCALL TAiChannel_getBurnoutRetType(TAiChannel obj)                       { return obj->getBurnoutRetType();      }
ErrorCode         BDAQCALL TAiChannel_setBurnoutRetType(TAiChannel obj, BurnoutRetType value) { return obj->setBurnoutRetType(value); }
double            BDAQCALL TAiChannel_getBurnoutRetValue(TAiChannel obj)                      { return obj->getBurnoutRetValue();     }
ErrorCode         BDAQCALL TAiChannel_setBurnoutRetValue(TAiChannel obj, double value)        { return obj->setBurnoutRetValue(value);}
double            BDAQCALL TAiChannel_getBurnShortRetValue(TAiChannel obj)                    { return obj->getBurnShortRetValue();     }
ErrorCode         BDAQCALL TAiChannel_setBurnShortRetValue(TAiChannel obj, double value)      { return obj->setBurnShortRetValue(value);}
FilterType        BDAQCALL TAiChannel_getFilterType(TAiChannel obj)                           { return obj->getFilterType();            }
ErrorCode         BDAQCALL TAiChannel_setFilterType(TAiChannel obj, FilterType value)         { return obj->setFilterType(value);       }
double            BDAQCALL TAiChannel_getFilterCutoffFreq(TAiChannel obj)                     { return obj->getFilterCutoffFreq();      }
ErrorCode         BDAQCALL TAiChannel_setFilterCutoffFreq(TAiChannel obj, double value)       { return obj->setFilterCutoffFreq(value); }
double            BDAQCALL TAiChannel_getFilterCutoffFreq1(TAiChannel obj)                    { return obj->getFilterCutoffFreq1();     }
ErrorCode         BDAQCALL TAiChannel_setFilterCutoffFreq1(TAiChannel obj, double value)      { return obj->setFilterCutoffFreq1(value);}
// new: Coupling & IEPE & Impedance
CouplingType      BDAQCALL TAiChannel_getCouplingType(TAiChannel obj)                         { return obj->getCouplingType();      }
ErrorCode         BDAQCALL TAiChannel_setCouplingType(TAiChannel obj, CouplingType value)     { return obj->setCouplingType(value); }
IepeType          BDAQCALL TAiChannel_getIepeType(TAiChannel obj)                             { return obj->getIepeType();          }
ErrorCode         BDAQCALL TAiChannel_setIepeType(TAiChannel obj, IepeType value)             { return obj->setIepeType(value);     }
ImpedanceType     BDAQCALL TAiChannel_getImpedanceType(TAiChannel obj)                        { return obj->getImpedanceType();     }
ErrorCode         BDAQCALL TAiChannel_setImpedanceType(TAiChannel obj, ImpedanceType value)   { return obj->setImpedanceType(value);}
// new: Sensor Scaling
ErrorCode         BDAQCALL TAiChannel_getSensorDescription(TAiChannel obj, int32 *size, wchar_t desc[]) { return obj->getSensorDescription(*size, desc); }
ErrorCode         BDAQCALL TAiChannel_setSensorDescription(TAiChannel obj, int32 size, wchar_t desc[])  { return obj->setSensorDescription(size, desc); }
// new: scale table
ErrorCode         BDAQCALL TAiChannel_getScaleTable(TAiChannel obj, int32 *size, MapFuncPiece table[])  { return obj->getScaleTable(*size, table); } 
ErrorCode         BDAQCALL TAiChannel_setScaleTable(TAiChannel obj, int32  size, MapFuncPiece table[])  { return obj->setScaleTable(size,  table); } 

// ----------------------------------------------------------
// CjcSetting
// ----------------------------------------------------------
int32             BDAQCALL TCjcSetting_getChannel(TCjcSetting obj)                 { return obj->getChannel();       }
ErrorCode         BDAQCALL TCjcSetting_setChannel(TCjcSetting obj, int32 ch)       { return obj->setChannel(ch);     }
double            BDAQCALL TCjcSetting_getValue(TCjcSetting obj)                   { return obj->getValue();         }
ErrorCode         BDAQCALL TCjcSetting_setValue(TCjcSetting obj, double value)     { return obj->setValue(value);    }
double            BDAQCALL TCjcSetting_getUpdateFreq(TCjcSetting obj)              { return obj->getUpdateFreq();    }
ErrorCode         BDAQCALL TCjcSetting_setUpdateFreq(TCjcSetting obj, double value){ return obj->setUpdateFreq(value);}

// ----------------------------------------------------------
// AI features
// ----------------------------------------------------------
// ADC features
int32             BDAQCALL TAiFeatures_getResolution(TAiFeatures obj)         { return obj->getResolution(); }
int32             BDAQCALL TAiFeatures_getDataSize(TAiFeatures obj)           { return obj->getDataSize();   }
int32             BDAQCALL TAiFeatures_getDataMask(TAiFeatures obj)           { return obj->getDataMask();   }

// channel features                                                        
int32             BDAQCALL TAiFeatures_getChannelCountMax(TAiFeatures obj)    { return obj->getChannelCountMax();            }
AiChannelType     BDAQCALL TAiFeatures_getChannelType(TAiFeatures obj)        { return obj->getChannelType();                }
int8              BDAQCALL TAiFeatures_getOverallValueRange(TAiFeatures obj)  { return obj->getOverallValueRange();          }
TArray            BDAQCALL TAiFeatures_getValueRanges(TAiFeatures obj)        { return (TArray)obj->getValueRanges();        }
TArray            BDAQCALL TAiFeatures_getBurnoutReturnTypes(TAiFeatures obj) { return (TArray)obj->getBurnoutReturnTypes(); }

// filter
TArray            BDAQCALL TAiFeatures_getFilterTypes(TAiFeatures obj)                             { return (TArray)obj->getFilterTypes();}
void              BDAQCALL TAiFeatures_getFilterCutoffFreqRange(TAiFeatures obj, MathInterval *x)  { obj->getFilterCutoffFreqRange(*x);   }
void              BDAQCALL TAiFeatures_getFilterCutoffFreq1Range(TAiFeatures obj, MathInterval *x) { obj->getFilterCutoffFreq1Range(*x);  }

// CJC features
int8              BDAQCALL TAiFeatures_getThermoSupported(TAiFeatures obj)         { return obj->getThermoSupported();    }
TArray            BDAQCALL TAiFeatures_getCjcChannels(TAiFeatures obj)             { return (TArray)obj->getCjcChannels();}
              
// buffered ai->basic features
int8              BDAQCALL TAiFeatures_getBufferedAiSupported(TAiFeatures obj)     { return obj->getBufferedAiSupported(); }
SamplingMethod    BDAQCALL TAiFeatures_getSamplingMethod(TAiFeatures obj)          { return obj->getSamplingMethod();      }
int32             BDAQCALL TAiFeatures_getChannelStartBase(TAiFeatures obj)        { return obj->getChannelStartBase();    }
int32             BDAQCALL TAiFeatures_getChannelCountBase(TAiFeatures obj)        { return obj->getChannelCountBase();    }

// buffered ai->conversion clock features
TArray            BDAQCALL TAiFeatures_getConvertClockSources(TAiFeatures obj)                    { return (TArray)obj->getConvertClockSources(); }
void              BDAQCALL TAiFeatures_getConvertClockRange(TAiFeatures obj, MathInterval *value) { obj->getConvertClockRange(*value);            }
              
// buffered ai->burst scan
int8              BDAQCALL TAiFeatures_getBurstScanSupported(TAiFeatures obj)                  { return obj->getBurstScanSupported();      }
TArray            BDAQCALL TAiFeatures_getScanClockSources(TAiFeatures obj)                    { return (TArray)obj->getScanClockSources();}
void              BDAQCALL TAiFeatures_getScanClockRange(TAiFeatures obj, MathInterval *x)     {        obj->getScanClockRange(*x);        }
int32             BDAQCALL TAiFeatures_getScanCountMax(TAiFeatures obj)                        { return obj->getScanCountMax();            }

// buffered ai->trigger features
int8              BDAQCALL TAiFeatures_getRetriggerable(TAiFeatures obj)                       { return obj->getRetriggerable(); }
int32             BDAQCALL TAiFeatures_getTriggerCount(TAiFeatures obj)                        { return obj->getTriggerCount();  }
TArray            BDAQCALL TAiFeatures_getTriggerFilterTypes(TAiFeatures obj, int32 reserved)                           { return obj->getTriggerFilterTypes(reserved);        }
void              BDAQCALL TAiFeatures_getTriggerFilterCutoffFreqRange(TAiFeatures obj, int32 reserved, MathInterval *x){ obj->getTriggerFilterCutoffFreqRange(reserved, *x); }

// buffered ai->trigger0/1/.../x features
TArray            BDAQCALL TAiFeatures_getTriggerActions(TAiFeatures obj, int32 trigger)                          { return (TArray)obj->getTriggerActions(trigger);    }
void              BDAQCALL TAiFeatures_getTriggerDelayRange(TAiFeatures obj, int32 trigger, MathInterval *x)      {        obj->getTriggerDelayRange(trigger, *x);     }
TArray            BDAQCALL TAiFeatures_getTriggerSources(TAiFeatures obj, int32 trigger)                          { return (TArray)obj->getTriggerSources(trigger);    }
ValueRange        BDAQCALL TAiFeatures_getTriggerSourceVrg(TAiFeatures obj, int32 trigger)                        { return obj->getTriggerSourceVrg(trigger);          }
double            BDAQCALL TAiFeatures_getTriggerHysteresisIndexMax(TAiFeatures obj, int32 trigger)               { return obj->getTriggerHysteresisIndexMax(trigger); }
int32             BDAQCALL TAiFeatures_getTriggerHysteresisIndexStep(TAiFeatures obj, int32 trigger)              { return obj->getTriggerHysteresisIndexStep(trigger);}

// --- DN4
TArray            BDAQCALL TAiFeatures_getConnectionTypes(TAiFeatures obj)                                        { return (TArray)obj->getConnectionTypes();          } 
int8              BDAQCALL TAiFeatures_getOverallConnection(TAiFeatures obj)                                      { return obj->getOverallConnection();                }

// new: coupling & IEPE & Impedance
TArray            BDAQCALL TAiFeatures_getCouplingTypes(TAiFeatures obj)  { return obj->getCouplingTypes(); }                         
TArray            BDAQCALL TAiFeatures_getIepeTypes(TAiFeatures obj)      { return obj->getIepeTypes();     }
TArray            BDAQCALL TAiFeatures_getImpedanceTypes(TAiFeatures obj) { return obj->getImpedanceTypes();}

// new: timestamp resolution
double            BDAQCALL TAiFeatures_getTimestampResolution(TAiFeatures obj) { return obj->getTimestampResolution(); }

// new: sensor features
TArray           BDAQCALL  TAiFeatures_getMeasureTypes(TAiFeatures obj) { return obj->getMeasureTypes(); }
TArray           BDAQCALL  TAiFeatures_getBridgeResistances(TAiFeatures obj) { return obj->getBridgeResistances(); }
void             BDAQCALL  TAiFeatures_getExcitingVoltageRange(TAiFeatures obj, MathInterval *value) { obj->getExcitingVoltageRange(*value); }

// ----------------------------------------------------------
// AiCtrlBase
// ----------------------------------------------------------
/* AiCtrlBase Methods */

/* AiCtrlBase Properties */
TAiFeatures       BDAQCALL TAiCtrlBase_getFeatures(TAiCtrlBase obj)                                                  { return obj->getFeatures();            }
TArray            BDAQCALL TAiCtrlBase_getChannels(TAiCtrlBase obj)                                                  { return (TArray)obj->getChannels();    }
int32             BDAQCALL TAiCtrlBase_getChannelCount(TAiCtrlBase obj)                                              { return obj->getChannelCount();        }
ErrorCode         BDAQCALL TAiCtrlBase_runSensorCalibration(TAiCtrlBase obj, int32 ch, CalibrationData const *data)  { return obj->runSensorCalibration(ch, data); }
// ----------------------------------------------------------
// InstantAiCtrl
// ----------------------------------------------------------
/* InstantAiCtrl Methods */
ErrorCode         BDAQCALL TInstantAiCtrl_ReadAny(TInstantAiCtrl obj, int32 chStart, int32 chCount, void *dataRaw, double *dataScaled) { return obj->ReadAny(chStart, chCount, dataRaw, dataScaled); }

/* InstantAiCtrl Properties */
TCjcSetting       BDAQCALL TInstantAiCtrl_getCjc(TInstantAiCtrl obj)                                 { return obj->getCjc();                          }
double            BDAQCALL TInstantAiCtrl_getAutoConvertClockRate(TInstantAiCtrl obj)                { return obj->getAutoConvertClockRate();         }
ErrorCode         BDAQCALL TInstantAiCtrl_setAutoConvertClockRate(TInstantAiCtrl obj, double value)  { return obj->setAutoConvertClockRate(value);    }
int32             BDAQCALL TInstantAiCtrl_getAutoConvertChannelStart(TInstantAiCtrl obj)             { return obj->getAutoConvertChannelStart();      }
ErrorCode         BDAQCALL TInstantAiCtrl_setAutoConvertChannelStart(TInstantAiCtrl obj, int32 value){ return obj->setAutoConvertChannelStart(value); }
int32             BDAQCALL TInstantAiCtrl_getAutoConvertChannelCount(TInstantAiCtrl obj)             { return obj->getAutoConvertChannelCount();      }
ErrorCode         BDAQCALL TInstantAiCtrl_setAutoConvertChannelCount(TInstantAiCtrl obj, int32 value){ return obj->setAutoConvertChannelCount(value); }

// ----------------------------------------------------------
// BufferedAiCtrl
// ----------------------------------------------------------
/* BufferedAiCtrl methods */
ErrorCode         BDAQCALL TBufferedAiCtrl_Prepare(TBufferedAiCtrl obj)                                         { return obj->Prepare();                       }
ErrorCode         BDAQCALL TBufferedAiCtrl_RunOnce(TBufferedAiCtrl obj)                                         { return obj->RunOnce();                       }
ErrorCode         BDAQCALL TBufferedAiCtrl_Start(TBufferedAiCtrl obj)                                           { return obj->Start();                         }
ErrorCode         BDAQCALL TBufferedAiCtrl_Stop(TBufferedAiCtrl obj)                                            { return obj->Stop();                          }
void              BDAQCALL TBufferedAiCtrl_Release(TBufferedAiCtrl obj)                                         {        obj->Release();                       }
int8              BDAQCALL TBufferedAiCtrl_GetBufferStatus(TBufferedAiCtrl obj, int32 *count, int32 *offset)    { return obj->GetBufferStatus(*count, *offset);}
ErrorCode         BDAQCALL TBufferedAiCtrl_GetData(TBufferedAiCtrl obj, int32 dt, int32 count, void *buffer)    { return obj->GetData(dt, count, buffer);      }

/* BufferedAiCtrl properties */
void*             BDAQCALL TBufferedAiCtrl_getBuffer(TBufferedAiCtrl obj)                                       { return obj->getBuffer();                     }
int32             BDAQCALL TBufferedAiCtrl_getBufferCapacity(TBufferedAiCtrl obj)                               { return obj->getBufferCapacity();             }
TScanChannel      BDAQCALL TBufferedAiCtrl_getScanChannel(TBufferedAiCtrl obj)                                  { return obj->getScanChannel();                }
TConvertClock     BDAQCALL TBufferedAiCtrl_getConvertClock(TBufferedAiCtrl obj)                                 { return obj->getConvertClock();               }
TScanClock        BDAQCALL TBufferedAiCtrl_getScanClock(TBufferedAiCtrl obj)                                    { return obj->getScanClock();                  }
TTrigger          BDAQCALL TBufferedAiCtrl_getTrigger(TBufferedAiCtrl obj, int32 trigger)                       { return obj->getTrigger(trigger);             }
int8              BDAQCALL TBufferedAiCtrl_getStreaming(TBufferedAiCtrl obj)                                    { return obj->getStreaming();                  }
ErrorCode         BDAQCALL TBufferedAiCtrl_setStreaming(TBufferedAiCtrl obj, int8 value)                        { return obj->setStreaming(!!value);           }

// ----------------------------------------------------------
// WaveformAiCtrl
// ----------------------------------------------------------
/* WaveformAiCtrl methods */
ErrorCode         BDAQCALL TWaveformAiCtrl_Prepare(TWaveformAiCtrl obj)                                      { return obj->Prepare();                       }
ErrorCode         BDAQCALL TWaveformAiCtrl_Start(TWaveformAiCtrl obj)                                        { return obj->Start();                         }
ErrorCode         BDAQCALL TWaveformAiCtrl_Stop(TWaveformAiCtrl obj)                                         { return obj->Stop();                          }
void              BDAQCALL TWaveformAiCtrl_Release(TWaveformAiCtrl obj)                                      {        obj->Release();                       }
int8              BDAQCALL TWaveformAiCtrl_GetBufferStatus(TWaveformAiCtrl obj, int32 *count, int32 *offset) { return obj->GetBufferStatus(*count, *offset);}

ErrorCode BDAQCALL TWaveformAiCtrl_GetData(TWaveformAiCtrl obj, int32 dt, int32 count, void *buffer, 
   int32 timeout, int32 *returned, double * startTime, int32 *markCount, DataMark *markBuf)
{ 
   return obj->GetData(dt, count, buffer, timeout, returned, startTime, markCount, markBuf);      
}

/* WaveformAiCtrl properties */
void*             BDAQCALL TWaveformAiCtrl_getBuffer(TWaveformAiCtrl obj)                                    { return obj->getBuffer();                     }
int32             BDAQCALL TWaveformAiCtrl_getBufferCapacity(TWaveformAiCtrl obj)                            { return obj->getBufferCapacity();             }
TConversion       BDAQCALL TWaveformAiCtrl_getConversion(TWaveformAiCtrl obj)                                { return obj->getConversion();                 }
TRecord           BDAQCALL TWaveformAiCtrl_getRecord(TWaveformAiCtrl obj)                                    { return obj->getRecord();                     }
TTrigger          BDAQCALL TWaveformAiCtrl_getTrigger(TWaveformAiCtrl obj, int32 trigger)                    { return obj->getTrigger(trigger);             }

// **********************************************************
// ctrl class : AO related
// ----------------------------------------------------------
// AoChannel
// ----------------------------------------------------------
int32             BDAQCALL TAoChannel_getChannel(TAoChannel obj)                      { return obj->getChannel();            }
ValueRange        BDAQCALL TAoChannel_getValueRange(TAoChannel obj)                   { return obj->getValueRange();         }
ErrorCode         BDAQCALL TAoChannel_setValueRange(TAoChannel obj, ValueRange value) { return obj->setValueRange(value);    }
double            BDAQCALL TAoChannel_getExtRefBipolar(TAoChannel obj)                { return obj->getExtRefBipolar();      }
ErrorCode         BDAQCALL TAoChannel_setExtRefBipolar(TAoChannel obj, double value)  { return obj->setExtRefBipolar(value); }
double            BDAQCALL TAoChannel_getExtRefUnipolar(TAoChannel obj)               { return obj->getExtRefUnipolar();     }
ErrorCode         BDAQCALL TAoChannel_setExtRefUnipolar(TAoChannel obj, double value) { return obj->setExtRefUnipolar(value);}
// new: scale table
ErrorCode         BDAQCALL TAoChannel_getScaleTable(TAoChannel obj, int32 *size, MapFuncPiece table[]) { return obj->getScaleTable(*size, table); } 
ErrorCode         BDAQCALL TAoChannel_setScaleTable(TAoChannel obj, int32  size, MapFuncPiece table[]) { return obj->setScaleTable(size,  table); } 

// ----------------------------------------------------------
// AO features
// ----------------------------------------------------------
// DAC features                                                               
int32             BDAQCALL TAoFeatures_getResolution(TAoFeatures obj)                         { return obj->getResolution(); }
int32             BDAQCALL TAoFeatures_getDataSize(TAoFeatures obj)                           { return obj->getDataSize();   }
int32             BDAQCALL TAoFeatures_getDataMask(TAoFeatures obj)                           { return obj->getDataMask();   }
                                                                                                
// channel features                                                           
int32             BDAQCALL TAoFeatures_getChannelCountMax(TAoFeatures obj)                    { return obj->getChannelCountMax();      }
TArray            BDAQCALL TAoFeatures_getValueRanges(TAoFeatures obj)                        { return (TArray)obj->getValueRanges();  }
int8              BDAQCALL TAoFeatures_getExternalRefAntiPolar(TAoFeatures obj)               { return obj->getExternalRefAntiPolar(); }
void              BDAQCALL TAoFeatures_getExternalRefRange(TAoFeatures obj, MathInterval *x)  { obj->getExternalRefRange(*x);          }

// buffered ao->basic features                                                
int8              BDAQCALL TAoFeatures_getBufferedAoSupported(TAoFeatures obj)                { return obj->getBufferedAoSupported(); }
SamplingMethod    BDAQCALL TAoFeatures_getSamplingMethod(TAoFeatures obj)                     { return obj->getSamplingMethod();      }
int32             BDAQCALL TAoFeatures_getChannelStartBase(TAoFeatures obj)                   { return obj->getChannelStartBase();    }
int32             BDAQCALL TAoFeatures_getChannelCountBase(TAoFeatures obj)                   { return obj->getChannelCountBase();    }

// buffered ao->conversion clock features                                     
TArray            BDAQCALL TAoFeatures_getConvertClockSources(TAoFeatures obj)                { return (TArray)obj->getConvertClockSources(); }
void              BDAQCALL TAoFeatures_getConvertClockRange(TAoFeatures obj, MathInterval *x) { obj->getConvertClockRange(*x);                }
                  
// buffered ao->trigger features                                              
int32             BDAQCALL TAoFeatures_getTriggerCount(TAoFeatures obj)                       { return obj->getTriggerCount(); }
int8              BDAQCALL TAoFeatures_getRetriggerable(TAoFeatures obj)                      { return obj->getRetriggerable(); }

// buffered ao->trigger0/1/.../x features  
TArray            BDAQCALL TAoFeatures_getTriggerSources(TAoFeatures obj, int32 trigger)                     { return (TArray)obj->getTriggerSources(trigger); }
TArray            BDAQCALL TAoFeatures_getTriggerActions(TAoFeatures obj, int32 trigger)                     { return (TArray)obj->getTriggerActions(trigger); }
void              BDAQCALL TAoFeatures_getTriggerDelayRange(TAoFeatures obj, int32 trigger, MathInterval *x) { obj->getTriggerDelayRange(trigger, *x);         }

// ----------------------------------------------------------
// AoCtrlBase
// ----------------------------------------------------------
/* AoCtrlBase Methods*/

/* AoCtrlBase Properties*/
TAoFeatures       BDAQCALL TAoCtrlBase_getFeatures(TAoCtrlBase obj)                            { return (TAoFeatures)obj->getFeatures();       }
TArray            BDAQCALL TAoCtrlBase_getChannels(TAoCtrlBase obj)                            { return (TArray)obj->getChannels();            }
int32             BDAQCALL TAoCtrlBase_getChannelCount(TAoCtrlBase obj)                        { return obj->getChannelCount();                }
double            BDAQCALL TAoCtrlBase_getExtRefValueForUnipolar(TAoCtrlBase obj)              { return obj->getExtRefValueForUnipolar();      }
ErrorCode         BDAQCALL TAoCtrlBase_setExtRefValueForUnipolar(TAoCtrlBase obj, double value){ return obj->setExtRefValueForUnipolar(value); }
double            BDAQCALL TAoCtrlBase_getExtRefValueForBipolar(TAoCtrlBase obj)               { return obj->getExtRefValueForBipolar();       }
ErrorCode         BDAQCALL TAoCtrlBase_setExtRefValueForBipolar(TAoCtrlBase obj, double value) { return obj->setExtRefValueForBipolar(value);  }

// ----------------------------------------------------------
// InstantAoCtrl
// ----------------------------------------------------------
/* InstantAoCtrl methods */
ErrorCode         BDAQCALL TInstantAoCtrl_WriteAny(TInstantAoCtrl obj, int32 chStart, int32 chCount, void *dataRaw, double *dataScaled) { return obj->WriteAny(chStart, chCount, dataRaw, dataScaled); }

// ----------------------------------------------------------
// BufferedAoCtrl
// ----------------------------------------------------------
/* BufferedAoCtrl methods */
ErrorCode         BDAQCALL TBufferedAoCtrl_Prepare(TBufferedAoCtrl obj)                                      { return obj->Prepare();                        }
ErrorCode         BDAQCALL TBufferedAoCtrl_RunOnce(TBufferedAoCtrl obj)                                      { return obj->RunOnce();                        }
ErrorCode         BDAQCALL TBufferedAoCtrl_Start(TBufferedAoCtrl obj)                                        { return obj->Start();                          }
ErrorCode         BDAQCALL TBufferedAoCtrl_Stop(TBufferedAoCtrl obj, int32 action)                           { return obj->Stop(action);                     }
void              BDAQCALL TBufferedAoCtrl_Release(TBufferedAoCtrl obj)                                      {        obj->Release();                        }
int8              BDAQCALL TBufferedAoCtrl_GetBufferStatus(TBufferedAoCtrl obj, int32 *count, int32 *offset) { return obj->GetBufferStatus(*count, *offset); }
ErrorCode         BDAQCALL TBufferedAoCtrl_SetData(TBufferedAoCtrl obj, int32 dt, int32 count, void *buffer) { return obj->SetData(dt, count, buffer);       }

/* BufferedAoCtrl properties */
void*             BDAQCALL TBufferedAoCtrl_getBuffer(TBufferedAoCtrl obj)                                    { return obj->getBuffer();                      }
int32             BDAQCALL TBufferedAoCtrl_getBufferCapacity(TBufferedAoCtrl obj)                            { return obj->getBufferCapacity();              }
TScanChannel      BDAQCALL TBufferedAoCtrl_getScanChannel(TBufferedAoCtrl obj)                               { return (TScanChannel)obj->getScanChannel();   }
TConvertClock     BDAQCALL TBufferedAoCtrl_getConvertClock(TBufferedAoCtrl obj)                              { return (TConvertClock)obj->getConvertClock(); }
TTrigger          BDAQCALL TBufferedAoCtrl_getTrigger(TBufferedAoCtrl obj, int32 trigger)                    { return (TTrigger)obj->getTrigger(trigger);    }
int8              BDAQCALL TBufferedAoCtrl_getStreaming(TBufferedAoCtrl obj)                                 { return obj->getStreaming();                   }
ErrorCode         BDAQCALL TBufferedAoCtrl_setStreaming(TBufferedAoCtrl obj, int8 value)                     { return obj->setStreaming(!!value);            }

// **********************************************************
// ctrl class : DIO related classes
// ----------------------------------------------------------
// DioPort
// ----------------------------------------------------------
int32             BDAQCALL TDioPort_getPort(TDioPort obj)                       { return obj->getPort();                }
DioPortDir        BDAQCALL TDioPort_getDirection(TDioPort obj)                  { return obj->getDirection();           }
ErrorCode         BDAQCALL TDioPort_setDirection(TDioPort obj, DioPortDir value){ return obj->setDirection(value);      }
// DI port property 
uint8             BDAQCALL TDioPort_getDiInversePort(TDioPort obj)              { return obj->getDiInversePort();       }
ErrorCode         BDAQCALL TDioPort_setDiInversePort(TDioPort obj, uint8 value) { return obj->setDiInversePort(value);  }
uint8             BDAQCALL TDioPort_getDiOpenState(TDioPort obj)                { return obj->getDiOpenState();       }
ErrorCode         BDAQCALL TDioPort_setDiOpenState(TDioPort obj, uint8 value)   { return obj->setDiOpenState(value);  }
// DO port property
uint8             BDAQCALL TDioPort_getDoPresetValue(TDioPort obj)              { return obj->getDoPresetValue();       }
ErrorCode         BDAQCALL TDioPort_setDoPresetValue(TDioPort obj, uint8 value) { return obj->setDoPresetValue(value);  }
DoCircuitType     BDAQCALL TDioPort_getDoCircuitType(TDioPort obj)              { return obj->getDoCircuitType();       }                  
ErrorCode         BDAQCALL TDioPort_setDoCircuitType(TDioPort obj, DoCircuitType value) { return obj->setDoCircuitType(value);  }

// ----------------------------------------------------------
// DiintChannel
// ----------------------------------------------------------
int32             BDAQCALL TDiintChannel_getChannel(TDiintChannel obj)                     { return obj->getChannel();       }
int8              BDAQCALL TDiintChannel_getEnabled(TDiintChannel obj)                     { return obj->getEnabled();       }
ErrorCode         BDAQCALL TDiintChannel_setEnabled(TDiintChannel obj, int8 value)         { return obj->setEnabled(!!value);}
int8              BDAQCALL TDiintChannel_getGated(TDiintChannel obj)                       { return obj->getGated();         }
ErrorCode         BDAQCALL TDiintChannel_setGated(TDiintChannel obj, int8 value)           { return obj->setGated(!!value);  }
ActiveSignal      BDAQCALL TDiintChannel_getTrigEdge(TDiintChannel obj)                    { return obj->getTrigEdge();      }
ErrorCode         BDAQCALL TDiintChannel_setTrigEdge(TDiintChannel obj, ActiveSignal value){ return obj->setTrigEdge(value); }
                  
// ----------------------------------------------------------
// DiCosintPort
// ----------------------------------------------------------
int32             BDAQCALL TDiCosintPort_getPort(TDiCosintPort obj)              { return obj->getPort();      }
uint8             BDAQCALL TDiCosintPort_getMask(TDiCosintPort obj)              { return obj->getMask();      }
ErrorCode         BDAQCALL TDiCosintPort_setMask(TDiCosintPort obj, uint8 value) { return obj->setMask(value); }

// ----------------------------------------------------------
// DiPmintPort
// ----------------------------------------------------------
int32             BDAQCALL TDiPmintPort_getPort(TDiPmintPort obj)                 { return obj->getPort();        }
uint8             BDAQCALL TDiPmintPort_getMask(TDiPmintPort obj)                 { return obj->getMask();        }
ErrorCode         BDAQCALL TDiPmintPort_setMask(TDiPmintPort obj, uint8 value)    { return obj->setMask(value);   }
uint8             BDAQCALL TDiPmintPort_getPattern(TDiPmintPort obj)              { return obj->getPattern();     }
ErrorCode         BDAQCALL TDiPmintPort_setPattern(TDiPmintPort obj, uint8 value) { return obj->setPattern(value);}

// ----------------------------------------------------------
// DIO features
// ----------------------------------------------------------
// Common
int8              BDAQCALL TDioFeatures_getPortProgrammable(TDioFeatures obj) { return obj->getPortProgrammable(); }
int32             BDAQCALL TDioFeatures_getChannelCountMax(TDioFeatures obj)  { return obj->getChannelCountMax();  }
int32             BDAQCALL TDioFeatures_getPortCount(TDioFeatures obj)        { return obj->getPortCount();        }
TArray            BDAQCALL TDioFeatures_getPortsType(TDioFeatures obj)        { return (TArray)obj->getPortsType();}
int8              BDAQCALL TDioFeatures_getDiSupported(TDioFeatures obj)      { return obj->getDiSupported();      }
int8              BDAQCALL TDioFeatures_getDoSupported(TDioFeatures obj)      { return obj->getDoSupported();      }

//Buffered DI / Buffered DO 
int8              BDAQCALL TDioFeatures_getBufferedDiSupported(TDioFeatures obj)                            { return obj->getBufferedDiSupported(); }
int8              BDAQCALL TDioFeatures_getBufferedDoSupported(TDioFeatures obj)                            { return obj->getBufferedDoSupported(); }
int32             BDAQCALL TDioFeatures_getDataSize(TDioFeatures obj)                                       { return obj->getDataSize();            }
int32             BDAQCALL TDioFeatures_getResolution(TDioFeatures obj)                                     { return obj->getResolution();          }

// DI Features
TArray            BDAQCALL TDioFeatures_getDiDataMask(TDioFeatures obj)       { return (TArray)obj->getDiDataMask(); }

// di noise filter features                                                            
int8              BDAQCALL TDioFeatures_getDiNoiseFilterSupported(TDioFeatures obj)                       { return obj->getDiNoiseFilterSupported();         }
TArray            BDAQCALL TDioFeatures_getDiNoiseFilterOfChannels(TDioFeatures obj)                      { return (TArray)obj->getDiNoiseFilterOfChannels();}
void              BDAQCALL TDioFeatures_getDiNoiseFilterBlockTimeRange(TDioFeatures obj, MathInterval *x) { obj->getDiNoiseFilterBlockTimeRange(*x);         }

// di interrupt features                                                               
int8              BDAQCALL TDioFeatures_getDiintSupported(TDioFeatures obj)      { return obj->getDiintSupported();              }
int8              BDAQCALL TDioFeatures_getDiintGateSupported(TDioFeatures obj)  { return obj->getDiintGateSupported();          }
int8              BDAQCALL TDioFeatures_getDiCosintSupported(TDioFeatures obj)   { return obj->getDiCosintSupported();           }
int8              BDAQCALL TDioFeatures_getDiPmintSupported(TDioFeatures obj)    { return obj->getDiPmintSupported();            }
TArray            BDAQCALL TDioFeatures_getDiintTriggerEdges(TDioFeatures obj)   { return (TArray)obj->getDiintTriggerEdges();   }
TArray            BDAQCALL TDioFeatures_getDiintOfChannels(TDioFeatures obj)     { return (TArray)obj->getDiintOfChannels();     }
TArray            BDAQCALL TDioFeatures_getDiintGateOfChannels(TDioFeatures obj) { return (TArray)obj->getDiintGateOfChannels(); }
TArray            BDAQCALL TDioFeatures_getDiCosintOfPorts(TDioFeatures obj)     { return (TArray)obj->getDiCosintOfPorts();     }
TArray            BDAQCALL TDioFeatures_getDiPmintOfPorts(TDioFeatures obj)      { return (TArray)obj->getDiPmintOfPorts();      }
TArray            BDAQCALL TDioFeatures_getDiSnapEventSources(TDioFeatures obj)  { return (TArray)obj->getDiSnapEventSources();  }

// DO features
TArray            BDAQCALL TDioFeatures_getDoDataMask(TDioFeatures obj)                                     { return (TArray)obj->getDoDataMask();            }
TArray            BDAQCALL TDioFeatures_getDoFreezeSignalSources(TDioFeatures obj)                          { return (TArray)obj->getDoFreezeSignalSources(); }
void              BDAQCALL TDioFeatures_getDoReflectWdtFeedIntervalRange(TDioFeatures obj, MathInterval *x) { obj->getDoReflectWdtFeedIntervalRange(*x);      }
Depository        BDAQCALL TDioFeatures_getDoPresetValueDepository(TDioFeatures obj)                        { return obj->getDoPresetValueDepository();       }
TArray            BDAQCALL TDioFeatures_getDoCircuitSelectableTypes(TDioFeatures obj)                       { return (TArray)obj->getDoCircuitSelectableTypes(); }

// For compatible
TArray            BDAQCALL TDioFeatures_getDataMask(TDioFeatures obj)                                       { return (TArray)obj->getDataMask();              }

//Buffered DI Feature
SamplingMethod    BDAQCALL TDioFeatures_getDiSamplingMethod(TDioFeatures obj)                                 { return obj->getDiSamplingMethod();      }

// buffered di->conversion clock features
TArray            BDAQCALL TDioFeatures_getDiConvertClockSources(TDioFeatures obj)                    { return (TArray)obj->getDiConvertClockSources(); }
void              BDAQCALL TDioFeatures_getDiConvertClockRange(TDioFeatures obj, MathInterval *value) { obj->getDiConvertClockRange(*value);            }

// buffered di->trigger features
int8              BDAQCALL TDioFeatures_getDiRetriggerable(TDioFeatures obj)                                         { return obj->getDiRetriggerable(); }
int32             BDAQCALL TDioFeatures_getDiTriggerCount(TDioFeatures obj)                                          { return obj->getDiTriggerCount();  }

// buffered di->trigger0/1/.../x features
TArray            BDAQCALL TDioFeatures_getDiTriggerActions(TDioFeatures obj, int32 trigger)                         { return (TArray)obj->getDiTriggerActions(trigger);    }
void              BDAQCALL TDioFeatures_getDiTriggerDelayRange(TDioFeatures obj, int32 trigger, MathInterval *x)     {        obj->getDiTriggerDelayRange(trigger, *x);     }
TArray            BDAQCALL TDioFeatures_getDiTriggerSources(TDioFeatures obj, int32 trigger)                         { return (TArray)obj->getDiTriggerSources(trigger);    }
ValueRange        BDAQCALL TDioFeatures_getDiTriggerSourceVrg(TDioFeatures obj, int32 trigger)                       { return obj->getDiTriggerSourceVrg(trigger);          }
double            BDAQCALL TDioFeatures_getDiTriggerHysteresisIndexMax(TDioFeatures obj, int32 trigger)              { return obj->getDiTriggerHysteresisIndexMax(trigger); }
int32             BDAQCALL TDioFeatures_getDiTriggerHysteresisIndexStep(TDioFeatures obj, int32 trigger)             { return obj->getDiTriggerHysteresisIndexStep(trigger);}

//Buffered DO Feature
SamplingMethod    BDAQCALL TDioFeatures_getDoSamplingMethod(TDioFeatures obj)                                 { return obj->getDoSamplingMethod();      }

// buffered di->conversion clock features
TArray            BDAQCALL TDioFeatures_getDoConvertClockSources(TDioFeatures obj)                    { return (TArray)obj->getDoConvertClockSources(); }
void              BDAQCALL TDioFeatures_getDoConvertClockRange(TDioFeatures obj, MathInterval *value) { obj->getDoConvertClockRange(*value);            }

// buffered do->trigger features
int8              BDAQCALL TDioFeatures_getDoRetriggerable(TDioFeatures obj)                                         { return obj->getDoRetriggerable(); }
int32             BDAQCALL TDioFeatures_getDoTriggerCount(TDioFeatures obj)                                          { return obj->getDoTriggerCount();  }

// buffered do->trigger0/1/.../x features
TArray            BDAQCALL TDioFeatures_getDoTriggerActions(TDioFeatures obj, int32 trigger)                         { return (TArray)obj->getDoTriggerActions(trigger);    }
void              BDAQCALL TDioFeatures_getDoTriggerDelayRange(TDioFeatures obj, int32 trigger, MathInterval *x)     {        obj->getDoTriggerDelayRange(trigger, *x);     }
TArray            BDAQCALL TDioFeatures_getDoTriggerSources(TDioFeatures obj, int32 trigger)                         { return (TArray)obj->getDoTriggerSources(trigger);    }
ValueRange        BDAQCALL TDioFeatures_getDoTriggerSourceVrg(TDioFeatures obj, int32 trigger)                       { return obj->getDoTriggerSourceVrg(trigger);          }
double            BDAQCALL TDioFeatures_getDoTriggerHysteresisIndexMax(TDioFeatures obj, int32 trigger)              { return obj->getDoTriggerHysteresisIndexMax(trigger); }
int32             BDAQCALL TDioFeatures_getDoTriggerHysteresisIndexStep(TDioFeatures obj, int32 trigger)             { return obj->getDoTriggerHysteresisIndexStep(trigger);}
// ----------------------------------------------------------
// DioCtrlBase
// ----------------------------------------------------------
/* Methods derived from DioCtrlBase */
TDioFeatures      BDAQCALL TDioCtrlBase_getFeatures(TDioCtrlBase obj)  { return (TDioFeatures)obj->getFeatures(); }
int32             BDAQCALL TDioCtrlBase_getPortCount(TDioCtrlBase obj) { return obj->getPortCount();              }
TArray            BDAQCALL TDioCtrlBase_getPorts(TDioCtrlBase obj)     { return (TArray)obj->getPorts();          }

// ----------------------------------------------------------
// InstantDiCtrl
// ----------------------------------------------------------
/* Instant DI methods */
ErrorCode         BDAQCALL TInstantDiCtrl_ReadAny(TInstantDiCtrl obj, int32 portStart, int32 portCount, uint8 data[]) { return obj->ReadAny(portStart, portCount, data);}
ErrorCode         BDAQCALL TInstantDiCtrl_ReadBit(TInstantDiCtrl obj, int32 port, int32 bit, uint8* data)             { return obj->ReadBit(port, bit, data);           }
ErrorCode         BDAQCALL TInstantDiCtrl_SnapStart(TInstantDiCtrl obj)                                               { return obj->SnapStart();                        }
ErrorCode         BDAQCALL TInstantDiCtrl_SnapStop(TInstantDiCtrl obj)                                                { return obj->SnapStop();                         }

/* Instant DI properties */
double            BDAQCALL TInstantDiCtrl_getNoiseFilterBlockTime(TInstantDiCtrl obj)               { return obj->getNoiseFilterBlockTime();     }
ErrorCode         BDAQCALL TInstantDiCtrl_setNoiseFilterBlockTime(TInstantDiCtrl obj, double value) { return obj->setNoiseFilterBlockTime(value);}
TArray            BDAQCALL TInstantDiCtrl_getNoiseFilter(TInstantDiCtrl obj)                        { return (TArray)obj->getNoiseFilter();      }
TArray            BDAQCALL TInstantDiCtrl_getDiintChannels(TInstantDiCtrl obj)                      { return (TArray)obj->getDiintChannels();    }
TArray            BDAQCALL TInstantDiCtrl_getDiCosintPorts(TInstantDiCtrl obj)                      { return (TArray)obj->getDiCosintPorts();    }
TArray            BDAQCALL TInstantDiCtrl_getDiPmintPorts(TInstantDiCtrl obj)                       { return (TArray)obj->getDiPmintPorts();     }

// ----------------------------------------------------------
// InstantDoCtrl
// ----------------------------------------------------------
/* Instant DO methods */
ErrorCode         BDAQCALL TInstantDoCtrl_WriteAny(TInstantDoCtrl obj, int32 portStart, int32 portCount, uint8 data[]){ return obj->WriteAny(portStart, portCount, data); }
ErrorCode         BDAQCALL TInstantDoCtrl_ReadAny(TInstantDoCtrl obj, int32 portStart, int32 portCount, uint8 data[]) { return obj->ReadAny(portStart, portCount, data);  }
ErrorCode         BDAQCALL TInstantDoCtrl_WriteBit(TInstantDoCtrl obj, int32 port, int32 bit, uint8 data)             { return obj->WriteBit(port, bit, data);            }
ErrorCode         BDAQCALL TInstantDoCtrl_ReadBit(TInstantDoCtrl obj, int32 port, int32 bit, uint8* data)             { return obj->ReadBit(port, bit, data);             }


// ----------------------------------------------------------
// BufferedDiCtrl
// ----------------------------------------------------------
/* BufferedDiCtrl methods */
ErrorCode         BDAQCALL TBufferedDiCtrl_Prepare(TBufferedDiCtrl obj)                                      { return obj->Prepare();                       }
ErrorCode         BDAQCALL TBufferedDiCtrl_Start(TBufferedDiCtrl obj)                                        { return obj->Start();                         }
ErrorCode         BDAQCALL TBufferedDiCtrl_Stop(TBufferedDiCtrl obj)                                         { return obj->Stop();                          }
void              BDAQCALL TBufferedDiCtrl_Release(TBufferedDiCtrl obj)                                      {        obj->Release();                       }
int8              BDAQCALL TBufferedDiCtrl_GetBufferStatus(TBufferedDiCtrl obj, int32 *count, int32 *offset) { return obj->GetBufferStatus(*count, *offset);}

ErrorCode BDAQCALL TBufferedDiCtrl_GetData(TBufferedDiCtrl obj, int32 count, void *buffer, 
                                           int32 timeout, int32 *returned, double * startTime, int32 *markCount, DataMark *markBuf)
{ 
   return obj->GetData(count, buffer, timeout, returned, startTime, markCount, markBuf);      
}

/* BufferedDiCtrl properties */
void*             BDAQCALL TBufferedDiCtrl_getBuffer(TBufferedDiCtrl obj)                                    { return obj->getBuffer();                     }
int32             BDAQCALL TBufferedDiCtrl_getBufferCapacity(TBufferedDiCtrl obj)                            { return obj->getBufferCapacity();             }
TScanPort         BDAQCALL TBufferedDiCtrl_getScanPort(TBufferedDiCtrl obj)                                  { return (TScanPort)obj->getScanPort();        }
TConvertClock     BDAQCALL TBufferedDiCtrl_getConvertClock(TBufferedDiCtrl obj)                              { return (TConvertClock)obj->getConvertClock();}
TTrigger          BDAQCALL TBufferedDiCtrl_getTrigger(TBufferedDiCtrl obj, int32 trigger)                    { return (TTrigger)obj->getTrigger(trigger);   }
// ----------------------------------------------------------
// BufferedDoCtrl
// ----------------------------------------------------------
/* BufferedDoCtrl methods */
ErrorCode         BDAQCALL TBufferedDoCtrl_Prepare(TBufferedDoCtrl obj)                                      { return obj->Prepare();                        }
ErrorCode         BDAQCALL TBufferedDoCtrl_RunOnce(TBufferedDoCtrl obj)                                      { return obj->RunOnce();                        }
ErrorCode         BDAQCALL TBufferedDoCtrl_Start(TBufferedDoCtrl obj)                                        { return obj->Start();                          }
ErrorCode         BDAQCALL TBufferedDoCtrl_Stop(TBufferedDoCtrl obj, int32 action)                           { return obj->Stop(action);                     }
void              BDAQCALL TBufferedDoCtrl_Release(TBufferedDoCtrl obj)                                      {        obj->Release();                        }
int8              BDAQCALL TBufferedDoCtrl_GetBufferStatus(TBufferedDoCtrl obj, int32 *count, int32 *offset) { return obj->GetBufferStatus(*count, *offset); }
ErrorCode         BDAQCALL TBufferedDoCtrl_SetData(TBufferedDoCtrl obj, int32 count, void *buffer)           { return obj->SetData(count, buffer);           }

/* BufferedDoCtrl properties */
void*             BDAQCALL TBufferedDoCtrl_getBuffer(TBufferedDoCtrl obj)                                    { return obj->getBuffer();                      }
int32             BDAQCALL TBufferedDoCtrl_getBufferCapacity(TBufferedDoCtrl obj)                            { return obj->getBufferCapacity();              }
TScanPort         BDAQCALL TBufferedDoCtrl_getScanPort(TBufferedDoCtrl obj)                                  { return (TScanPort)obj->getScanPort();         }
TConvertClock     BDAQCALL TBufferedDoCtrl_getConvertClock(TBufferedDoCtrl obj)                              { return (TConvertClock)obj->getConvertClock(); }
TTrigger          BDAQCALL TBufferedDoCtrl_getTrigger(TBufferedDoCtrl obj, int32 trigger)                    { return (TTrigger)obj->getTrigger(trigger);    }


// ----------------------------------------------------------
// common classes : ScanPort
// ----------------------------------------------------------
int32             BDAQCALL TScanPort_getPortStart(TScanPort obj)                             { return obj->getPortStart();             }
ErrorCode         BDAQCALL TScanPort_setPortStart(TScanPort obj, int32 value)                { return obj->setPortStart(value);        }
int32             BDAQCALL TScanPort_getPortCount(TScanPort obj)                             { return obj->getPortCount();             }
ErrorCode         BDAQCALL TScanPort_setPortCount(TScanPort obj, int32 value)                { return obj->setPortCount(value);        }
void              BDAQCALL TScanPort_getPortMap(TScanPort obj, int32 count, int8 *portMap)   { return obj->getPortMap(count, portMap); } 
ErrorCode         BDAQCALL TScanPort_setPortMap(TScanPort obj, int32 count, int8 *portMap)   { return obj->setPortMap(count, portMap); } 
int32             BDAQCALL TScanPort_getSectionLength(TScanPort  obj)                        { return obj->getSectionLength();         }
ErrorCode         BDAQCALL TScanPort_setSectionLength(TScanPort obj, int32 value)            { return obj->setSectionLength(value);    }
int32             BDAQCALL TScanPort_getSectionCount(TScanPort obj)                          { return obj->getSectionCount();          }
ErrorCode         BDAQCALL TScanPort_setSectionCount(TScanPort obj, int32 value)             { return obj->setSectionCount(value);     }
int32             BDAQCALL TScanPort_getCycles(TScanPort obj)                                { return obj->getCycles();                }
ErrorCode         BDAQCALL TScanPort_setCycles(TScanPort obj, int32 value)                   { return obj->setCycles(value);           }

// **********************************************************
// ctrl class : Counter related
// ----------------------------------------------------------
// Counter Indexer
// ----------------------------------------------------------
void              BDAQCALL TCounterIndexer_Dispose(TCounterIndexer obj)                { obj->Dispose();                       }
int32             BDAQCALL TCounterIndexer_getLength(TCounterIndexer obj)              { return obj->getLength();              }
TArray            BDAQCALL TCounterIndexer_getItem(TCounterIndexer obj, int32 channel) { return (TArray)obj->getItem(channel); }

// ----------------------------------------------------------
// Counter features
// ----------------------------------------------------------
// Channel features
int32             BDAQCALL TCntrFeatures_getChannelCountMax(TCntrFeatures obj) { return obj->getChannelCountMax();            }
int32             BDAQCALL TCntrFeatures_getResolution(TCntrFeatures obj)      { return obj->getResolution();                 }
int32             BDAQCALL TCntrFeatures_getDataSize(TCntrFeatures obj)        { return obj->getDataSize();                   }
TCounterIndexer   BDAQCALL TCntrFeatures_getCapabilities(TCntrFeatures obj)    { return (TCounterIndexer)obj->getCapabilities(); }

// noise filter features
int8              BDAQCALL TCntrFeatures_getNoiseFilterSupported(TCntrFeatures obj)                      { return obj->getNoiseFilterSupported();          }
TArray            BDAQCALL TCntrFeatures_getNoiseFilterOfChannels(TCntrFeatures obj)                     { return (TArray)obj->getNoiseFilterOfChannels(); }
void              BDAQCALL TCntrFeatures_getNoiseFilterBlockTimeRange(TCntrFeatures obj, MathInterval *x){ obj->getNoiseFilterBlockTimeRange(*x);          } 
          
// new: measurement timeout range
void              BDAQCALL TCntrFeatures_getMeasurementTimeoutRange(TCntrFeatures obj, MathInterval *x){ obj->getMeasurementTimeoutRange(*x); }

// event counting features
TCounterIndexer   BDAQCALL TCntrFeatures_getEcClockSources(TCntrFeatures obj)                    { return (TCounterIndexer)obj->getEcClockSources(); } 
TArray            BDAQCALL TCntrFeatures_getEcClockPolarities(TCntrFeatures obj)                 { return (TArray)obj->getEcClockPolarities();       }
TArray            BDAQCALL TCntrFeatures_getEcGatePolarities(TCntrFeatures obj)                  { return (TArray)obj->getEcGatePolarities();        }
TArray            BDAQCALL TCntrFeatures_getEcGateControlOfChannels(TCntrFeatures obj)           { return (TArray)obj->getEcGateControlOfChannels(); }
                  
// frequency measurement features
TArray            BDAQCALL TCntrFeatures_getFmMethods(TCntrFeatures obj)                         { return (TArray)obj->getFmMethods(); }

// one-shot features
TCounterIndexer   BDAQCALL TCntrFeatures_getOsClockSources(TCntrFeatures obj)                    { return (TCounterIndexer)obj->getOsClockSources();}
TArray            BDAQCALL TCntrFeatures_getOsClockPolarities(TCntrFeatures obj)                 { return (TArray)obj->getOsClockPolarities();   }
TCounterIndexer   BDAQCALL TCntrFeatures_getOsGateSources(TCntrFeatures obj)                     { return (TCounterIndexer)obj->getOsGateSources(); }
TArray            BDAQCALL TCntrFeatures_getOsGatePolarities(TCntrFeatures obj)                  { return (TArray)obj->getOsGatePolarities();    }
TArray            BDAQCALL TCntrFeatures_getOsOutSignals(TCntrFeatures obj)                      { return (TArray)obj->getOsOutSignals();        }
void              BDAQCALL TCntrFeatures_getOsDelayCountRange(TCntrFeatures obj, MathInterval *x){ obj->getOsDelayCountRange(*x);                }

// timer/pulse features
TArray            BDAQCALL TCntrFeatures_getTmrGateControlOfChannels(TCntrFeatures obj)          { return (TArray)obj->getTmrGateControlOfChannels();}
TArray            BDAQCALL TCntrFeatures_getTmrGatePolarities(TCntrFeatures obj)                 { return (TArray)obj->getTmrGatePolarities();       }
TArray            BDAQCALL TCntrFeatures_getTmrOutSignals(TCntrFeatures obj)                     { return (TArray)obj->getTmrOutSignals();           }
void              BDAQCALL TCntrFeatures_getTmrFrequencyRange(TCntrFeatures obj, MathInterval *x){ obj->getTmrFrequencyRange(*x);                    }
                  
// pulse width measurement features
TArray            BDAQCALL TCntrFeatures_getPiCascadeGroup(TCntrFeatures obj)                   { return (TArray)obj->getPiCascadeGroup(); }

// pulse width modulation features
TArray            BDAQCALL TCntrFeatures_getPoGateControlOfChannels(TCntrFeatures obj)          { return (TArray)obj->getPoGateControlOfChannels();}
TArray            BDAQCALL TCntrFeatures_getPoGatePolarities(TCntrFeatures obj)                 { return (TArray)obj->getPoGatePolarities();       }
TArray            BDAQCALL TCntrFeatures_getPoOutSignals(TCntrFeatures obj)                     { return (TArray)obj->getPoOutSignals();           }
void              BDAQCALL TCntrFeatures_getPoHiPeriodRange(TCntrFeatures obj, MathInterval *x) { obj->getPoHiPeriodRange(*x);                     } 
void              BDAQCALL TCntrFeatures_getPoLoPeriodRange(TCntrFeatures obj, MathInterval *x) { obj->getPoLoPeriodRange(*x);                     } 
void              BDAQCALL TCntrFeatures_getPoOutCountRange(TCntrFeatures obj, MathInterval *x) { obj->getPoOutCountRange(*x);                     }

// new: trigger features for pulse width modulation
int32             BDAQCALL TCntrFeatures_getPoTriggerCount(TCntrFeatures obj)                      { return obj->getPoTriggerCount();             }
TArray            BDAQCALL TCntrFeatures_getPoTriggerSources(TCntrFeatures obj)                    { return (TArray)obj->getPoTriggerSources();   }
TArray            BDAQCALL TCntrFeatures_getPoTriggerActions(TCntrFeatures obj)                    { return (TArray)obj->getPoTriggerActions();   }
void              BDAQCALL TCntrFeatures_getPoTriggerDelayRange(TCntrFeatures obj, MathInterval *x){ obj->getPoTriggerDelayRange(*x);             } 

// up-down counter features
TArray            BDAQCALL TCntrFeatures_getUdCountingTypes(TCntrFeatures obj)                   { return (TArray)obj->getUdCountingTypes();   }
TArray            BDAQCALL TCntrFeatures_getUdInitialValues(TCntrFeatures obj)                   { return (TArray)obj->getUdInitialValues();   }
TArray            BDAQCALL TCntrFeatures_getUdSnapEventSources(TCntrFeatures obj)                { return (TArray)obj->getUdSnapEventSources();}
void              BDAQCALL TCntrFeatures_getUdValueResetTimes(TCntrFeatures obj, MathInterval *x){ obj->getUdValueResetTimes(*x);       }

// new features for Counter continue comparing: outputting pulse settings
TArray            BDAQCALL TCntrFeatures_getCcpGateControlOfChannels(TCntrFeatures obj)          { return (TArray)obj->getCcpGateControlOfChannels();}
TArray            BDAQCALL TCntrFeatures_getCcpGatePolarities(TCntrFeatures obj)                 { return (TArray)obj->getCcpGatePolarities();       }
TArray            BDAQCALL TCntrFeatures_getCcpOutSignals(TCntrFeatures obj)                     { return (TArray)obj->getCcpOutSignals();           }
void              BDAQCALL TCntrFeatures_getCcpHiPeriodRange(TCntrFeatures obj, MathInterval *x) { obj->getCcpHiPeriodRange(*x);                     } 
void              BDAQCALL TCntrFeatures_getCcpLoPeriodRange(TCntrFeatures obj, MathInterval *x) { obj->getCcpLoPeriodRange(*x);                     } 
void              BDAQCALL TCntrFeatures_getCcpOutCountRange(TCntrFeatures obj, MathInterval *x) { obj->getCcpOutCountRange(*x);                     }

// buffered counter features
int32             BDAQCALL TCntrFeatures_getTriggerCount        (TCntrFeatures obj)                   { return obj->getTriggerCount();                  }
TArray            BDAQCALL TCntrFeatures_getTriggerActions      (TCntrFeatures obj, int32 trigger)    { return (TArray)obj->getTriggerActions(trigger); }
TArray            BDAQCALL TCntrFeatures_getTriggerSources      (TCntrFeatures obj, int32 trigger)    { return (TArray)obj->getTriggerSources(trigger); }
TCounterIndexer   BDAQCALL TCntrFeatures_getEcSampleClockSources(TCntrFeatures obj)                   { return (TCounterIndexer)obj->getEcSampleClkSrcs(); }
TCounterIndexer   BDAQCALL TCntrFeatures_getPiSampleClockSources(TCntrFeatures obj)                   { return (TCounterIndexer)obj->getPiSampleClkSrcs(); }
TCounterIndexer   BDAQCALL TCntrFeatures_getPoSampleClockSources(TCntrFeatures obj)                   { return (TCounterIndexer)obj->getPoSampleClkSrcs(); }
TCounterIndexer   BDAQCALL TCntrFeatures_getUdSampleClockSources(TCntrFeatures obj)                   { return (TCounterIndexer)obj->getUdSampleClkSrcs(); }

// ----------------------------------------------------------
// CntrCtrlBase
// ----------------------------------------------------------
/* Methods */
TCntrFeatures     BDAQCALL TCntrCtrlBase_getFeatures(TCntrCtrlBase obj)                          { return (TCntrFeatures)obj->getFeatures();     }
int32             BDAQCALL TCntrCtrlBase_getChannelStart(TCntrCtrlBase obj)                      { return obj->getChannelStart();                }
ErrorCode         BDAQCALL TCntrCtrlBase_setChannelStart(TCntrCtrlBase obj, int32 value)         { return obj->setChannelStart(value);           }
int32             BDAQCALL TCntrCtrlBase_getChannelCount(TCntrCtrlBase obj)                      { return obj->getChannelCount();                }
ErrorCode         BDAQCALL TCntrCtrlBase_setChannelCount(TCntrCtrlBase obj, int32 value)         { return obj->setChannelCount(value);           }
int8              BDAQCALL TCntrCtrlBase_getEnabled(TCntrCtrlBase obj)                           { return obj->getEnabled();                     }
ErrorCode         BDAQCALL TCntrCtrlBase_setEnabled(TCntrCtrlBase obj, int8 enabled)             { return obj->setEnabled(!!enabled);            }
int8              BDAQCALL TCntrCtrlBase_getRunning(TCntrCtrlBase obj)                           { return obj->getRunning();                     }
double            BDAQCALL TCntrCtrlBase_getNoiseFilterBlockTime(TCntrCtrlBase obj)              { return obj->getNoiseFilterBlockTime();        }
ErrorCode         BDAQCALL TCntrCtrlBase_setNoiseFilterBlockTime(TCntrCtrlBase obj, double value){ return obj->setNoiseFilterBlockTime(value);   }
TNosFltChannel    BDAQCALL TCntrCtrlBase_getNoiseFilter(TCntrCtrlBase obj)                       { return (TNosFltChannel)obj->getNoiseFilter(); }
double            BDAQCALL TCntrCtrlBase_getMeasurementTimeout(TCntrCtrlBase obj)                { return obj->getMeasurementTimeout();          }
ErrorCode         BDAQCALL TCntrCtrlBase_setMeasurementTimeout(TCntrCtrlBase obj, double value)  { return obj->setMeasurementTimeout(value);     }

// ----------------------------------------------------------
// EcChannel
// ----------------------------------------------------------
int32             BDAQCALL TEcChannel_getChannel(TEcChannel obj)                                 { return obj->getChannel();                }
int8              BDAQCALL TEcChannel_getNoiseFiltered(TEcChannel obj)                           { return obj->getNoiseFiltered();          }
ErrorCode         BDAQCALL TEcChannel_setNoiseFiltered(TEcChannel obj, int8 value)               { return obj->setNoiseFiltered(!!value);   }
SignalDrop        BDAQCALL TEcChannel_getClockSource(TEcChannel obj)                             { return obj->getClockSource();            }
ErrorCode         BDAQCALL TEcChannel_setClockSource(TEcChannel obj, SignalDrop value)           { return obj->setClockSource(value);       }
SignalPolarity    BDAQCALL TEcChannel_getClockPolarity(TEcChannel obj)                           { return obj->getClockPolarity();          }
ErrorCode         BDAQCALL TEcChannel_setClockPolarity(TEcChannel obj, SignalPolarity value)     { return obj->setClockPolarity(value);     }
SignalPolarity    BDAQCALL TEcChannel_getGatePolarity(TEcChannel obj)                            { return obj->getGatePolarity();           }
ErrorCode         BDAQCALL TEcChannel_setGatePolarity(TEcChannel obj, SignalPolarity value)      { return obj->setGatePolarity(value);      }
int8              BDAQCALL TEcChannel_getGated(TEcChannel obj)                                   { return obj->getGated();                  }
ErrorCode         BDAQCALL TEcChannel_setGated(TEcChannel obj, int8 value)                       { return obj->setGated(!!value);           }
                  
// ----------------------------------------------------------
// EventCounterCtrl
// ----------------------------------------------------------
/* Event counter methods */
ErrorCode         BDAQCALL TEventCounterCtrl_Read(TEventCounterCtrl obj, int32 count, int32 *buffer) { return obj->Read(count, buffer);   }
TArray            BDAQCALL TEventCounterCtrl_getChannels(TEventCounterCtrl obj)                      { return (TArray)obj->getChannels(); }

// ----------------------------------------------------------
// FmChannel
// ----------------------------------------------------------
int32             BDAQCALL TFmChannel_getChannel(TFmChannel obj)                           { return obj->getChannel();              }
int8              BDAQCALL TFmChannel_getNoiseFiltered(TFmChannel obj)                     { return obj->getNoiseFiltered();        }
ErrorCode         BDAQCALL TFmChannel_setNoiseFiltered(TFmChannel obj, int8 value)         { return obj->setNoiseFiltered(!!value); }
FreqMeasureMethod BDAQCALL TFmChannel_getFmMethod(TFmChannel obj)                          { return obj->getFmMethod();             }
ErrorCode         BDAQCALL TFmChannel_setFmMethod(TFmChannel obj, FreqMeasureMethod value) { return obj->setFmMethod(value);        }
double            BDAQCALL TFmChannel_getCollectionPeriod(TFmChannel obj)                  { return obj->getCollectionPeriod();     }
ErrorCode         BDAQCALL TFmChannel_setCollectionPeriod(TFmChannel obj, double value)    { return obj->setCollectionPeriod(value);}

// ----------------------------------------------------------
// FreqMeterCtrl
// ----------------------------------------------------------
/* Frequency meter methods */
ErrorCode         BDAQCALL TFreqMeterCtrl_Read(TFreqMeterCtrl obj, int32 count, double *buffer) { return obj->Read(count, buffer);  }
TArray            BDAQCALL TFreqMeterCtrl_getChannels(TFreqMeterCtrl obj)                       { return (TArray)obj->getChannels();}

// ----------------------------------------------------------
// OsChannel
// ----------------------------------------------------------
int32             BDAQCALL TOsChannel_getChannel(TOsChannel obj)                            { return obj->getChannel();           }
int8              BDAQCALL TOsChannel_getNoiseFiltered(TOsChannel obj)                      { return obj->getNoiseFiltered();     }
ErrorCode         BDAQCALL TOsChannel_setNoiseFiltered(TOsChannel obj, int8 value)          { return obj->setNoiseFiltered(!!value);}
int32             BDAQCALL TOsChannel_getDelayCount(TOsChannel obj)                         { return obj->getDelayCount();        }
ErrorCode         BDAQCALL TOsChannel_setDelayCount(TOsChannel obj, int32 value)            { return obj->setDelayCount(value);   }
SignalDrop        BDAQCALL TOsChannel_getClockSource(TOsChannel obj)                        { return obj->getClockSource();       }
ErrorCode         BDAQCALL TOsChannel_setClockSource(TOsChannel obj, SignalDrop value)      { return obj->setClockSource(value);  }
SignalPolarity    BDAQCALL TOsChannel_getClockPolarity(TOsChannel obj)                      { return obj->getClockPolarity();     }
ErrorCode         BDAQCALL TOsChannel_setClockPolarity(TOsChannel obj, SignalPolarity value){ return obj->setClockPolarity(value);}
SignalDrop        BDAQCALL TOsChannel_getGateSource(TOsChannel obj)                         { return obj->getGateSource();        }
ErrorCode         BDAQCALL TOsChannel_setGateSource(TOsChannel obj, SignalDrop value)       { return obj->setGateSource(value);   }
SignalPolarity    BDAQCALL TOsChannel_getGatePolarity(TOsChannel obj)                       { return obj->getGatePolarity();      }
ErrorCode         BDAQCALL TOsChannel_setGatePolarity(TOsChannel obj, SignalPolarity value) { return obj->setGatePolarity(value); }
OutSignalType     BDAQCALL TOsChannel_getOutSignal(TOsChannel obj)                          { return obj->getOutSignal();         }
ErrorCode         BDAQCALL TOsChannel_setOutSignal(TOsChannel obj, OutSignalType value)     { return obj->setOutSignal(value);    }

// ----------------------------------------------------------
// OneShotCtrl
// ----------------------------------------------------------
/* one shot methods */
TArray            BDAQCALL TOneShotCtrl_getChannels(TOneShotCtrl obj)                       { return (TArray)obj->getChannels();  }

// ----------------------------------------------------------
// TmrChannel
// ----------------------------------------------------------
int32             BDAQCALL TTmrChannel_getChannel(TTmrChannel obj)                            { return obj->getChannel();            }
int8              BDAQCALL TTmrChannel_getNoiseFiltered(TTmrChannel obj)                      { return obj->getNoiseFiltered();      }
ErrorCode         BDAQCALL TTmrChannel_setNoiseFiltered(TTmrChannel obj, int8 value)          { return obj->setNoiseFiltered(!!value); }
double            BDAQCALL TTmrChannel_getFrequency(TTmrChannel obj)                          { return obj->getFrequency();          }
ErrorCode         BDAQCALL TTmrChannel_setFrequency(TTmrChannel obj, double value)            { return obj->setFrequency(value);     }
int8              BDAQCALL TTmrChannel_getGated(TTmrChannel obj)                              { return obj->getGated();              }
ErrorCode         BDAQCALL TTmrChannel_setGated(TTmrChannel obj, int8 value)                  { return obj->setGated(!!value);       }
SignalPolarity    BDAQCALL TTmrChannel_getGatePolarity(TTmrChannel obj)                       { return obj->getGatePolarity();       }
ErrorCode         BDAQCALL TTmrChannel_setGatePolarity(TTmrChannel obj, SignalPolarity value) { return obj->setGatePolarity(value);  }
OutSignalType     BDAQCALL TTmrChannel_getOutSignal(TTmrChannel obj)                          { return obj->getOutSignal();          }
ErrorCode         BDAQCALL TTmrChannel_setOutSignal(TTmrChannel obj, OutSignalType value)     { return obj->setOutSignal(value);     }
                  
// ----------------------------------------------------------
// TimerPulseCtrl
// ----------------------------------------------------------
/* Timer/Pulse methods */
TArray            BDAQCALL TTimerPulseCtrl_getChannels(TTimerPulseCtrl obj)             { return (TArray)obj->getChannels();   }

// ----------------------------------------------------------
// PiChannel
// ----------------------------------------------------------
int32             BDAQCALL TPiChannel_getChannel(TPiChannel obj)                        { return obj->getChannel();            }
int8              BDAQCALL TPiChannel_getNoiseFiltered(TPiChannel obj)                  { return obj->getNoiseFiltered();      }
ErrorCode         BDAQCALL TPiChannel_setNoiseFiltered(TPiChannel obj, int8 value)      { return obj->setNoiseFiltered(!!value); }

// ----------------------------------------------------------
// PwMeterCtrl
// ----------------------------------------------------------
/* PwMeterCtrl Method */
TArray            BDAQCALL TPwMeterCtrl_getChannels(TPwMeterCtrl obj)                            { return (TArray)obj->getChannels(); }
ErrorCode         BDAQCALL TPwMeterCtrl_Read(TPwMeterCtrl obj, int32 count, PulseWidth *buffer)  { return obj->Read(count, buffer);   }

// ----------------------------------------------------------
// PoChannel
// ----------------------------------------------------------
int32             BDAQCALL TPoChannel_getChannel(TPoChannel obj)                            { return obj->getChannel();           }
int8              BDAQCALL TPoChannel_getNoiseFiltered(TPoChannel obj)                      { return obj->getNoiseFiltered();     }
ErrorCode         BDAQCALL TPoChannel_setNoiseFiltered(TPoChannel obj, int8 value)          { return obj->setNoiseFiltered(!!value);}
void              BDAQCALL TPoChannel_getPulseWidth(TPoChannel obj, PulseWidth *x)          { obj->getPulseWidth(*x);             }
ErrorCode         BDAQCALL TPoChannel_setPulseWidth(TPoChannel obj, PulseWidth *x)          { return obj->setPulseWidth(*x);      }
int8              BDAQCALL TPoChannel_getGated(TPoChannel obj)                              { return obj->getGated();             }
ErrorCode         BDAQCALL TPoChannel_setGated(TPoChannel obj, int8 value)                  { return obj->setGated(!!value);      }
SignalPolarity    BDAQCALL TPoChannel_getGatePolarity(TPoChannel obj)                       { return obj->getGatePolarity();      }
ErrorCode         BDAQCALL TPoChannel_setGatePolarity(TPoChannel obj, SignalPolarity value) { return obj->setGatePolarity(value); }
OutSignalType     BDAQCALL TPoChannel_getOutSignal(TPoChannel obj)                          { return obj->getOutSignal();         }
ErrorCode         BDAQCALL TPoChannel_setOutSignal(TPoChannel obj, OutSignalType value)     { return obj->setOutSignal(value);    }
int32             BDAQCALL TPoChannel_getOutCount(TPoChannel obj)                           { return obj->getOutCount();          }
ErrorCode         BDAQCALL TPoChannel_setOutCount(TPoChannel obj, int32 value)              { return obj->setOutCount(value);     }

// new : trigger settings
SignalDrop        BDAQCALL TPoChannel_getTriggerSource(TPoChannel obj)                      { return obj->getTriggerSource();         }
ErrorCode         BDAQCALL TPoChannel_setTriggerSource(TPoChannel obj, SignalDrop value)    { return obj->setTriggerSource(value);    }
ActiveSignal      BDAQCALL TPoChannel_getTriggerEdge(TPoChannel obj)                        { return obj->getTriggerEdge();           }
ErrorCode         BDAQCALL TPoChannel_setTriggerEdge(TPoChannel obj, ActiveSignal value)    { return obj->setTriggerEdge(value);      }
TriggerAction     BDAQCALL TPoChannel_getTriggerAction(TPoChannel obj)                      { return obj->getTriggerAction();         }
ErrorCode         BDAQCALL TPoChannel_setTriggerAction(TPoChannel obj, TriggerAction value) { return obj->setTriggerAction(value);    }
double            BDAQCALL TPoChannel_getTriggerDelayCount(TPoChannel obj)                  { return obj->getTriggerDelayCount();     }
ErrorCode         BDAQCALL TPoChannel_setTriggerDelayCount(TPoChannel obj, double value)    { return obj->setTriggerDelayCount(value);}

// ----------------------------------------------------------
// PwModulatorCtrl
// ----------------------------------------------------------
/* Pulse width modulator methods */
TArray            BDAQCALL TPwModulatorCtrl_getChannels(TPwModulatorCtrl obj)               { return (TArray)obj->getChannels(); }

// ----------------------------------------------------------
// UdChannel
// ----------------------------------------------------------
int32             BDAQCALL TUdChannel_getChannel(TUdChannel obj)                            { return obj->getChannel();               }
int8              BDAQCALL TUdChannel_getNoiseFiltered(TUdChannel obj)                      { return obj->getNoiseFiltered();         }
ErrorCode         BDAQCALL TUdChannel_setNoiseFiltered(TUdChannel obj, int8 value)          { return obj->setNoiseFiltered(!!value);  }
CountingType      BDAQCALL TUdChannel_getCountingType(TUdChannel obj)                       { return obj->getCountingType();          }
ErrorCode         BDAQCALL TUdChannel_setCountingType(TUdChannel obj, CountingType value)   { return obj->setCountingType(value);     }
int32             BDAQCALL TUdChannel_getInitialValue(TUdChannel obj)                       { return obj->getInitialValue();          }
ErrorCode         BDAQCALL TUdChannel_setInitialValue(TUdChannel obj, int32 value)          { return obj->setInitialValue(value);     }
int32             BDAQCALL TUdChannel_getResetTimesByIndex(TUdChannel obj)                  { return obj->getResetTimesByIndex();     }
ErrorCode         BDAQCALL TUdChannel_setResetTimesByIndex(TUdChannel obj, int32 value)     { return obj->setResetTimesByIndex(value);}

void              BDAQCALL TUdChannel_getPulseWidth(TUdChannel obj, PulseWidth *x)          { obj->getPulseWidth(*x);             } 
ErrorCode         BDAQCALL TUdChannel_setPulseWidth(TUdChannel obj, PulseWidth *x)          { return obj->setPulseWidth(*x);      }
int8              BDAQCALL TUdChannel_getGated(TUdChannel obj)                              { return obj->getGated();             }
ErrorCode         BDAQCALL TUdChannel_setGated(TUdChannel obj, int8 value)                  { return obj->setGated(!!value);      }
SignalPolarity    BDAQCALL TUdChannel_getGatePolarity(TUdChannel obj)                       { return obj->getGatePolarity();      }
ErrorCode         BDAQCALL TUdChannel_setGatePolarity(TUdChannel obj, SignalPolarity value) { return obj->setGatePolarity(value); }
OutSignalType     BDAQCALL TUdChannel_getOutSignal(TUdChannel obj)                          { return obj->getOutSignal();         }
ErrorCode         BDAQCALL TUdChannel_setOutSignal(TUdChannel obj, OutSignalType value)     { return obj->setOutSignal(value);    }
int32             BDAQCALL TUdChannel_getOutCount(TUdChannel obj)                           { return obj->getOutCount();          }
ErrorCode         BDAQCALL TUdChannel_setOutCount(TUdChannel obj, int32 value)              { return obj->setOutCount(value);     }
                                                                                             
// ----------------------------------------------------------
// UdCounterCtrl
// ----------------------------------------------------------
/* UdCounterCtrl methods */
ErrorCode         BDAQCALL TUdCounterCtrl_SnapStart(TUdCounterCtrl obj, int32 srcId)                                                      { return obj->SnapStart(srcId);                                     }
ErrorCode         BDAQCALL TUdCounterCtrl_SnapStop(TUdCounterCtrl obj, int32 srcId)                                                       { return obj->SnapStop(srcId);                                      }
ErrorCode         BDAQCALL TUdCounterCtrl_CompareSetTable(TUdCounterCtrl obj, int32 channel, int32 count, int32 *table)                   { return obj->CompareSetTable(channel, count, table);               }
ErrorCode         BDAQCALL TUdCounterCtrl_CompareSetInterval(TUdCounterCtrl obj, int32 channel, int32 start, int32 increment,int32 count) { return obj->CompareSetInterval(channel, start, increment, count); }
ErrorCode         BDAQCALL TUdCounterCtrl_CompareClear(TUdCounterCtrl obj, int32 channel)                                                 { return obj->CompareClear(channel);                                }
ErrorCode         BDAQCALL TUdCounterCtrl_ValueReset(TUdCounterCtrl obj)                                                                  { return obj->ValueReset();                                         }
ErrorCode         BDAQCALL TUdCounterCtrl_Read(TUdCounterCtrl obj, int32 count, int32 *buffer)                                            { return obj->Read(count, buffer);                                  }
TArray            BDAQCALL TUdCounterCtrl_getChannels(TUdCounterCtrl obj)                                                                 { return (TArray)obj->getChannels();                                }

// Buffered Event Counter
// ----------------------------------------------------------
/* Buffered Event Counter methods*/
int32             BDAQCALL TBfdEcCtrl_getBufferCapacity(TBfdEventCounterCtrl obj)                                        { return obj->getBufferCapacity();                 }
int8              BDAQCALL TBfdEcCtrl_getBufferStatus(TBfdEventCounterCtrl obj, int32 ch, int32 *count, int32 *offset)   { return obj->getBufferStatus(ch, *count, *offset);}
void              BDAQCALL TBfdEcCtrl_getChannelMap(TBfdEventCounterCtrl obj, int32 count, int8 *chMap)                  { return obj->getChannelMap(count, chMap);         } 
ErrorCode         BDAQCALL TBfdEcCtrl_setChannelMap(TBfdEventCounterCtrl obj, int32 count, int8 *chMap)                  { return obj->setChannelMap(count, chMap);         } 
TTrigger          BDAQCALL TBfdEcCtrl_getTrigger(TBfdEventCounterCtrl obj, int32 trigger)                                { return obj->getTrigger(trigger);                 }
TRecord           BDAQCALL TBfdEcCtrl_getRecord(TBfdEventCounterCtrl obj)                                                { return obj->getRecord();                         }
ErrorCode         BDAQCALL TBfdEcCtrl_setSampleClkSrc(TBfdEventCounterCtrl obj, SignalDrop drop)                         { return obj->setSampleClkSrc(drop);               }
SignalDrop        BDAQCALL TBfdEcCtrl_getSampleClkSrc(TBfdEventCounterCtrl obj)                                          { return obj->getSampleClkSrc();                   }
TArray            BDAQCALL TBfdEcCtrl_getChannels(TBfdEventCounterCtrl obj)                                              { return (TArray)obj->getChannels();               }
ErrorCode         BDAQCALL TBfdEcCtrl_Prepare(TBfdEventCounterCtrl obj)                                                  { return obj->Prepare();                           }
void              BDAQCALL TBfdEcCtrl_Release(TBfdEventCounterCtrl obj)                                                  {        obj->Release();                           }

ErrorCode         BDAQCALL TBfdEcCtrl_GetData(TBfdEventCounterCtrl obj, int32 cntr, int32 count, void *buffer, int32 timeout, int32 *returned, double *startTime) 
{ 
   return obj->GetData(cntr, count, buffer, timeout, returned, startTime); 
}

/* Buffered Pulse width meter methods*/
int32             BDAQCALL TBfdPwMeterCtrl_getBufferCapacity(TBfdPwMeterCtrl obj)                                        { return obj->getBufferCapacity();                 }
int8              BDAQCALL TBfdPwMeterCtrl_getBufferStatus(TBfdPwMeterCtrl obj, int32 ch, int32 *count, int32 *offset)   { return obj->getBufferStatus(ch, *count, *offset);}
void              BDAQCALL TBfdPwMeterCtrl_getChannelMap(TBfdPwMeterCtrl obj, int32 count, int8 *chMap)                  { return obj->getChannelMap(count, chMap);         } 
ErrorCode         BDAQCALL TBfdPwMeterCtrl_setChannelMap(TBfdPwMeterCtrl obj, int32 count, int8 *chMap)                  { return obj->setChannelMap(count, chMap);         } 
TTrigger          BDAQCALL TBfdPwMeterCtrl_getTrigger(TBfdPwMeterCtrl obj, int32 trigger)                                { return obj->getTrigger(trigger);                 }
TRecord           BDAQCALL TBfdPwMeterCtrl_getRecord(TBfdPwMeterCtrl obj)                                                { return obj->getRecord();                         }
ErrorCode         BDAQCALL TBfdPwMeterCtrl_setSampleClkSrc(TBfdPwMeterCtrl obj, SignalDrop drop)                         { return obj->setSampleClkSrc(drop);               }
SignalDrop        BDAQCALL TBfdPwMeterCtrl_getSampleClkSrc(TBfdPwMeterCtrl obj)                                          { return obj->getSampleClkSrc();                   }
TArray            BDAQCALL TBfdPwMeterCtrl_getChannels(TBfdPwMeterCtrl obj)                                              { return (TArray)obj->getChannels();               }
ErrorCode         BDAQCALL TBfdPwMeterCtrl_Prepare(TBfdPwMeterCtrl obj)                                                  { return obj->Prepare();                           }
void              BDAQCALL TBfdPwMeterCtrl_Release(TBfdPwMeterCtrl obj)                                                  {        obj->Release();                           }

ErrorCode         BDAQCALL TBfdPwMeterCtrl_GetData(TBfdPwMeterCtrl obj, int32 cntr, int32 count, void *buffer, int32 timeout, int32 *returned, double *startTime) 
{ 
   return obj->GetData(cntr, count, buffer, timeout, returned, startTime); 
}

/* Buffered up down counter methods*/
int32             BDAQCALL TBfdUdCounterCtrl_getBufferCapacity(TBfdUdCounterCtrl obj)                                        { return obj->getBufferCapacity();                 }
int8              BDAQCALL TBfdUdCounterCtrl_getBufferStatus(TBfdUdCounterCtrl obj, int32 ch, int32 *count, int32 *offset)   { return obj->getBufferStatus(ch, *count, *offset);}
void              BDAQCALL TBfdUdCounterCtrl_getChannelMap(TBfdUdCounterCtrl obj, int32 count, int8 *chMap)                  { return obj->getChannelMap(count, chMap);         } 
ErrorCode         BDAQCALL TBfdUdCounterCtrl_setChannelMap(TBfdUdCounterCtrl obj, int32 count, int8 *chMap)                  { return obj->setChannelMap(count, chMap);         } 
TTrigger          BDAQCALL TBfdUdCounterCtrl_getTrigger(TBfdUdCounterCtrl obj, int32 trigger)                                { return obj->getTrigger(trigger);                 }
TRecord           BDAQCALL TBfdUdCounterCtrl_getRecord(TBfdUdCounterCtrl obj)                                                { return obj->getRecord();                         }
ErrorCode         BDAQCALL TBfdUdCounterCtrl_setSampleClkSrc(TBfdUdCounterCtrl obj, SignalDrop drop)                         { return obj->setSampleClkSrc(drop);               }
SignalDrop        BDAQCALL TBfdUdCounterCtrl_getSampleClkSrc(TBfdUdCounterCtrl obj)                                          { return obj->getSampleClkSrc();                   }
TArray            BDAQCALL TBfdUdCounterCtrl_getChannels(TBfdUdCounterCtrl obj)                                              { return (TArray)obj->getChannels();               }
ErrorCode         BDAQCALL TBfdUdCounterCtrl_Prepare(TBfdUdCounterCtrl obj)                                                  { return obj->Prepare();                           }
void              BDAQCALL TBfdUdCounterCtrl_Release(TBfdUdCounterCtrl obj)                                                  {        obj->Release();                           }

ErrorCode         BDAQCALL TBfdUdCounterCtrl_GetData(TBfdUdCounterCtrl obj, int32 cntr, int32 count, void *buffer, int32 timeout, int32 *returned, double *startTime) 
{ 
   return obj->GetData(cntr, count, buffer, timeout, returned, startTime); 
}

/* Buffered Pulse width modulator methods*/
int32             BDAQCALL TBfdPwModulatorCtrl_getBufferCapacity(TBfdPwModulatorCtrl obj)                                        { return obj->getBufferCapacity();                 }
int8              BDAQCALL TBfdPwModulatorCtrl_getBufferStatus(TBfdPwModulatorCtrl obj, int32 ch, int32 *count, int32 *offset)   { return obj->getBufferStatus(ch, *count, *offset);}
void              BDAQCALL TBfdPwModulatorCtrl_getChannelMap(TBfdPwModulatorCtrl obj, int32 count, int8 *chMap)                  { return obj->getChannelMap(count, chMap);         } 
ErrorCode         BDAQCALL TBfdPwModulatorCtrl_setChannelMap(TBfdPwModulatorCtrl obj, int32 count, int8 *chMap)                  { return obj->setChannelMap(count, chMap);         } 
TTrigger          BDAQCALL TBfdPwModulatorCtrl_getTrigger(TBfdPwModulatorCtrl obj, int32 trigger)                                { return obj->getTrigger(trigger);                 }
int32             BDAQCALL TBfdPwModulatorCtrl_getSamples(TBfdPwModulatorCtrl obj)                                               { return obj->getSamples();                        }
ErrorCode         BDAQCALL TBfdPwModulatorCtrl_setSamples(TBfdPwModulatorCtrl obj, int32 value)                                  { return obj->setSamples(value);                   }
int32             BDAQCALL TBfdPwModulatorCtrl_getIntervalCount(TBfdPwModulatorCtrl obj)                                         { return obj->getIntervalCount();                  }
ErrorCode         BDAQCALL TBfdPwModulatorCtrl_setIntervalCount(TBfdPwModulatorCtrl obj, int32 value)                            { return obj->setIntervalCount(value);             }
int8              BDAQCALL TBfdPwModulatorCtrl_getStreaming(TBfdPwModulatorCtrl obj)                                             { return obj->getStreaming();                      }
ErrorCode         BDAQCALL TBfdPwModulatorCtrl_setStreaming(TBfdPwModulatorCtrl obj, int8 value)                                 { return obj->setStreaming(!!value);               }
ErrorCode         BDAQCALL TBfdPwModulatorCtrl_setSampleClkSrc(TBfdPwModulatorCtrl obj, SignalDrop drop)                         { return obj->setSampleClkSrc(drop);               }
SignalDrop        BDAQCALL TBfdPwModulatorCtrl_getSampleClkSrc(TBfdPwModulatorCtrl obj)                                          { return obj->getSampleClkSrc();                   }
TArray            BDAQCALL TBfdPwModulatorCtrl_getChannels(TBfdPwModulatorCtrl obj)                                              { return (TArray)obj->getChannels();               }
ErrorCode         BDAQCALL TBfdPwModulatorCtrl_Prepare(TBfdPwModulatorCtrl obj)                                                  { return obj->Prepare();                           }
void              BDAQCALL TBfdPwModulatorCtrl_Release(TBfdPwModulatorCtrl obj)                                                  {        obj->Release();                           }

ErrorCode         BDAQCALL TBfdPwModulatorCtrl_SetData(TBfdPwModulatorCtrl obj, int32 cntr, uint32 count, void *buffer) 
{ 
   return obj->SetData(cntr, count, buffer);
}


// **********************************************************
// ctrl class : calibration related
// ----------------------------------------------------------
// ----------------------------------------------------------
// CaliSubject
// ----------------------------------------------------------
wchar_t const *   BDAQCALL TCaliSubject_getDescription(TCaliSubject obj)                                                      { return obj->getDescription();       }
wchar_t const *   BDAQCALL TCaliSubject_getInstruction(TCaliSubject obj)                                                      { return obj->getInstruction();       }
wchar_t const *   BDAQCALL TCaliSubject_getTargetRange(TCaliSubject obj)                                                      { return obj->getTargetRange();       }

CaliState         BDAQCALL TCaliSubject_AdjCodeGetCurrentState(TCaliSubject obj, double *value, uint32 *count, uint32 code[]) { return obj->AdjCodeGetCurrentState(value, count, code); }
void              BDAQCALL TCaliSubject_AdjCodeGetRange(TCaliSubject obj, uint32 lower[], uint32 upper[])                     {        obj->AdjCodeGetRange(lower, upper); }      
ErrorCode         BDAQCALL TCaliSubject_ManualAdjStart(TCaliSubject obj)                                                      { return obj->ManualAdjStart();              }
ErrorCode         BDAQCALL TCaliSubject_ManualAdjStop(TCaliSubject obj)                                                       { return obj->ManualAdjStop();               }
ErrorCode         BDAQCALL TCaliSubject_ManualAdjSetCode(TCaliSubject obj, uint32 count, uint32 code[])                       { return obj->ManualAdjSetCode(count, code); }

// ----------------------------------------------------------
// CaliSection
// ----------------------------------------------------------
wchar_t const *   BDAQCALL TCaliSection_getTypeName(TCaliSection obj)                                                         { return obj->getTypeName();          }
wchar_t const *   BDAQCALL TCaliSection_getDescription(TCaliSection obj)                                                      { return obj->getDescription();       } 
wchar_t const *   BDAQCALL TCaliSection_getInstruction(TCaliSection obj)                                                      { return obj->getInstruction();       }
TArray            BDAQCALL TCaliSection_getSubjects(TCaliSection obj)                                                         { return obj->getSubjects();          }       

ErrorCode         BDAQCALL TCaliSection_Prepare(TCaliSection obj)                                                             { return obj->Prepare();              }                
ErrorCode         BDAQCALL TCaliSection_BatchStart(TCaliSection obj)                                                          { return obj->BatchStart();           }                
void              BDAQCALL TCaliSection_BatchTerminate(TCaliSection obj)                                                      {        obj->BatchTerminate();       }               

// ----------------------------------------------------------
// CaliSolution
// ----------------------------------------------------------
wchar_t const *   BDAQCALL TCaliSolution_getTypeName(TCaliSolution obj)                                                       { return obj->getTypeName();          }
wchar_t const *   BDAQCALL TCaliSolution_getDescription(TCaliSolution obj)                                                    { return obj->getDescription();       }
wchar_t const *   BDAQCALL TCaliSolution_getInstruction(TCaliSolution obj)                                                    { return obj->getInstruction();       }
uint8   const *   BDAQCALL TCaliSolution_getAuxiliaryImage(TCaliSolution obj, uint32 *size)                                   { return obj->getAuxiliaryImage(size);}
TArray            BDAQCALL TCaliSolution_getSections(TCaliSolution obj)                                                       { return obj->getSections();          }       

ErrorCode         BDAQCALL TCaliSolution_AdjCodesSave(TCaliSolution obj)                                                      { return obj->AdjCodesSave();         }               
ErrorCode         BDAQCALL TCaliSolution_AdjCodesLoad(TCaliSolution obj)                                                      { return obj->AdjCodesLoad();         }               
ErrorCode         BDAQCALL TCaliSolution_AdjCodesSaveToGoldBackup(TCaliSolution obj)                                          { return obj->AdjCodesSaveToGoldBackup();         }
ErrorCode         BDAQCALL TCaliSolution_AdjCodesLoadFromGoldBackup(TCaliSolution obj, int32 action)                          { return obj->AdjCodesLoadFromGoldBackup(action); }

// ----------------------------------------------------------
// CalibrationCtrl
// ----------------------------------------------------------
TArray            BDAQCALL TCalibrationCtrl_getSolutions(TCalibrationCtrl obj)                                                { return obj->getSolutions();         }       

// **********************************************************
// ctrl class : firmware related
// ----------------------------------------------------------
// ----------------------------------------------------------
// Firmware
// ----------------------------------------------------------
wchar_t const *   BDAQCALL TFirmware_getDescription(TFirmware obj)                                                            { return obj->getDescription();          }
wchar_t const *   BDAQCALL TFirmware_getNotice(TFirmware obj)                                                                 { return obj->getNotice();               } 
wchar_t const *   BDAQCALL TFirmware_getActivationTitle(TFirmware obj)                                                        { return obj->getActivationTitle();      } 
wchar_t const *   BDAQCALL TFirmware_getVersionOnDevice(TFirmware obj)                                                        { return obj->getVersionOnDevice();      }
wchar_t const *   BDAQCALL TFirmware_getVersionOnFile(TFirmware obj)                                                          { return obj->getVersionOnFile();        }
int32             BDAQCALL TFirmware_getOverwriteProgressing(TFirmware obj)                                                   { return obj->getOverwriteProgressing(); }       
                                                                                          
ErrorCode         BDAQCALL TFirmware_LoadFwFile(TFirmware obj, wchar_t const * filePath)                                      { return obj->LoadFwFile(filePath);              }
ErrorCode         BDAQCALL TFirmware_Overwrite(TFirmware obj, FwAction action, wchar_t const *activationCode)                 { return obj->Overwrite(action, activationCode); }
                                                                                          
// ----------------------------------------------------------
// FirmwareCtrl
// ----------------------------------------------------------
TArray            BDAQCALL TFirmwareCtrl_getFirmwares(TFirmwareCtrl obj)                                                      { return obj->getFirmwares();            } 

// ---------------------------------------------------------------
// DAQNAVI4 CSCL ANSI-C interface function table
// 
// NOTE:
//     MUST NOT RE-ORDER OR REMOVE the elements of the table.
//     YOU CAN JUST APPEND new element at the tail of the table.
//
// DAQNAVI4: 
//      For extensibility, here we put the APIs into several 
//  independence tables so that each table can be extended individually.
// ---------------------------------------------------------------
#include "../misc/daqnavi3_api.h"

// DN4 Fusion device APIs
extern "C" {
   ErrorCode BDAQCALL AdxFusionDeviceCreate(int32 count, int32 children[], int32 *fusionNumber);
   ErrorCode BDAQCALL AdxFusionDeviceAddChildren(int32 fusionNumber, int32 count, int32 children[]);
   ErrorCode BDAQCALL AdxFusionDeviceDeleteChildren(int32 fusionNumber, int32 count, int32 children[]);
   ErrorCode BDAQCALL AdxFusionDeviceGetChildren(int32 fusionNumber, int32 *count, int32 children[]);
   ErrorCode BDAQCALL AdxDeviceFusionableCheck(int32 fusionNumber, int32 count, int32 children[]);
   ErrorCode BDAQCALL AdxIsFusionDevice(int32 fusionNumber);

};

static DAQ_FN const s_dn4_global[] = {
   // Global APIs ----------------------------------------------------
   (DAQ_FN)AdxGetValueRangeInformation,           // index: 0
   (DAQ_FN)AdxGetSignalConnectionInformation,     // index: 1
   (DAQ_FN)AdxTranslateTemperatureScale,          // index: 2
   (DAQ_FN)AdxEnumToString,                       // index: 3
   (DAQ_FN)AdxStringToEnum,                       // index: 4
   (DAQ_FN)AdxDeviceGetLinkageInfo,               // index: 5
   (DAQ_FN)AdxEventClearFlag,                     // index: 6
   (DAQ_FN)AdxPropertyRead,                       // index: 7
   (DAQ_FN)AdxPropertyWrite,                      // index: 8

   // New: DN4 fusion APIs -------------------------------------------
   (DAQ_FN)AdxFusionDeviceCreate,                 // index: 9
   (DAQ_FN)AdxFusionDeviceAddChildren,            // index: 10
   (DAQ_FN)AdxFusionDeviceDeleteChildren,         // index: 11
   (DAQ_FN)AdxFusionDeviceGetChildren,            // index: 12
   (DAQ_FN)AdxDeviceFusionableCheck,              // index: 13
   (DAQ_FN)AdxIsFusionDevice,                     // index: 14
};

static DAQ_FN const s_dn4_base[] = {
   // Array -------------------------------------------------------------------------
   (DAQ_FN)TArray_Dispose,                        // index: 0          
   (DAQ_FN)TArray_getLength,                      // index: 1          
   (DAQ_FN)TArray_getItem,                        // index: 2          

   // ScanChannel -------------------------------------------------------------------------
   (DAQ_FN)TScanChannel_getChannelStart,          // index: 3
   (DAQ_FN)TScanChannel_setChannelStart,          // index: 4
   (DAQ_FN)TScanChannel_getChannelCount,          // index: 5
   (DAQ_FN)TScanChannel_setChannelCount,          // index: 6
   (DAQ_FN)TScanChannel_getIntervalCount,         // index: 7
   (DAQ_FN)TScanChannel_setIntervalCount,         // index: 8
   (DAQ_FN)TScanChannel_getSamples,               // index: 9
   (DAQ_FN)TScanChannel_setSamples,               // index: 10

   // ConvertClock ------------------------------------------------------------------------
   (DAQ_FN)TConvertClock_getSource,               // index: 11
   (DAQ_FN)TConvertClock_setSource,               // index: 12
   (DAQ_FN)TConvertClock_getRate,                 // index: 13
   (DAQ_FN)TConvertClock_setRate,                 // index: 14

   // ScanClock -------------------------------------------------------------------------
   (DAQ_FN)TScanClock_getSource,                  // index: 15
   (DAQ_FN)TScanClock_setSource,                  // index: 16
   (DAQ_FN)TScanClock_getRate,                    // index: 17
   (DAQ_FN)TScanClock_setRate,                    // index: 18
   (DAQ_FN)TScanClock_getScanCount,               // index: 19
   (DAQ_FN)TScanClock_setScanCount,               // index: 20

   // Trigger -------------------------------------------------------------------------
   (DAQ_FN)TTrigger_getSource,                    // index: 21
   (DAQ_FN)TTrigger_setSource,                    // index: 22
   (DAQ_FN)TTrigger_getEdge,                      // index: 23
   (DAQ_FN)TTrigger_setEdge,                      // index: 24
   (DAQ_FN)TTrigger_getLevel,                     // index: 25
   (DAQ_FN)TTrigger_setLevel,                     // index: 26
   (DAQ_FN)TTrigger_getAction,                    // index: 27
   (DAQ_FN)TTrigger_setAction,                    // index: 28
   (DAQ_FN)TTrigger_getDelayCount,                // index: 29
   (DAQ_FN)TTrigger_setDelayCount,                // index: 30
   (DAQ_FN)TTrigger_getHysteresisIndex,           // index: 31
   (DAQ_FN)TTrigger_setHysteresisIndex,           // index: 32
            
   // Conversion ----------------------------------------------------------------------------
   (DAQ_FN)TConversion_getClockSource,            // index: 33
   (DAQ_FN)TConversion_setClockSource,            // index: 34
   (DAQ_FN)TConversion_getClockRate,              // index: 35
   (DAQ_FN)TConversion_setClockRate,              // index: 36
   (DAQ_FN)TConversion_getChannelStart,           // index: 37
   (DAQ_FN)TConversion_setChannelStart,           // index: 38
   (DAQ_FN)TConversion_getChannelCount,           // index: 39
   (DAQ_FN)TConversion_setChannelCount,           // index: 40
   (DAQ_FN)TConversion_getChannelMap,             // index: 41
   (DAQ_FN)TConversion_setChannelMap,             // index: 42

   // Record ----------------------------------------------------------------------------
   (DAQ_FN)TRecord_getSectionLength,              // index: 43
   (DAQ_FN)TRecord_setSectionLength,              // index: 44
   (DAQ_FN)TRecord_getSectionCount,               // index: 45
   (DAQ_FN)TRecord_setSectionCount,               // index: 46
   (DAQ_FN)TRecord_getCycles,                     // index: 47
   (DAQ_FN)TRecord_setCycles,                     // index: 48

   // NosFltChannel ------------------------------------------------------------------
   (DAQ_FN)TNosFltChannel_getChannel,             // index: 49
   (DAQ_FN)TNosFltChannel_getEnabled,             // index: 50
   (DAQ_FN)TNosFltChannel_setEnabled,             // index: 51

   // Device Ctrl -------------------------------------------------------------------------
   (DAQ_FN)TDeviceCtrl_addEventHandler,           // index: 52
   (DAQ_FN)TDeviceCtrl_removeEventHandler,        // index: 53
   (DAQ_FN)TDeviceCtrl_Refresh,                   // index: 54
   (DAQ_FN)TDeviceCtrl_ReadRegister,              // index: 55
   (DAQ_FN)TDeviceCtrl_WriteRegister,             // index: 56
   (DAQ_FN)TDeviceCtrl_ReadPrivateRegion,         // index: 57
   (DAQ_FN)TDeviceCtrl_WritePrivateRegion,        // index: 58
   (DAQ_FN)TDeviceCtrl_getDeviceNumber,           // index: 59
   (DAQ_FN)TDeviceCtrl_getDescription,            // index: 60
   (DAQ_FN)TDeviceCtrl_getAccessMode,             // index: 61
   (DAQ_FN)TDeviceCtrl_getProductId,              // index: 62
   (DAQ_FN)TDeviceCtrl_getBoardId,                // index: 63
   (DAQ_FN)TDeviceCtrl_getBoardVersion,           // index: 64
   (DAQ_FN)TDeviceCtrl_getDriverVersion,          // index: 65
   (DAQ_FN)TDeviceCtrl_getDllVersion,             // index: 66
   (DAQ_FN)TDeviceCtrl_getLocation,               // index: 67
   (DAQ_FN)TDeviceCtrl_getPrivateRegionLength,    // index: 68
   (DAQ_FN)TDeviceCtrl_getHotResetPreventable,    // index: 69
   (DAQ_FN)TDeviceCtrl_getBaseAddresses,          // index: 70
   (DAQ_FN)TDeviceCtrl_getInterrupts,             // index: 71
   (DAQ_FN)TDeviceCtrl_getSupportedTerminalBoard, // index: 72
   (DAQ_FN)TDeviceCtrl_getSupportedEvents,        // index: 73
   (DAQ_FN)TDeviceCtrl_getTerminalBoard,          // index: 74
   (DAQ_FN)TDeviceCtrl_setTerminalBoard,          // index: 75
   (DAQ_FN)TDeviceCtrl_setDescription,            // index: 76, 
   (DAQ_FN)TDeviceCtrl_setBoardId,                // index: 77, 
   (DAQ_FN)TDeviceCtrl_getSupportedScenarios,     // index: 78
   (DAQ_FN)TDeviceCtrl_Dispose,                   // index: 79
   (DAQ_FN)TDeviceCtrl_Create,                    // index: 80
                                                             
   // DaqCtrlBase -------------------------------------------------------------------------
   (DAQ_FN)TDaqCtrlBase_addEventHandler,          // index: 81
   (DAQ_FN)TDaqCtrlBase_removeEventHandler,       // index: 82
   (DAQ_FN)TDaqCtrlBase_Cleanup,                  // index: 83
   (DAQ_FN)TDaqCtrlBase_Dispose,                  // index: 84
   (DAQ_FN)TDaqCtrlBase_getSelectedDevice,        // index: 85
   (DAQ_FN)TDaqCtrlBase_setSelectedDevice,        // index: 86
   (DAQ_FN)TDaqCtrlBase_getState,                 // index: 87
   (DAQ_FN)TDaqCtrlBase_getDevice,                // index  88
   (DAQ_FN)TDaqCtrlBase_getSupportedDevices,      // index: 89
   (DAQ_FN)TDaqCtrlBase_getSupportedModes,        // index: 90
   (DAQ_FN)TDaqCtrlBase_Create,                   // index: 91

   // New -------------------------------------------------------------------------
   (DAQ_FN)TDeviceCtrl_getDevice,                 // index: 92
   (DAQ_FN)TDaqCtrlBase_getModule,                // index: 93

   // new: trigger source filter---------------------------------------------------
   (DAQ_FN)TTrigger_getFilterType,                // index: 94
   (DAQ_FN)TTrigger_setFilterType,                // index: 95
   (DAQ_FN)TTrigger_getFilterCutoffFreq,          // index: 96
   (DAQ_FN)TTrigger_setFilterCutoffFreq,          // index: 97

   // new: load profile------------------------------------------------------------
   (DAQ_FN)TDaqCtrlBase_LoadProfile,              // index: 98

   //  new: set device properties--------------------------------------------------
   (DAQ_FN)TDeviceCtrl_setLocateEnabled,          // index: 99

   //  new: get all installed devices----------------------------------------------
   (DAQ_FN)TDeviceCtrl_getInstalledDevices,       // index: 100
   (DAQ_FN)TDeviceCtrl_SynchronizeTimebase,       // index: 101
   (DAQ_FN)TDeviceCtrl_CalculateAbsoluteTime,     // index: 102

   //  new: HW specific properties ----------------------------------------------
   (DAQ_FN)TDeviceCtrl_getHwSpecific,             // index: 103
   (DAQ_FN)TDeviceCtrl_setHwSpecific,             // index: 104

   // new: calibration related ---------------------------------------------------
   (DAQ_FN)TCaliSubject_getDescription,           // index: 105
   (DAQ_FN)TCaliSubject_getInstruction,           // index: 106
   (DAQ_FN)TCaliSubject_getTargetRange,           // index: 107
   (DAQ_FN)TCaliSubject_AdjCodeGetCurrentState,   // index: 108
   (DAQ_FN)TCaliSubject_AdjCodeGetRange,          // index: 109
   (DAQ_FN)TCaliSubject_ManualAdjStart,           // index: 110
   (DAQ_FN)TCaliSubject_ManualAdjStop,            // index: 111
   (DAQ_FN)TCaliSubject_ManualAdjSetCode,         // index: 112
                                                  
   (DAQ_FN)TCaliSection_getTypeName,              // index: 113
   (DAQ_FN)TCaliSection_getDescription,           // index: 114
   (DAQ_FN)TCaliSection_getInstruction,           // index: 115
   (DAQ_FN)TCaliSection_getSubjects,              // index: 116
   (DAQ_FN)TCaliSection_BatchStart,               // index: 117
   (DAQ_FN)TCaliSection_BatchTerminate,           // index: 118

   (DAQ_FN)TCaliSolution_getTypeName,               // index: 119
   (DAQ_FN)TCaliSolution_getDescription,            // index: 120
   (DAQ_FN)TCaliSolution_getInstruction,            // index: 121
   (DAQ_FN)TCaliSolution_getAuxiliaryImage,         // index: 122
   (DAQ_FN)TCaliSolution_getSections,               // index: 123
   (DAQ_FN)TCaliSolution_AdjCodesSave,              // index: 124
   (DAQ_FN)TCaliSolution_AdjCodesLoad,              // index: 125
   (DAQ_FN)TCaliSolution_AdjCodesSaveToGoldBackup,  // index: 126
   (DAQ_FN)TCaliSolution_AdjCodesLoadFromGoldBackup,// index: 127
                                                  
   (DAQ_FN)TCalibrationCtrl_getSolutions,           // index: 128

   // new: firmware related ---------------------------------------------------
   (DAQ_FN)TFirmware_getDescription,                // index: 129
   (DAQ_FN)TFirmware_getNotice,                     // index: 130
   (DAQ_FN)TFirmware_getActivationTitle,            // index: 131
   (DAQ_FN)TFirmware_getVersionOnDevice,            // index: 132
   (DAQ_FN)TFirmware_getVersionOnFile,              // index: 133
   (DAQ_FN)TFirmware_getOverwriteProgressing,       // index: 134
   (DAQ_FN)TFirmware_LoadFwFile,                    // index: 135
   (DAQ_FN)TFirmware_Overwrite,                     // index: 136

   (DAQ_FN)TFirmwareCtrl_getFirmwares,              // index: 137

   //  new: fusion device properties ----------------------------------------------
   (DAQ_FN)TDeviceCtrl_getSupportedFusionTypes,     // index: 138

   //  new: programmable pin properties--------------------------------------------
   (DAQ_FN)TDeviceCtrl_getProgrammableSignals,          // index: 139
   (DAQ_FN)TDeviceCtrl_getProgrammableSignalsDirection, // index: 140
   (DAQ_FN)TDeviceCtrl_setProgrammableSignalsDirection, // index: 141

   // new: features & properties for signal routing--------------------------------
   (DAQ_FN)TDeviceCtrl_getRtSignalEndpoints,            // index: 142
   (DAQ_FN)TDeviceCtrl_getRtEndpointXSupportedSources,  // index: 143
   (DAQ_FN)TDeviceCtrl_getRtEndpointXSource,            // index: 144 
   (DAQ_FN)TDeviceCtrl_setRtEndpointXSource,            // index: 145

   (DAQ_FN)TCaliSection_Prepare,                        // index: 146

   // new: bus/slot number of device -----------------------------------------------
   (DAQ_FN)TDeviceCtrl_getBusSlot,                      // index: 147
};

static DAQ_FN const s_dn4_ai[] = {
   // CjcSetting -------------------------------------------------------------------------
   (DAQ_FN)TCjcSetting_getChannel,                    // index: 0
   (DAQ_FN)TCjcSetting_setChannel,                    // index: 1
   (DAQ_FN)TCjcSetting_getValue,                      // index: 2
   (DAQ_FN)TCjcSetting_setValue,                      // index: 3
   (DAQ_FN)TCjcSetting_getUpdateFreq,                 // index: 4
   (DAQ_FN)TCjcSetting_setUpdateFreq,                 // index: 5

   // AiChannel ------------------------------------------------------------------
   (DAQ_FN)TAiChannel_getChannel,                     // index: 6
   (DAQ_FN)TAiChannel_getValueRange,                  // index: 7
   (DAQ_FN)TAiChannel_setValueRange,                  // index: 8
   (DAQ_FN)TAiChannel_getSignalType,                  // index: 9
   (DAQ_FN)TAiChannel_setSignalType,                  // index: 10
   (DAQ_FN)TAiChannel_getBurnoutRetType,              // index: 11
   (DAQ_FN)TAiChannel_setBurnoutRetType,              // index: 12
   (DAQ_FN)TAiChannel_getBurnoutRetValue,             // index: 13
   (DAQ_FN)TAiChannel_setBurnoutRetValue,             // index: 14
   (DAQ_FN)TAiChannel_getFilterType,                  // index: 15
   (DAQ_FN)TAiChannel_setFilterType,                  // index: 16
   (DAQ_FN)TAiChannel_getFilterCutoffFreq,            // index: 17
   (DAQ_FN)TAiChannel_setFilterCutoffFreq,            // index: 18
   (DAQ_FN)TAiChannel_getFilterCutoffFreq1,           // index: 19
   (DAQ_FN)TAiChannel_setFilterCutoffFreq1,           // index: 20
   (DAQ_FN)TAiChannel_getLogicalNumber,               // index: 21

   // AI features -------------------------------------------------------------------------
   (DAQ_FN)TAiFeatures_getResolution,                 // index: 22
   (DAQ_FN)TAiFeatures_getDataSize,                   // index: 23
   (DAQ_FN)TAiFeatures_getDataMask,                   // index: 24
   (DAQ_FN)TAiFeatures_getChannelCountMax,            // index: 25
   (DAQ_FN)TAiFeatures_getChannelType,                // index: 26
   (DAQ_FN)TAiFeatures_getOverallValueRange,          // index: 27
   (DAQ_FN)TAiFeatures_getValueRanges,                // index: 28
   (DAQ_FN)TAiFeatures_getBurnoutReturnTypes,         // index: 29
   (DAQ_FN)TAiFeatures_getFilterTypes,                // index: 30
   (DAQ_FN)TAiFeatures_getFilterCutoffFreqRange,      // index: 31
   (DAQ_FN)TAiFeatures_getFilterCutoffFreq1Range,     // index: 32
   (DAQ_FN)TAiFeatures_getThermoSupported,            // index: 33
   (DAQ_FN)TAiFeatures_getCjcChannels,                // index: 34
   (DAQ_FN)TAiFeatures_getBufferedAiSupported,        // index: 35
   (DAQ_FN)TAiFeatures_getSamplingMethod,             // index: 36
   (DAQ_FN)TAiFeatures_getChannelStartBase,           // index: 37
   (DAQ_FN)TAiFeatures_getChannelCountBase,           // index: 38
   (DAQ_FN)TAiFeatures_getConvertClockSources,        // index: 39
   (DAQ_FN)TAiFeatures_getConvertClockRange,          // index: 40
   (DAQ_FN)TAiFeatures_getBurstScanSupported,         // index: 41
   (DAQ_FN)TAiFeatures_getScanClockSources,           // index: 42
   (DAQ_FN)TAiFeatures_getScanClockRange,             // index: 43
   (DAQ_FN)TAiFeatures_getScanCountMax,               // index: 44
   (DAQ_FN)TAiFeatures_getRetriggerable,              // index: 45
   (DAQ_FN)TAiFeatures_getTriggerCount,               // index: 46
   (DAQ_FN)TAiFeatures_getTriggerActions,             // index: 47
   (DAQ_FN)TAiFeatures_getTriggerDelayRange,          // index: 48
   (DAQ_FN)TAiFeatures_getTriggerSources,             // index: 49
   (DAQ_FN)TAiFeatures_getTriggerSourceVrg,           // index: 50
   (DAQ_FN)TAiFeatures_getTriggerHysteresisIndexMax,  // index: 51
   (DAQ_FN)TAiFeatures_getTriggerHysteresisIndexStep, // index: 52

   // AiChannel -----------------------------------------------------------------------
   (DAQ_FN)TAiChannel_getScaleTable,                  // index: 53
   (DAQ_FN)TAiChannel_setScaleTable,                  // index: 54 
   (DAQ_FN)NULL,                                      // index: 55 remove TAiChannel_GenerateNewVrg
   (DAQ_FN)NULL,                                      // index: 56 remove TAiChannel_GetCjcScaleTable,              
   (DAQ_FN)NULL,                                      // index: 57 remove TAiChannel_SetCjcScaleTable,    

   // AICtrlBase -----------------------------------------------------------------------
   (DAQ_FN)TAiCtrlBase_getFeatures,                   // index: 58
   (DAQ_FN)TAiCtrlBase_getChannels,                   // index: 59
   (DAQ_FN)TAiCtrlBase_getChannelCount,               // index: 60

   // InstantAICtrl -----------------------------------------------------------------------
   (DAQ_FN)TInstantAiCtrl_ReadAny,                    // index: 61
   (DAQ_FN)TInstantAiCtrl_getCjc,                     // index: 62
   (DAQ_FN)TInstantAiCtrl_getAutoConvertClockRate,    // index: 63
   (DAQ_FN)TInstantAiCtrl_setAutoConvertClockRate,    // index: 64
   (DAQ_FN)TInstantAiCtrl_getAutoConvertChannelStart, // index: 65
   (DAQ_FN)TInstantAiCtrl_setAutoConvertChannelStart, // index: 66
   (DAQ_FN)TInstantAiCtrl_getAutoConvertChannelCount, // index: 67
   (DAQ_FN)TInstantAiCtrl_setAutoConvertChannelCount, // index: 68

   // BufferedAiCtrl ----------------------------------------------------------------------
   (DAQ_FN)TBufferedAiCtrl_Prepare,                   // index: 69
   (DAQ_FN)TBufferedAiCtrl_RunOnce,                   // index: 70
   (DAQ_FN)TBufferedAiCtrl_Start,                     // index: 71
   (DAQ_FN)TBufferedAiCtrl_Stop,                      // index: 72
   (DAQ_FN)TBufferedAiCtrl_Release,                   // index: 73
   (DAQ_FN)TBufferedAiCtrl_GetBufferStatus,           // index: 74
   (DAQ_FN)TBufferedAiCtrl_GetData,                   // index: 75
   (DAQ_FN)TBufferedAiCtrl_getBuffer,                 // index: 76
   (DAQ_FN)TBufferedAiCtrl_getBufferCapacity,         // index: 77
   (DAQ_FN)TBufferedAiCtrl_getScanChannel,            // index: 78
   (DAQ_FN)TBufferedAiCtrl_getConvertClock,           // index: 79
   (DAQ_FN)TBufferedAiCtrl_getScanClock,              // index: 80
   (DAQ_FN)TBufferedAiCtrl_getTrigger,                // index: 81
   (DAQ_FN)TBufferedAiCtrl_getStreaming,              // index: 82
   (DAQ_FN)TBufferedAiCtrl_setStreaming,              // index: 83
    
   // WaveformAiCtrl ----------------------------------------------------------------------
   (DAQ_FN)TWaveformAiCtrl_Prepare,                   // index: 84
   (DAQ_FN)TWaveformAiCtrl_Start,                     // index: 85
   (DAQ_FN)TWaveformAiCtrl_Stop,                      // index: 86
   (DAQ_FN)TWaveformAiCtrl_Release,                   // index: 87
   (DAQ_FN)TWaveformAiCtrl_GetBufferStatus,           // index: 88
   (DAQ_FN)TWaveformAiCtrl_GetData,                   // index: 89
   (DAQ_FN)TWaveformAiCtrl_getBuffer,                 // index: 90
   (DAQ_FN)TWaveformAiCtrl_getBufferCapacity,         // index: 91
   (DAQ_FN)TWaveformAiCtrl_getConversion,             // index: 92
   (DAQ_FN)TWaveformAiCtrl_getRecord,                 // index: 93
   (DAQ_FN)TWaveformAiCtrl_getTrigger,                // index: 94

   // new: coupling & IEPE & Impedance ----------------------------------------------------
   (DAQ_FN)TAiChannel_getCouplingType,                // index: 95
   (DAQ_FN)TAiChannel_setCouplingType,                // index: 96
   (DAQ_FN)TAiChannel_getIepeType,                    // index: 97
   (DAQ_FN)TAiChannel_setIepeType,                    // index: 98
   (DAQ_FN)TAiChannel_getImpedanceType,               // index: 99
   (DAQ_FN)TAiChannel_setImpedanceType,               // index: 100

   (DAQ_FN)TAiFeatures_getCouplingTypes,              // index: 101
   (DAQ_FN)TAiFeatures_getIepeTypes,                  // index: 102
   (DAQ_FN)TAiFeatures_getImpedanceTypes,             // index: 103

    // new: trigger source filter----------------------------------------------------
   (DAQ_FN)TAiFeatures_getTriggerFilterTypes,          // index: 104
   (DAQ_FN)TAiFeatures_getTriggerFilterCutoffFreqRange,// index: 105

   // new: channel connection ----------------------------------------------------
   (DAQ_FN)TAiFeatures_getConnectionTypes,             // index: 106
   (DAQ_FN)TAiFeatures_getOverallConnection,           // index: 107

   // new: timestamp resolution ----------------------------------------------------
   (DAQ_FN)TAiFeatures_getTimestampResolution,        // index: 108

   // new: sensor scaling ----------------------------------------------------
   (DAQ_FN)TAiChannel_getSensorDescription,           // index: 109
   (DAQ_FN)TAiChannel_setSensorDescription,           // index: 110
   
   // AICtrlBase -----------------------------------------------------------------------
   (DAQ_FN)TAiCtrlBase_runSensorCalibration,          // index: 111

   // new: sensor features --------------------------------------------------------
   (DAQ_FN)TAiFeatures_getMeasureTypes,               // index: 112
   (DAQ_FN)TAiFeatures_getBridgeResistances,          // index: 113
   (DAQ_FN)TAiFeatures_getExcitingVoltageRange,       // index: 114

   // new: sensor status detect: sensor short
   (DAQ_FN)TAiChannel_getBurnShortRetValue,           // index: 115
   (DAQ_FN)TAiChannel_setBurnShortRetValue,           // index: 116
};                                                                  
                                                       
static DAQ_FN const s_dn4_ao[] = {                    
   // AoChannel_ -----------------------------------------------------------------------
   (DAQ_FN)TAoChannel_getChannel,                     // index: 0
   (DAQ_FN)TAoChannel_getValueRange,                  // index: 1
   (DAQ_FN)TAoChannel_setValueRange,                  // index: 2
   NULL, /*(DAQ_FN)TAoChannel_getInitialState,*/      // index: 3
   NULL, /*(DAQ_FN)TAoChannel_setInitialState,*/      // index: 4
                                                      
   // AO features -------------------------------------------------------------------------
   (DAQ_FN)TAoFeatures_getResolution,                 // index: 5 
   (DAQ_FN)TAoFeatures_getDataSize,                   // index: 6 
   (DAQ_FN)TAoFeatures_getDataMask ,                  // index: 7 
   (DAQ_FN)TAoFeatures_getChannelCountMax,            // index: 8 
   (DAQ_FN)TAoFeatures_getValueRanges,                // index: 9 
   (DAQ_FN)TAoFeatures_getExternalRefAntiPolar,       // index: 10
   (DAQ_FN)TAoFeatures_getExternalRefRange,           // index: 11
   (DAQ_FN)TAoFeatures_getBufferedAoSupported,        // index: 12
   (DAQ_FN)TAoFeatures_getSamplingMethod,             // index: 13
   (DAQ_FN)TAoFeatures_getChannelStartBase,           // index: 14
   (DAQ_FN)TAoFeatures_getChannelCountBase,           // index: 15
   (DAQ_FN)TAoFeatures_getConvertClockSources,        // index: 16
   (DAQ_FN)TAoFeatures_getConvertClockRange,          // index: 17
   (DAQ_FN)TAoFeatures_getTriggerCount,               // index: 18
   (DAQ_FN)TAoFeatures_getTriggerSources,             // index: 19
   (DAQ_FN)TAoFeatures_getTriggerActions,             // index: 20
   (DAQ_FN)TAoFeatures_getTriggerDelayRange,          // index: 21

   // AoChannel_ -----------------------------------------------------------------------
   (DAQ_FN)TAoChannel_getScaleTable,                  // index: 22 
   (DAQ_FN)TAoChannel_setScaleTable,                  // index: 23 
   (DAQ_FN)NULL,                                      // index: 24 remove TAoChannel_generateNewVrg
                                                      
   // AoCtrlBase -----------------------------------------------------------------------
   (DAQ_FN)TAoCtrlBase_getFeatures,                   // index: 25
   (DAQ_FN)TAoCtrlBase_getChannels,                   // index: 26
   (DAQ_FN)TAoCtrlBase_getChannelCount,               // index: 27
   (DAQ_FN)TAoCtrlBase_getExtRefValueForUnipolar,     // index: 28
   (DAQ_FN)TAoCtrlBase_setExtRefValueForUnipolar,     // index: 29
   (DAQ_FN)TAoCtrlBase_getExtRefValueForBipolar,      // index: 30
   (DAQ_FN)TAoCtrlBase_setExtRefValueForBipolar,      // index: 31

   // InstantAoCtrl -----------------------------------------------------------------------
   (DAQ_FN)TInstantAoCtrl_WriteAny,                   // index: 32

   // BufferedAoCtrl ----------------------------------------------------------------------
   (DAQ_FN)TBufferedAoCtrl_Prepare,                   // index: 33
   (DAQ_FN)TBufferedAoCtrl_RunOnce,                   // index: 34
   (DAQ_FN)TBufferedAoCtrl_Start,                     // index: 35
   (DAQ_FN)TBufferedAoCtrl_Stop,                      // index: 36
   (DAQ_FN)TBufferedAoCtrl_Release,                   // index: 37
   (DAQ_FN)TBufferedAoCtrl_GetBufferStatus,           // index: 38
   (DAQ_FN)TBufferedAoCtrl_SetData,                   // index: 39
   (DAQ_FN)TBufferedAoCtrl_getBuffer,                 // index: 40
   (DAQ_FN)TBufferedAoCtrl_getBufferCapacity,         // index: 41
   (DAQ_FN)TBufferedAoCtrl_getScanChannel,            // index: 42
   (DAQ_FN)TBufferedAoCtrl_getConvertClock,           // index: 43
   (DAQ_FN)TBufferedAoCtrl_getTrigger,                // index: 44
   (DAQ_FN)TBufferedAoCtrl_getStreaming,              // index: 45
   (DAQ_FN)TBufferedAoCtrl_setStreaming,              // index: 46

   // DN4 new property  -------------------------------------------------------------------
   (DAQ_FN)TAoChannel_getExtRefBipolar,               // index: 47
   (DAQ_FN)TAoChannel_setExtRefBipolar,               // index: 48
   (DAQ_FN)TAoChannel_getExtRefUnipolar,              // index: 49
   (DAQ_FN)TAoChannel_setExtRefUnipolar,              // index: 50

   // DN4 new property  -------------------------------------------------------------------
   (DAQ_FN)TAoFeatures_getRetriggerable,              // index: 51
};

static DAQ_FN const s_dn4_dio[] = {
   // DioPort -----------------------------------------------------------------------
   (DAQ_FN)TDioPort_getPort,                             // index: 0
   (DAQ_FN)TDioPort_getDirection,                        // index: 1
   (DAQ_FN)TDioPort_setDirection,                        // index: 2
   (DAQ_FN)TDioPort_getDiInversePort,                    // index: 3
   (DAQ_FN)TDioPort_setDiInversePort,                    // index: 4
   NULL, /*(DAQ_FN)TDioPort_getDoInitialState,*/         // index: 5
   NULL, /*(DAQ_FN)TDioPort_setDoInitialState,*/         // index: 6

   // DiintChannel ------------------------------------------------------------------------
   (DAQ_FN)TDiintChannel_getChannel,                     // index: 7 
   (DAQ_FN)TDiintChannel_getEnabled,                     // index: 8 
   (DAQ_FN)TDiintChannel_setEnabled,                     // index: 9 
   (DAQ_FN)TDiintChannel_getGated,                       // index: 10
   (DAQ_FN)TDiintChannel_setGated,                       // index: 11
   (DAQ_FN)TDiintChannel_getTrigEdge,                    // index: 12
   (DAQ_FN)TDiintChannel_setTrigEdge,                    // index: 13

   // DiCosintPort ------------------------------------------------------------------------
   (DAQ_FN)TDiCosintPort_getPort,                        // index: 14
   (DAQ_FN)TDiCosintPort_getMask,                        // index: 15
   (DAQ_FN)TDiCosintPort_setMask,                        // index: 16

   // DiPmintPort -------------------------------------------------------------------------
   (DAQ_FN)TDiPmintPort_getPort,                         // index: 17
   (DAQ_FN)TDiPmintPort_getMask,                         // index: 18
   (DAQ_FN)TDiPmintPort_setMask,                         // index: 19
   (DAQ_FN)TDiPmintPort_getPattern,                      // index: 20
   (DAQ_FN)TDiPmintPort_setPattern,                      // index: 21

   // DIO features -------------------------------------------------------------------------
   (DAQ_FN)TDioFeatures_getPortProgrammable,             // index: 22
   (DAQ_FN)TDioFeatures_getChannelCountMax,              // index: 23
   (DAQ_FN)TDioFeatures_getPortCount,                    // index: 24
   (DAQ_FN)TDioFeatures_getPortsType,                    // index: 25
   (DAQ_FN)TDioFeatures_getDiSupported,                  // index: 26
   (DAQ_FN)TDioFeatures_getDoSupported,                  // index: 27
   (DAQ_FN)TDioFeatures_getDiDataMask,                   // index: 28
   (DAQ_FN)TDioFeatures_getDiNoiseFilterSupported,       // index: 29
   (DAQ_FN)TDioFeatures_getDiNoiseFilterOfChannels,      // index: 30
   (DAQ_FN)TDioFeatures_getDiNoiseFilterBlockTimeRange,  // index: 31
   (DAQ_FN)TDioFeatures_getDiintSupported,               // index: 32
   (DAQ_FN)TDioFeatures_getDiintGateSupported,           // index: 33
   (DAQ_FN)TDioFeatures_getDiCosintSupported,            // index: 34
   (DAQ_FN)TDioFeatures_getDiPmintSupported,             // index: 35
   (DAQ_FN)TDioFeatures_getDiintTriggerEdges,            // index: 36
   (DAQ_FN)TDioFeatures_getDiintOfChannels,              // index: 37
   (DAQ_FN)TDioFeatures_getDiintGateOfChannels,          // index: 38
   (DAQ_FN)TDioFeatures_getDiCosintOfPorts,              // index: 39
   (DAQ_FN)TDioFeatures_getDiPmintOfPorts,               // index: 40
   (DAQ_FN)TDioFeatures_getDiSnapEventSources,           // index: 41
   (DAQ_FN)TDioFeatures_getDoDataMask,                   // index: 42
   (DAQ_FN)TDioFeatures_getDoFreezeSignalSources,        // index: 43
   (DAQ_FN)TDioFeatures_getDoReflectWdtFeedIntervalRange,// index: 44

   // DioCtrlBase -----------------------------------------------------------------------
   (DAQ_FN)TDioCtrlBase_getFeatures,                     // index: 45
   (DAQ_FN)TDioCtrlBase_getPortCount,                    // index: 46
   (DAQ_FN)TDioCtrlBase_getPorts,                        // index: 47

   // InstantDiCtrl -----------------------------------------------------------------------
   (DAQ_FN)TInstantDiCtrl_ReadAny,                       // index: 48
   (DAQ_FN)TInstantDiCtrl_ReadBit,                       // index: 49
   (DAQ_FN)TInstantDiCtrl_SnapStart,                     // index: 50
   (DAQ_FN)TInstantDiCtrl_SnapStop,                      // index: 51
   (DAQ_FN)TInstantDiCtrl_getNoiseFilterBlockTime,       // index: 52
   (DAQ_FN)TInstantDiCtrl_setNoiseFilterBlockTime,       // index: 53
   (DAQ_FN)TInstantDiCtrl_getNoiseFilter,                // index: 54
   (DAQ_FN)TInstantDiCtrl_getDiintChannels,              // index: 55
   (DAQ_FN)TInstantDiCtrl_getDiCosintPorts,              // index: 56
   (DAQ_FN)TInstantDiCtrl_getDiPmintPorts,               // index: 57
                                                          
   // InstantDoCtrl -----------------------------------------------------------------------
   (DAQ_FN)TInstantDoCtrl_WriteAny,                      // index: 58
   (DAQ_FN)TInstantDoCtrl_ReadAny,                       // index: 59
   (DAQ_FN)TInstantDoCtrl_WriteBit,                      // index: 60
   (DAQ_FN)TInstantDoCtrl_ReadBit,                       // index: 61

   // new -----------------------------------------------------------------------
   (DAQ_FN)TDioFeatures_getDataMask,                     // index: 62, for compatible
   (DAQ_FN)TDioFeatures_getDoPresetValueDepository,      // index: 63
   (DAQ_FN)TDioPort_getDoPresetValue,                    // index: 64
   (DAQ_FN)TDioPort_setDoPresetValue,                    // index: 65
   (DAQ_FN)TDioFeatures_getDoCircuitSelectableTypes,     // index: 66
   (DAQ_FN)TDioPort_getDoCircuitType,                    // index: 67
   (DAQ_FN)TDioPort_setDoCircuitType,                    // index: 68

   // new: Buffered Di Feature ---------------------------------------------------
   (DAQ_FN)TDioFeatures_getBufferedDiSupported,            // index:69
   (DAQ_FN)TDioFeatures_getDiSamplingMethod,               // index:70   
   (DAQ_FN)TDioFeatures_getDiConvertClockSources,          // index:71
   (DAQ_FN)TDioFeatures_getDiConvertClockRange,            // index:72

   (DAQ_FN)TDioFeatures_getDiRetriggerable,                // index:73
   (DAQ_FN)TDioFeatures_getDiTriggerCount,                 // index:74
   (DAQ_FN)TDioFeatures_getDiTriggerActions,               // index:75
   (DAQ_FN)TDioFeatures_getDiTriggerDelayRange,            // index:76 
   (DAQ_FN)TDioFeatures_getDiTriggerSources,               // index:77
   (DAQ_FN)TDioFeatures_getDiTriggerSourceVrg,             // index:78 
   (DAQ_FN)TDioFeatures_getDiTriggerHysteresisIndexMax,    // index:79
   (DAQ_FN)TDioFeatures_getDiTriggerHysteresisIndexStep,   // index:80

   // BufferedDiCtrl -----------------------------------------------------------------------
   (DAQ_FN)TBufferedDiCtrl_Prepare,                      // index:81
   (DAQ_FN)TBufferedDiCtrl_Start,                        // index:82 
   (DAQ_FN)TBufferedDiCtrl_Stop,                         // index:83
   (DAQ_FN)TBufferedDiCtrl_Release,                      // index:84 
   (DAQ_FN)TBufferedDiCtrl_GetBufferStatus,              // index:85
   (DAQ_FN)TBufferedDiCtrl_GetData,                      // index:86
   (DAQ_FN)TBufferedDiCtrl_getBuffer,                    // index:87
   (DAQ_FN)TBufferedDiCtrl_getBufferCapacity,            // index:88 
   (DAQ_FN)TBufferedDiCtrl_getScanPort,                  // index:89
   (DAQ_FN)TBufferedDiCtrl_getConvertClock,              // index:90 
   (DAQ_FN)TBufferedDiCtrl_getTrigger,                   // index:91

   (DAQ_FN)TDioFeatures_getDataSize,                     // index:92
   (DAQ_FN)TDioFeatures_getResolution,                   // index:93

   (DAQ_FN)TDioFeatures_getBufferedDoSupported,          // index:94  
   (DAQ_FN)TDioFeatures_getDoSamplingMethod,             // index:95   
   (DAQ_FN)TDioFeatures_getDoConvertClockSources,        // index:96
   (DAQ_FN)TDioFeatures_getDoConvertClockRange,          // index:97 

   (DAQ_FN)TDioFeatures_getDoRetriggerable,                // index:98  
   (DAQ_FN)TDioFeatures_getDoTriggerCount,                 // index:99
   (DAQ_FN)TDioFeatures_getDoTriggerActions,               // index:100 
   (DAQ_FN)TDioFeatures_getDoTriggerDelayRange,            // index:101
   (DAQ_FN)TDioFeatures_getDoTriggerSources,               // index:102
   (DAQ_FN)TDioFeatures_getDoTriggerSourceVrg,             // index:103
   (DAQ_FN)TDioFeatures_getDoTriggerHysteresisIndexMax,    // index:104
   (DAQ_FN)TDioFeatures_getDoTriggerHysteresisIndexStep,   // index:105

   (DAQ_FN)TBufferedDoCtrl_Prepare,                      // index:106   
   (DAQ_FN)TBufferedDoCtrl_RunOnce,                      // index:107
   (DAQ_FN)TBufferedDoCtrl_Start,                        // index:108 
   (DAQ_FN)TBufferedDoCtrl_Stop,                         // index:109
   (DAQ_FN)TBufferedDoCtrl_Release,                      // index:110
   (DAQ_FN)TBufferedDoCtrl_GetBufferStatus,              // index:111
   (DAQ_FN)TBufferedDoCtrl_SetData,                      // index:112
   (DAQ_FN)TBufferedDoCtrl_getBuffer,                    // index:113
   (DAQ_FN)TBufferedDoCtrl_getBufferCapacity,            // index:114 
   (DAQ_FN)TBufferedDoCtrl_getScanPort,                  // index:115 
   (DAQ_FN)TBufferedDoCtrl_getConvertClock,              // index:116
   (DAQ_FN)TBufferedDoCtrl_getTrigger,                   // index:117
   (DAQ_FN)NULL,                                         // index:118: TBufferedDoCtrl_getStreaming
   (DAQ_FN)NULL,                                         // index:119: TBufferedDoCtrl_setStreaming
   (DAQ_FN)NULL,                                         // index:120: TBufferedDoCtrl_ReadPort

   // new: ScanPort -------------------------------------------------------------
   (DAQ_FN)TScanPort_getPortStart,                     // index: 121
   (DAQ_FN)TScanPort_setPortStart,                     // index: 122
   (DAQ_FN)TScanPort_getPortCount,                     // index: 123
   (DAQ_FN)TScanPort_setPortCount,                     // index: 124
   (DAQ_FN)TScanPort_getPortMap,                       // index: 125
   (DAQ_FN)TScanPort_setPortMap,                       // index: 126
   (DAQ_FN)TScanPort_getSectionLength,                 // index: 127
   (DAQ_FN)TScanPort_setSectionLength,                 // index: 128
   (DAQ_FN)TScanPort_getSectionCount,                  // index: 129
   (DAQ_FN)TScanPort_setSectionCount,                  // index: 130
   (DAQ_FN)TScanPort_getCycles,                        // index: 131
   (DAQ_FN)TScanPort_setCycles,                        // index: 132  

   // new: DioPort::Di Port Open State--------------------------------------------
   (DAQ_FN)TDioPort_getDiOpenState,                    // index: 133
   (DAQ_FN)TDioPort_setDiOpenState,                    // index: 134

};                                                      

static DAQ_FN const s_dn4_cntr[] = {
   // Counter Indexer ------------------------------------------------------------
   (DAQ_FN)TCounterIndexer_Dispose,                         // index: 0
   (DAQ_FN)TCounterIndexer_getLength,                        // index: 1
   (DAQ_FN)TCounterIndexer_getItem,                         // index: 2

   // Counter Features ----------------------------------------------------------------
   (DAQ_FN)TCntrFeatures_getChannelCountMax,             // index: 3 
   (DAQ_FN)TCntrFeatures_getResolution,                  // index: 4 
   (DAQ_FN)TCntrFeatures_getDataSize,                    // index: 5 
   (DAQ_FN)TCntrFeatures_getCapabilities,                // index: 6 
   (DAQ_FN)TCntrFeatures_getNoiseFilterSupported,        // index: 7 
   (DAQ_FN)TCntrFeatures_getNoiseFilterOfChannels,       // index: 8 
   (DAQ_FN)TCntrFeatures_getNoiseFilterBlockTimeRange,   // index: 9 
   (DAQ_FN)TCntrFeatures_getEcClockPolarities,           // index: 10
   (DAQ_FN)TCntrFeatures_getEcGatePolarities,            // index: 11
   (DAQ_FN)TCntrFeatures_getEcGateControlOfChannels,     // index: 12
   (DAQ_FN)TCntrFeatures_getFmMethods,                   // index: 13
   (DAQ_FN)TCntrFeatures_getOsClockSources,              // index: 14
   (DAQ_FN)TCntrFeatures_getOsClockPolarities,           // index: 15
   (DAQ_FN)TCntrFeatures_getOsGateSources,               // index: 16
   (DAQ_FN)TCntrFeatures_getOsGatePolarities,            // index: 17
   (DAQ_FN)TCntrFeatures_getOsOutSignals,                // index: 18
   (DAQ_FN)TCntrFeatures_getOsDelayCountRange,           // index: 19
   (DAQ_FN)TCntrFeatures_getTmrGateControlOfChannels,    // index: 20
   (DAQ_FN)TCntrFeatures_getTmrGatePolarities,           // index: 21
   (DAQ_FN)TCntrFeatures_getTmrOutSignals,               // index: 22
   (DAQ_FN)TCntrFeatures_getTmrFrequencyRange,           // index: 23
   (DAQ_FN)TCntrFeatures_getPiCascadeGroup,              // index: 24
   (DAQ_FN)TCntrFeatures_getPoGateControlOfChannels,     // index: 25
   (DAQ_FN)TCntrFeatures_getPoGatePolarities,            // index: 26
   (DAQ_FN)TCntrFeatures_getPoOutSignals,                // index: 27
   (DAQ_FN)TCntrFeatures_getPoHiPeriodRange,             // index: 28
   (DAQ_FN)TCntrFeatures_getPoLoPeriodRange,             // index: 29
   (DAQ_FN)TCntrFeatures_getPoOutCountRange,             // index: 30
   (DAQ_FN)TCntrFeatures_getUdCountingTypes,             // index: 31
   (DAQ_FN)TCntrFeatures_getUdInitialValues,             // index: 32
   (DAQ_FN)TCntrFeatures_getUdSnapEventSources,          // index: 33

   // CntrCtrlBase ----------------------------------------------------------------
   (DAQ_FN)TCntrCtrlBase_getFeatures,                    // index: 34
   (DAQ_FN)TCntrCtrlBase_getChannelStart,                // index: 35
   (DAQ_FN)TCntrCtrlBase_setChannelStart,                // index: 36
   (DAQ_FN)TCntrCtrlBase_getChannelCount,                // index: 37
   (DAQ_FN)TCntrCtrlBase_setChannelCount,                // index: 38
   (DAQ_FN)TCntrCtrlBase_getEnabled,                     // index: 39
   (DAQ_FN)TCntrCtrlBase_setEnabled,                     // index: 40
   (DAQ_FN)TCntrCtrlBase_getRunning,                     // index: 41
   (DAQ_FN)TCntrCtrlBase_getNoiseFilterBlockTime,        // index: 42
   (DAQ_FN)TCntrCtrlBase_setNoiseFilterBlockTime,        // index: 43
   (DAQ_FN)TCntrCtrlBase_getNoiseFilter,                 // index: 44
                                                          
   // EventCounterCtrl ----------------------------------------------------------------
   // EcChannel 
   (DAQ_FN)TEcChannel_getChannel,                        // index: 45
   (DAQ_FN)TEcChannel_getNoiseFiltered,                  // index: 46
   (DAQ_FN)TEcChannel_setNoiseFiltered,                  // index: 47
   (DAQ_FN)TEcChannel_getClockPolarity,                  // index: 48
   (DAQ_FN)TEcChannel_setClockPolarity,                  // index: 49
   (DAQ_FN)TEcChannel_getGatePolarity,                   // index: 50
   (DAQ_FN)TEcChannel_setGatePolarity,                   // index: 51
   (DAQ_FN)TEcChannel_getGated,                          // index: 52
   (DAQ_FN)TEcChannel_setGated,                          // index: 53
   // EventCounterCtrl                                              
   (DAQ_FN)TEventCounterCtrl_Read,                       // index: 54
   (DAQ_FN)TEventCounterCtrl_getChannels,                // index: 55

   // FreqMeterCtrl ----------------------------------------------------------------------
   // FmChannel 
   (DAQ_FN)TFmChannel_getChannel,                        // index: 56
   (DAQ_FN)TFmChannel_getNoiseFiltered,                  // index: 57
   (DAQ_FN)TFmChannel_setNoiseFiltered,                  // index: 58
   (DAQ_FN)TFmChannel_getFmMethod,                       // index: 59
   (DAQ_FN)TFmChannel_setFmMethod,                       // index: 60
   (DAQ_FN)TFmChannel_getCollectionPeriod,               // index: 61
   (DAQ_FN)TFmChannel_setCollectionPeriod,               // index: 62
   //FreqMeterCtrl                                        
   (DAQ_FN)TFreqMeterCtrl_Read,                          // index: 63
   (DAQ_FN)TFreqMeterCtrl_getChannels,                   // index: 64
                                                          
   // OneShot ----------------------------------------------------------------------
   // OsChannel 
   (DAQ_FN)TOsChannel_getChannel,                        // index: 65
   (DAQ_FN)TOsChannel_getNoiseFiltered,                  // index: 66
   (DAQ_FN)TOsChannel_setNoiseFiltered,                  // index: 67
   (DAQ_FN)TOsChannel_getDelayCount,                     // index: 68
   (DAQ_FN)TOsChannel_setDelayCount,                     // index: 69
   (DAQ_FN)TOsChannel_getClockSource,                    // index: 70
   (DAQ_FN)TOsChannel_setClockSource,                    // index: 71
   (DAQ_FN)TOsChannel_getClockPolarity,                  // index: 72
   (DAQ_FN)TOsChannel_setClockPolarity,                  // index: 73
   (DAQ_FN)TOsChannel_getGateSource,                     // index: 74
   (DAQ_FN)TOsChannel_setGateSource,                     // index: 75
   (DAQ_FN)TOsChannel_getGatePolarity,                   // index: 76
   (DAQ_FN)TOsChannel_setGatePolarity,                   // index: 77
   (DAQ_FN)TOsChannel_getOutSignal,                      // index: 78
   (DAQ_FN)TOsChannel_setOutSignal,                      // index: 79
   // OneShotCtrl                                                   
   (DAQ_FN)TOneShotCtrl_getChannels,                     // index: 80
                                                                    
   // TimerPulse ----------------------------------------------------------------------
   // TmrChannel 
   (DAQ_FN)TTmrChannel_getChannel,                       // index: 81
   (DAQ_FN)TTmrChannel_getNoiseFiltered,                 // index: 82
   (DAQ_FN)TTmrChannel_setNoiseFiltered,                 // index: 83
   (DAQ_FN)TTmrChannel_getFrequency,                     // index: 84
   (DAQ_FN)TTmrChannel_setFrequency,                     // index: 85
   (DAQ_FN)TTmrChannel_getGated,                         // index: 86
   (DAQ_FN)TTmrChannel_setGated,                         // index: 87
   (DAQ_FN)TTmrChannel_getGatePolarity,                  // index: 88
   (DAQ_FN)TTmrChannel_setGatePolarity,                  // index: 89
   (DAQ_FN)TTmrChannel_getOutSignal,                     // index: 90
   (DAQ_FN)TTmrChannel_setOutSignal,                     // index: 91
   // TimerPulseCtrl                                                
   (DAQ_FN)TTimerPulseCtrl_getChannels,                  // index: 92
                                                                    
   // PwMeter ------------------------------------------------------------------------
   // PiChannel                                                     
   (DAQ_FN)TPiChannel_getChannel,                        // index: 93
   (DAQ_FN)TPiChannel_getNoiseFiltered,                  // index: 94
   (DAQ_FN)TPiChannel_setNoiseFiltered,                  // index: 95
   // PwMeterCtrl                                                   
   (DAQ_FN)TPwMeterCtrl_getChannels,                     // index: 96
   (DAQ_FN)TPwMeterCtrl_Read,                            // index: 97
                                                                    
   // PwModulator ----------------------------------------------------------------------
   // PoChannel                                           
   (DAQ_FN)TPoChannel_getChannel,                        // index: 98
   (DAQ_FN)TPoChannel_getNoiseFiltered,                  // index: 99
   (DAQ_FN)TPoChannel_setNoiseFiltered,                  // index: 100
   (DAQ_FN)TPoChannel_getPulseWidth,                     // index: 101
   (DAQ_FN)TPoChannel_setPulseWidth,                     // index: 102
   (DAQ_FN)TPoChannel_getGated,                          // index: 103
   (DAQ_FN)TPoChannel_setGated,                          // index: 104
   (DAQ_FN)TPoChannel_getGatePolarity,                   // index: 105
   (DAQ_FN)TPoChannel_setGatePolarity,                   // index: 106
   (DAQ_FN)TPoChannel_getOutSignal,                      // index: 107
   (DAQ_FN)TPoChannel_setOutSignal,                      // index: 108
   (DAQ_FN)TPoChannel_getOutCount,                       // index: 109
   (DAQ_FN)TPoChannel_setOutCount,                       // index: 110
   // PwModulatorCtrl                                               
   (DAQ_FN)TPwModulatorCtrl_getChannels,                 // index: 111
                                                                    
   // Up-down counting-------------------------------------------------------------------
   // UdChannel                                           
   (DAQ_FN)TUdChannel_getChannel,                        // index: 112
   (DAQ_FN)TUdChannel_getNoiseFiltered,                  // index: 113
   (DAQ_FN)TUdChannel_setNoiseFiltered,                  // index: 114
   (DAQ_FN)TUdChannel_getCountingType,                   // index: 115
   (DAQ_FN)TUdChannel_setCountingType,                   // index: 116
   (DAQ_FN)TUdChannel_getInitialValue,                   // index: 117
   (DAQ_FN)TUdChannel_setInitialValue,                   // index: 118
   (DAQ_FN)TUdChannel_getResetTimesByIndex,              // index: 119
   (DAQ_FN)TUdChannel_setResetTimesByIndex,              // index: 120
   // UdCounterCtrl                                                 
   (DAQ_FN)TUdCounterCtrl_SnapStart,                     // index: 121
   (DAQ_FN)TUdCounterCtrl_SnapStop,                      // index: 122
   (DAQ_FN)TUdCounterCtrl_CompareSetTable,               // index: 123
   (DAQ_FN)TUdCounterCtrl_CompareSetInterval,            // index: 124
   (DAQ_FN)TUdCounterCtrl_CompareClear,                  // index: 125
   (DAQ_FN)TUdCounterCtrl_ValueReset,                    // index: 126
   (DAQ_FN)TUdCounterCtrl_Read,                          // index: 127
   (DAQ_FN)TUdCounterCtrl_getChannels,                   // index: 128

   // new: measurement timeout-------------------------------------------------------------
   (DAQ_FN)TCntrFeatures_getMeasurementTimeoutRange,     // index: 129
   (DAQ_FN)TCntrCtrlBase_getMeasurementTimeout,          // index: 130
   (DAQ_FN)TCntrCtrlBase_setMeasurementTimeout,          // index: 131

   // new: buffered counter features
   (DAQ_FN)TCntrFeatures_getTriggerCount,                // index: 132
   (DAQ_FN)TCntrFeatures_getTriggerSources,              // index: 133
   (DAQ_FN)TCntrFeatures_getTriggerActions,              // index: 134
   (DAQ_FN)TCntrFeatures_getEcSampleClockSources,        // index: 135
   (DAQ_FN)TCntrFeatures_getPiSampleClockSources,        // index: 136
   (DAQ_FN)TCntrFeatures_getPoSampleClockSources,        // index: 137
   (DAQ_FN)TCntrFeatures_getUdSampleClockSources,        // index: 138

   // new: buffered event counter
   (DAQ_FN)TBfdEcCtrl_getChannelMap,                     // index: 139
   (DAQ_FN)TBfdEcCtrl_setChannelMap,                     // index: 140
   (DAQ_FN)TBfdEcCtrl_getTrigger,                        // index: 141 
   (DAQ_FN)TBfdEcCtrl_getRecord,                         // index: 142
   (DAQ_FN)TBfdEcCtrl_setSampleClkSrc,                   // index: 143
   (DAQ_FN)TBfdEcCtrl_getSampleClkSrc,                   // index: 144
   (DAQ_FN)TBfdEcCtrl_getChannels,                       // index: 145
   (DAQ_FN)TBfdEcCtrl_Prepare,                           // index: 146
   (DAQ_FN)TBfdEcCtrl_Release,                           // index: 147
   (DAQ_FN)TBfdEcCtrl_GetData,                           // index: 148

   // new: buffered pulse width meter
   (DAQ_FN)TBfdPwMeterCtrl_getChannelMap,                // index: 149 
   (DAQ_FN)TBfdPwMeterCtrl_setChannelMap,                // index: 150
   (DAQ_FN)TBfdPwMeterCtrl_getTrigger,                   // index: 151 
   (DAQ_FN)TBfdPwMeterCtrl_getRecord,                    // index: 152
   (DAQ_FN)TBfdPwMeterCtrl_setSampleClkSrc,              // index: 153
   (DAQ_FN)TBfdPwMeterCtrl_getSampleClkSrc,              // index: 154
   (DAQ_FN)TBfdPwMeterCtrl_getChannels,                  // index: 155
   (DAQ_FN)TBfdPwMeterCtrl_Prepare,                      // index: 156
   (DAQ_FN)TBfdPwMeterCtrl_Release,                      // index: 157
   (DAQ_FN)TBfdPwMeterCtrl_GetData,                      // index: 158

   // new: buffered up down counter
   (DAQ_FN)TBfdUdCounterCtrl_getChannelMap,              // index: 159 
   (DAQ_FN)TBfdUdCounterCtrl_setChannelMap,              // index: 160
   (DAQ_FN)TBfdUdCounterCtrl_getTrigger,                 // index: 161 
   (DAQ_FN)TBfdUdCounterCtrl_getRecord,                  // index: 162
   (DAQ_FN)TBfdUdCounterCtrl_setSampleClkSrc,            // index: 163
   (DAQ_FN)TBfdUdCounterCtrl_getSampleClkSrc,            // index: 164
   (DAQ_FN)TBfdUdCounterCtrl_getChannels,                // index: 165
   (DAQ_FN)TBfdUdCounterCtrl_Prepare,                    // index: 166
   (DAQ_FN)TBfdUdCounterCtrl_Release,                    // index: 167
   (DAQ_FN)TBfdUdCounterCtrl_GetData,                    // index: 168

   // new: buffered pulse width modulator
   (DAQ_FN)TBfdPwModulatorCtrl_getChannelMap,            // index: 169
   (DAQ_FN)TBfdPwModulatorCtrl_setChannelMap,            // index: 170 
   (DAQ_FN)TBfdPwModulatorCtrl_getTrigger,               // index: 171 
   (DAQ_FN)TBfdPwModulatorCtrl_getSamples,               // index: 172
   (DAQ_FN)TBfdPwModulatorCtrl_setSamples,               // index: 173 
   (DAQ_FN)TBfdPwModulatorCtrl_getIntervalCount,         // index: 174 
   (DAQ_FN)TBfdPwModulatorCtrl_setIntervalCount,         // index: 175 
   (DAQ_FN)TBfdPwModulatorCtrl_setStreaming,             // index: 176
   (DAQ_FN)TBfdPwModulatorCtrl_setSampleClkSrc,          // index: 177
   (DAQ_FN)TBfdPwModulatorCtrl_getSampleClkSrc,          // index: 178
   (DAQ_FN)TBfdPwModulatorCtrl_getChannels,              // index: 179
   (DAQ_FN)TBfdPwModulatorCtrl_Prepare,                  // index: 180 
   (DAQ_FN)TBfdPwModulatorCtrl_Release,                  // index: 181 
   (DAQ_FN)TBfdPwModulatorCtrl_SetData,                  // index: 182 

   (DAQ_FN)TBfdEcCtrl_getBufferCapacity,                 // index: 183
   (DAQ_FN)TBfdPwMeterCtrl_getBufferCapacity,            // index: 184
   (DAQ_FN)TBfdUdCounterCtrl_getBufferCapacity,          // index: 185
   (DAQ_FN)TBfdPwModulatorCtrl_getBufferCapacity,        // index: 186

   (DAQ_FN)TBfdPwModulatorCtrl_getStreaming,             // index: 187

   (DAQ_FN)TBfdEcCtrl_getBufferStatus,                   // index: 188
   (DAQ_FN)TBfdPwMeterCtrl_getBufferStatus,              // index: 189
   (DAQ_FN)TBfdUdCounterCtrl_getBufferStatus,            // index: 190
   (DAQ_FN)TBfdPwModulatorCtrl_getBufferStatus,          // index: 191
   (DAQ_FN)TCntrFeatures_getUdValueResetTimes,           // index: 192

   (DAQ_FN)TCntrFeatures_getEcClockSources,              // index: 193
   (DAQ_FN)TEcChannel_getClockSource,                    // index: 194
   (DAQ_FN)TEcChannel_setClockSource,                    // index: 195

   // new features & properties for Counter continue comparing: outputting pulse settings
   (DAQ_FN)TCntrFeatures_getCcpGateControlOfChannels,    // index: 196
   (DAQ_FN)TCntrFeatures_getCcpGatePolarities,           // index: 197
   (DAQ_FN)TCntrFeatures_getCcpOutSignals,               // index: 198
   (DAQ_FN)TCntrFeatures_getCcpHiPeriodRange,            // index: 199
   (DAQ_FN)TCntrFeatures_getCcpLoPeriodRange,            // index: 200
   (DAQ_FN)TCntrFeatures_getCcpOutCountRange,            // index: 201

   (DAQ_FN)TUdChannel_getPulseWidth,                     // index: 202
   (DAQ_FN)TUdChannel_setPulseWidth,                     // index: 203
   (DAQ_FN)TUdChannel_getGated,                          // index: 204
   (DAQ_FN)TUdChannel_setGated,                          // index: 205
   (DAQ_FN)TUdChannel_getGatePolarity,                   // index: 206
   (DAQ_FN)TUdChannel_setGatePolarity,                   // index: 207
   (DAQ_FN)TUdChannel_getOutSignal,                      // index: 208
   (DAQ_FN)TUdChannel_setOutSignal,                      // index: 209
   (DAQ_FN)TUdChannel_getOutCount,                       // index: 210
   (DAQ_FN)TUdChannel_setOutCount,                       // index: 211

   // new features & properties for trigger settings of pulse width modulation
   (DAQ_FN)TCntrFeatures_getPoTriggerCount,              // index: 212
   (DAQ_FN)TCntrFeatures_getPoTriggerSources,            // index: 213
   (DAQ_FN)TCntrFeatures_getPoTriggerActions,            // index: 214
   (DAQ_FN)TCntrFeatures_getPoTriggerDelayRange,         // index: 215

   (DAQ_FN)TPoChannel_getTriggerSource,                  // index: 216
   (DAQ_FN)TPoChannel_setTriggerSource,                  // index: 217
   (DAQ_FN)TPoChannel_getTriggerEdge,                    // index: 218  
   (DAQ_FN)TPoChannel_setTriggerEdge,                    // index: 219  
   (DAQ_FN)TPoChannel_getTriggerAction,                  // index: 220
   (DAQ_FN)TPoChannel_setTriggerAction,                  // index: 221
   (DAQ_FN)TPoChannel_getTriggerDelayCount,              // index: 222
   (DAQ_FN)TPoChannel_setTriggerDelayCount,              // index: 223

};

static DaqNaviLib s_daqLib = {
   4, // Version
   0, // Revision
   s_dn4_global,
   s_dn4_base,
   s_dn4_ai,
   s_dn4_ao,
   s_dn4_dio,
   s_dn4_cntr,
};

extern "C" {
    DaqNaviLib const * BDAQCALL AdxDaqNaviLibInitialize()
    {
       return &s_daqLib;
    }
}
