/*
 * DAQNAVI4 CSCL ANSI-C API DECLARATION
 *   
 *   For internal directly reference the APIs, such as JAVA stub.
 *  
 *  Created on: 2014-12-11
 *      Author: rocky
 */
#ifndef _DAQNAVI_CTRL_ANSI_API_H
#define _DAQNAVI_CTRL_ANSI_API_H

typedef class XArray             * TArray;
typedef class ScanChannelImpl    * TScanChannel;
typedef class ConvertClockImpl   * TConvertClock;
typedef class ScanClockImpl      * TScanClock;
typedef class TriggerImpl        * TTrigger;
typedef class ConversionImpl     * TConversion;
typedef class RecordImpl         * TRecord;
typedef class NosFltChannelImpl  * TNosFltChannel;
typedef class DeviceCtrlImpl     * TDeviceCtrl;
typedef class DaqCtrlBaseImpl    * TDaqCtrlBase;

typedef class CjcSettingImpl     * TCjcSetting;
typedef class AiChannelImpl      * TAiChannel;
typedef class AiFeaturesImpl     * TAiFeatures;
typedef class AiCtrlBaseImpl     * TAiCtrlBase;
typedef class InstantAiCtrlImpl  * TInstantAiCtrl;
typedef class BufferedAiCtrlImpl * TBufferedAiCtrl;
typedef class WaveformAiCtrlImpl * TWaveformAiCtrl;

typedef class AoChannelImpl      * TAoChannel;
typedef class AoFeaturesImpl     * TAoFeatures;
typedef class AoCtrlBaseImpl     * TAoCtrlBase;
typedef class InstantAoCtrlImpl  * TInstantAoCtrl;
typedef class BufferedAoCtrlImpl * TBufferedAoCtrl;

typedef class DioPortImpl        * TDioPort;
typedef class ScanPortImpl       * TScanPort;
typedef class DiintChannelImpl   * TDiintChannel;
typedef class DiCosintPortImpl   * TDiCosintPort;
typedef class DiPmintPortImpl    * TDiPmintPort;
typedef class DioFeaturesImpl    * TDioFeatures;
typedef class DioCtrlBaseImpl    * TDioCtrlBase;
typedef class InstantDiCtrlImpl  * TInstantDiCtrl;
typedef class InstantDoCtrlImpl  * TInstantDoCtrl;
typedef class BufferedDiCtrlImpl * TBufferedDiCtrl;
typedef class BufferedDoCtrlImpl * TBufferedDoCtrl;

typedef class XCntrIndexer       * TCounterIndexer;
typedef class CntrFeaturesImpl   * TCntrFeatures;
typedef class CntrCtrlBaseImpl   * TCntrCtrlBase;

typedef class EcChannelImpl        * TEcChannel;
typedef class EventCounterCtrlImpl * TEventCounterCtrl;

typedef class FmChannelImpl       * TFmChannel;
typedef class FreqMeterCtrlImpl   * TFreqMeterCtrl;

typedef class OsChannelImpl       * TOsChannel;
typedef class OneShotCtrlImpl     * TOneShotCtrl;

typedef class TmrChannelImpl      * TTmrChannel;
typedef class TimerPulseCtrlImpl  * TTimerPulseCtrl;

typedef class PiChannelImpl       * TPiChannel;
typedef class PwMeterCtrlImpl     * TPwMeterCtrl;

typedef class PoChannelImpl       * TPoChannel;
typedef class PwModulatorCtrlImpl * TPwModulatorCtrl;

typedef class UdChannelImpl       * TUdChannel;
typedef class UdCounterCtrlImpl   * TUdCounterCtrl;

typedef class BfdEventCounterCtrlImpl * TBfdEventCounterCtrl;
typedef class BfdPwMeterCtrlImpl      * TBfdPwMeterCtrl;
typedef class BfdUdCounterCtrlImpl    * TBfdUdCounterCtrl;
typedef class BfdPwModulatorCtrlImpl  * TBfdPwModulatorCtrl;

typedef class CalibrationCtrlImpl     * TCalibrationCtrl;
typedef class CaliSolutionImpl        * TCaliSolution;
typedef class CaliSectionImpl         * TCaliSection;
typedef class CaliSubjectImpl         * TCaliSubject;

typedef class FirmwareCtrlImpl        * TFirmwareCtrl;
typedef class FirmwareImpl            * TFirmware;

// *******************************************************************************
//
// !!!!!!!!!! ALL APIs USE 'BDAQCALL' calling convention !!!!!!!!!!
//
// *******************************************************************************
#ifdef __cplusplus
extern "C" {
#endif
   // *******************************************************************************
   //
   // ------------------------ DAQNAVI4 CSCL ANSI-C API STUB ------------------------  
   //
   // *******************************************************************************

   // ----------------------------------------------------------
   // common classes : Array
   // ----------------------------------------------------------
   void              BDAQCALL TArray_Dispose(TArray obj);              
   int32             BDAQCALL TArray_getLength(TArray obj);             
   void*             BDAQCALL TArray_getItem(TArray obj, int32 index); 

   // ----------------------------------------------------------
   // common classes : ScanChannel
   // ----------------------------------------------------------
   int32             BDAQCALL TScanChannel_getChannelStart(TScanChannel obj);               
   ErrorCode         BDAQCALL TScanChannel_setChannelStart(TScanChannel obj, int32 value);  
   int32             BDAQCALL TScanChannel_getChannelCount(TScanChannel obj);               
   ErrorCode         BDAQCALL TScanChannel_setChannelCount(TScanChannel obj, int32 value);  
   int32             BDAQCALL TScanChannel_getIntervalCount(TScanChannel obj);              
   ErrorCode         BDAQCALL TScanChannel_setIntervalCount(TScanChannel obj, int32 value); 
   int32             BDAQCALL TScanChannel_getSamples(TScanChannel obj);                    
   ErrorCode         BDAQCALL TScanChannel_setSamples(TScanChannel obj, int32 value);       
   
   // ----------------------------------------------------------
   // common classes : ConvertClock
   // ----------------------------------------------------------
   SignalDrop        BDAQCALL TConvertClock_getSource(TConvertClock obj);                  
   ErrorCode         BDAQCALL TConvertClock_setSource(TConvertClock obj, SignalDrop value);
   double            BDAQCALL TConvertClock_getRate(TConvertClock obj);                    
   ErrorCode         BDAQCALL TConvertClock_setRate(TConvertClock obj, double value);      

   // ----------------------------------------------------------
   // common classes : ScanClock
   // ----------------------------------------------------------
   SignalDrop        BDAQCALL TScanClock_getSource(TScanClock obj);                    
   ErrorCode         BDAQCALL TScanClock_setSource(TScanClock obj, SignalDrop value);  
   double            BDAQCALL TScanClock_getRate(TScanClock obj);                      
   ErrorCode         BDAQCALL TScanClock_setRate(TScanClock obj, double value);        
   int32             BDAQCALL TScanClock_getScanCount(TScanClock obj);                 
   ErrorCode         BDAQCALL TScanClock_setScanCount(TScanClock obj, int32 value);    
                        
   // ----------------------------------------------------------
   // common classes : Trigger
   // ----------------------------------------------------------
   SignalDrop        BDAQCALL TTrigger_getSource(TTrigger obj);                        
   ErrorCode         BDAQCALL TTrigger_setSource(TTrigger obj,SignalDrop value);       
   ActiveSignal      BDAQCALL TTrigger_getEdge(TTrigger obj);                          
   ErrorCode         BDAQCALL TTrigger_setEdge(TTrigger obj, ActiveSignal value);      
   double            BDAQCALL TTrigger_getLevel(TTrigger obj);                         
   ErrorCode         BDAQCALL TTrigger_setLevel(TTrigger obj, double value);           
   TriggerAction     BDAQCALL TTrigger_getAction(TTrigger obj);                        
   ErrorCode         BDAQCALL TTrigger_setAction(TTrigger obj, TriggerAction value);   
   int32             BDAQCALL TTrigger_getDelayCount(TTrigger obj);                    
   ErrorCode         BDAQCALL TTrigger_setDelayCount(TTrigger obj, int32 value);       
   double            BDAQCALL TTrigger_getHysteresisIndex(TTrigger obj);               
   ErrorCode         BDAQCALL TTrigger_setHysteresisIndex(TTrigger obj, double value); 
   FilterType        BDAQCALL TTrigger_getFilterType(TTrigger obj);                    
   ErrorCode         BDAQCALL TTrigger_setFilterType(TTrigger obj, FilterType value);  
   double            BDAQCALL TTrigger_getFilterCutoffFreq(TTrigger obj);              
   ErrorCode         BDAQCALL TTrigger_setFilterCutoffFreq(TTrigger obj, double value);

   // ----------------------------------------------------------
   // common classes : NosFltChannel
   // ----------------------------------------------------------
   int32             BDAQCALL TNosFltChannel_getChannel(TNosFltChannel obj);             
   int8              BDAQCALL TNosFltChannel_getEnabled(TNosFltChannel obj);             
   ErrorCode         BDAQCALL TNosFltChannel_setEnabled(TNosFltChannel obj, int8 value); 

   // ----------------------------------------------------------
   // common classes : Conversion
   // ----------------------------------------------------------
   SignalDrop        BDAQCALL TConversion_getClockSource(TConversion obj);                         
   ErrorCode         BDAQCALL TConversion_setClockSource(TConversion obj, SignalDrop value);       
   double            BDAQCALL TConversion_getClockRate(TConversion obj);                           
   ErrorCode         BDAQCALL TConversion_setClockRate(TConversion obj, double value);             
   int32             BDAQCALL TConversion_getChannelStart(TConversion obj);                        
   ErrorCode         BDAQCALL TConversion_setChannelStart(TConversion obj, int32 value);           
   int32             BDAQCALL TConversion_getChannelCount(TConversion obj);                        
   ErrorCode         BDAQCALL TConversion_setChannelCount(TConversion obj, int32 value);           
   void              BDAQCALL TConversion_getChannelMap(TConversion obj, int32 count, int8 *chMap);
   ErrorCode         BDAQCALL TConversion_setChannelMap(TConversion obj, int32 count, int8 *chMap);
     
   // ----------------------------------------------------------
   // common classes : Record
   // ----------------------------------------------------------
   int32             BDAQCALL TRecord_getSectionLength(TRecord obj);                      
   ErrorCode         BDAQCALL TRecord_setSectionLength(TRecord obj, int32 value);         
   int32             BDAQCALL TRecord_getSectionCount(TRecord obj);                       
   ErrorCode         BDAQCALL TRecord_setSectionCount(TRecord obj, int32 value);          
   int32             BDAQCALL TRecord_getCycles(TRecord obj);                             
   ErrorCode         BDAQCALL TRecord_setCycles(TRecord obj, int32 value);                

   // **********************************************************
   // ctrl class : device ctrl class
   // ----------------------------------------------------------
   // Event
   void              BDAQCALL TDeviceCtrl_addEventHandler(TDeviceCtrl obj, EventId id, DeviceEventProc proc, void *userParam);     
   void              BDAQCALL TDeviceCtrl_removeEventHandler(TDeviceCtrl obj, EventId id, DeviceEventProc proc, void *userParam); 

   // Method
   ErrorCode         BDAQCALL TDeviceCtrl_Refresh(TDeviceCtrl obj);                                                       
   ErrorCode         BDAQCALL TDeviceCtrl_ReadRegister(TDeviceCtrl obj, int32 space, int32 offset, int32 length, void *data);    
   ErrorCode         BDAQCALL TDeviceCtrl_WriteRegister(TDeviceCtrl obj, int32 space, int32 offset, int32 length, void *data);   
   ErrorCode         BDAQCALL TDeviceCtrl_ReadPrivateRegion(TDeviceCtrl obj, int32 signature, int32 length, uint8 *data); 
   ErrorCode         BDAQCALL TDeviceCtrl_WritePrivateRegion(TDeviceCtrl obj, int32 signature, int32 length, uint8 *data);
   ErrorCode         BDAQCALL TDeviceCtrl_SynchronizeTimebase(TDeviceCtrl obj);
   double            BDAQCALL TDeviceCtrl_CalculateAbsoluteTime(TDeviceCtrl obj, double relativeTime);

   // property
   int32             BDAQCALL TDeviceCtrl_getDeviceNumber(TDeviceCtrl obj);                             
   ErrorCode         BDAQCALL TDeviceCtrl_getDescription(TDeviceCtrl obj, int32 length, wchar_t *desc); 
   ErrorCode         BDAQCALL TDeviceCtrl_setDescription(TDeviceCtrl obj, int32 length, wchar_t *desc); 
   AccessMode        BDAQCALL TDeviceCtrl_getAccessMode(TDeviceCtrl obj);                               
   ProductId         BDAQCALL TDeviceCtrl_getProductId(TDeviceCtrl obj);                                
   int32             BDAQCALL TDeviceCtrl_getBoardId(TDeviceCtrl obj);  
   ErrorCode         BDAQCALL TDeviceCtrl_setBoardId(TDeviceCtrl obj, int32 value);  
   ErrorCode         BDAQCALL TDeviceCtrl_getBoardVersion(TDeviceCtrl obj, int32 length, wchar_t *ver); 
   ErrorCode         BDAQCALL TDeviceCtrl_getDriverVersion(TDeviceCtrl obj, int32 length, wchar_t *ver);
   ErrorCode         BDAQCALL TDeviceCtrl_getDllVersion(TDeviceCtrl obj, int32 length, wchar_t *ver);   
   ErrorCode         BDAQCALL TDeviceCtrl_getLocation(TDeviceCtrl obj, int32 length, wchar_t *loc);     
   int32             BDAQCALL TDeviceCtrl_getPrivateRegionLength(TDeviceCtrl obj);                      
   int32             BDAQCALL TDeviceCtrl_getHotResetPreventable(TDeviceCtrl obj);                      

   int32             BDAQCALL TDeviceCtrl_getBusSlot(TDeviceCtrl obj);                      
   TArray            BDAQCALL TDeviceCtrl_getBaseAddresses(TDeviceCtrl obj);                            
   TArray            BDAQCALL TDeviceCtrl_getInterrupts(TDeviceCtrl obj);                               
   TArray            BDAQCALL TDeviceCtrl_getSupportedTerminalBoard(TDeviceCtrl obj);                   
   TArray            BDAQCALL TDeviceCtrl_getSupportedEvents(TDeviceCtrl obj);                          
                                                                                                      
   TerminalBoard     BDAQCALL TDeviceCtrl_getTerminalBoard(TDeviceCtrl obj);                            
   ErrorCode         BDAQCALL TDeviceCtrl_setTerminalBoard(TDeviceCtrl obj, TerminalBoard value);  
   ErrorCode         BDAQCALL TDeviceCtrl_setLocateEnabled(TDeviceCtrl obj, int32 enabled);

   int32             BDAQCALL TDeviceCtrl_getSupportedScenarios(TDeviceCtrl obj);                       
   HANDLE            BDAQCALL TDeviceCtrl_getDevice(TDeviceCtrl obj);                                   

   // HW specific property
   ErrorCode         BDAQCALL TDeviceCtrl_getHwSpecific(TDeviceCtrl obj, wchar_t const *name, int32 *size, void *buffer);
   ErrorCode         BDAQCALL TDeviceCtrl_setHwSpecific(TDeviceCtrl obj, wchar_t const *name, int32 size, void *buffer);

   // Property for fusion device
   TArray            BDAQCALL TDeviceCtrl_getSupportedFusionTypes(TDeviceCtrl obj);

   // Features & properties for PFP pins
   TArray            BDAQCALL TDeviceCtrl_getProgrammableSignals(TDeviceCtrl obj);
   ErrorCode         BDAQCALL TDeviceCtrl_getProgrammableSignalsDirection(TDeviceCtrl obj, int32 length, SignalDirection dir[]);
   ErrorCode         BDAQCALL TDeviceCtrl_setProgrammableSignalsDirection(TDeviceCtrl obj, int32 length, SignalDirection dir[]);

   // Features & properties for signal routing
   TArray            BDAQCALL TDeviceCtrl_getRtSignalEndpoints(TDeviceCtrl obj);
   TArray            BDAQCALL TDeviceCtrl_getRtEndpointXSupportedSources(TDeviceCtrl obj, int32 epIndex);
   SignalDrop        BDAQCALL TDeviceCtrl_getRtEndpointXSource(TDeviceCtrl obj, int32 epIndex);
   ErrorCode         BDAQCALL TDeviceCtrl_setRtEndpointXSource(TDeviceCtrl obj, int32 epIndex, SignalDrop source);

   // dispose
   void              BDAQCALL TDeviceCtrl_Dispose(TDeviceCtrl obj);
  
   // static:   
   TDeviceCtrl       BDAQCALL TDeviceCtrl_Create(int32 deviceNumber, wchar_t const *description, AccessMode mode);
   TArray            BDAQCALL TDeviceCtrl_getInstalledDevices();                           


   // **********************************************************
   // ctrl class : daq ctrl base 
   // ----------------------------------------------------------
   /* Methods & Properties */
   void              BDAQCALL TDaqCtrlBase_addEventHandler(TDaqCtrlBase obj, EventId id, DaqEventProc proc, void *userParam);    
   void              BDAQCALL TDaqCtrlBase_removeEventHandler(TDaqCtrlBase obj, EventId id, DaqEventProc proc, void *userParam); 
   ErrorCode         BDAQCALL TDaqCtrlBase_LoadProfile(TDaqCtrlBase obj, wchar_t const *fileName);
   void              BDAQCALL TDaqCtrlBase_Cleanup(TDaqCtrlBase obj);                                       
   void              BDAQCALL TDaqCtrlBase_getSelectedDevice(TDaqCtrlBase obj, DeviceInformation *x);       
   ErrorCode         BDAQCALL TDaqCtrlBase_setSelectedDevice(TDaqCtrlBase obj, DeviceInformation const *x); 
   ControlState      BDAQCALL TDaqCtrlBase_getState(TDaqCtrlBase obj);                                      
   HANDLE            BDAQCALL TDaqCtrlBase_getDevice(TDaqCtrlBase obj);                                     
   TArray            BDAQCALL TDaqCtrlBase_getSupportedDevices(TDaqCtrlBase obj);                           
   TArray            BDAQCALL TDaqCtrlBase_getSupportedModes(TDaqCtrlBase obj);                             
   HANDLE            BDAQCALL TDaqCtrlBase_getModule(TDaqCtrlBase obj);                                     

   // dispose
   void BDAQCALL TDaqCtrlBase_Dispose(TDaqCtrlBase obj); 

   /* creator */
   TDaqCtrlBase BDAQCALL TDaqCtrlBase_Create(Scenario type);

   // **********************************************************
   // ctrl class : AI related
   // ----------------------------------------------------------
   // AiChannel
   // ----------------------------------------------------------
   int32             BDAQCALL TAiChannel_getChannel(TAiChannel obj);                              
   int32             BDAQCALL TAiChannel_getLogicalNumber(TAiChannel obj);                        
   ValueRange        BDAQCALL TAiChannel_getValueRange(TAiChannel obj);                           
   ErrorCode         BDAQCALL TAiChannel_setValueRange(TAiChannel obj, ValueRange value);         
   AiSignalType      BDAQCALL TAiChannel_getSignalType(TAiChannel obj);                           
   ErrorCode         BDAQCALL TAiChannel_setSignalType(TAiChannel obj, AiSignalType value);       
   BurnoutRetType    BDAQCALL TAiChannel_getBurnoutRetType(TAiChannel obj);                       
   ErrorCode         BDAQCALL TAiChannel_setBurnoutRetType(TAiChannel obj, BurnoutRetType value); 
   double            BDAQCALL TAiChannel_getBurnoutRetValue(TAiChannel obj);                      
   ErrorCode         BDAQCALL TAiChannel_setBurnoutRetValue(TAiChannel obj, double value);        
   double            BDAQCALL TAiChannel_getBurnShortRetValue(TAiChannel obj);                      
   ErrorCode         BDAQCALL TAiChannel_setBurnShortRetValue(TAiChannel obj, double value);        
   FilterType        BDAQCALL TAiChannel_getFilterType(TAiChannel obj);                           
   ErrorCode         BDAQCALL TAiChannel_setFilterType(TAiChannel obj, FilterType value);         
   double            BDAQCALL TAiChannel_getFilterCutoffFreq(TAiChannel obj);                     
   ErrorCode         BDAQCALL TAiChannel_setFilterCutoffFreq(TAiChannel obj, double value);       
   double            BDAQCALL TAiChannel_getFilterCutoffFreq1(TAiChannel obj);                    
   ErrorCode         BDAQCALL TAiChannel_setFilterCutoffFreq1(TAiChannel obj, double value);      

   // new: Coupling & IEPE & Impedance
   CouplingType      BDAQCALL TAiChannel_getCouplingType(TAiChannel obj);
   ErrorCode         BDAQCALL TAiChannel_setCouplingType(TAiChannel obj, CouplingType value);
   IepeType          BDAQCALL TAiChannel_getIepeType(TAiChannel obj);
   ErrorCode         BDAQCALL TAiChannel_setIepeType(TAiChannel obj, IepeType value);
   ImpedanceType     BDAQCALL TAiChannel_getImpedanceType(TAiChannel obj);
   ErrorCode         BDAQCALL TAiChannel_setImpedanceType(TAiChannel obj, ImpedanceType value);

   // new: Sensor Scaling
   ErrorCode         BDAQCALL TAiChannel_getSensorDescription(TAiChannel obj, int32 *size, wchar_t desc[]);
   ErrorCode         BDAQCALL TAiChannel_setSensorDescription(TAiChannel obj, int32 size, wchar_t desc[]);

   // new: scale table
   ErrorCode         BDAQCALL TAiChannel_getScaleTable(TAiChannel obj, int32 *size, MapFuncPiece table[]);
   ErrorCode         BDAQCALL TAiChannel_setScaleTable(TAiChannel obj, int32  size, MapFuncPiece table[]);

   // ----------------------------------------------------------
   // CjcSetting
   // ----------------------------------------------------------
   int32             BDAQCALL TCjcSetting_getChannel(TCjcSetting obj);                 
   ErrorCode         BDAQCALL TCjcSetting_setChannel(TCjcSetting obj, int32 ch);       
   double            BDAQCALL TCjcSetting_getValue(TCjcSetting obj);                   
   ErrorCode         BDAQCALL TCjcSetting_setValue(TCjcSetting obj, double value);     
   double            BDAQCALL TCjcSetting_getUpdateFreq(TCjcSetting obj);              
   ErrorCode         BDAQCALL TCjcSetting_setUpdateFreq(TCjcSetting obj, double value);

   // ----------------------------------------------------------
   // AI features
   // ----------------------------------------------------------
   // ADC features
   int32             BDAQCALL TAiFeatures_getResolution(TAiFeatures obj);         
   int32             BDAQCALL TAiFeatures_getDataSize(TAiFeatures obj);           
   int32             BDAQCALL TAiFeatures_getDataMask(TAiFeatures obj);           

   // channel features                                                        
   int32             BDAQCALL TAiFeatures_getChannelCountMax(TAiFeatures obj);    
   AiChannelType     BDAQCALL TAiFeatures_getChannelType(TAiFeatures obj);        
   int8              BDAQCALL TAiFeatures_getOverallValueRange(TAiFeatures obj);  
   TArray            BDAQCALL TAiFeatures_getValueRanges(TAiFeatures obj);        
   TArray            BDAQCALL TAiFeatures_getBurnoutReturnTypes(TAiFeatures obj); 
   TArray            BDAQCALL TAiFeatures_getConnectionTypes(TAiFeatures obj);
   int8              BDAQCALL TAiFeatures_getOverallConnection(TAiFeatures obj);

   // filter
   TArray            BDAQCALL TAiFeatures_getFilterTypes(TAiFeatures obj);                            
   void              BDAQCALL TAiFeatures_getFilterCutoffFreqRange(TAiFeatures obj, MathInterval *x); 
   void              BDAQCALL TAiFeatures_getFilterCutoffFreq1Range(TAiFeatures obj, MathInterval *x);

   // CJC features
   int8              BDAQCALL TAiFeatures_getThermoSupported(TAiFeatures obj);         
   TArray            BDAQCALL TAiFeatures_getCjcChannels(TAiFeatures obj);             
                 
   // buffered ai->basic features
   int8              BDAQCALL TAiFeatures_getBufferedAiSupported(TAiFeatures obj);     
   SamplingMethod    BDAQCALL TAiFeatures_getSamplingMethod(TAiFeatures obj);          
   int32             BDAQCALL TAiFeatures_getChannelStartBase(TAiFeatures obj);        
   int32             BDAQCALL TAiFeatures_getChannelCountBase(TAiFeatures obj);        

   // buffered ai->conversion clock features
   TArray            BDAQCALL TAiFeatures_getConvertClockSources(TAiFeatures obj);                    
   void              BDAQCALL TAiFeatures_getConvertClockRange(TAiFeatures obj, MathInterval *value); 
                 
   // buffered ai->burst scan
   int8              BDAQCALL TAiFeatures_getBurstScanSupported(TAiFeatures obj);                  
   TArray            BDAQCALL TAiFeatures_getScanClockSources(TAiFeatures obj);                    
   void              BDAQCALL TAiFeatures_getScanClockRange(TAiFeatures obj, MathInterval *x);     
   int32             BDAQCALL TAiFeatures_getScanCountMax(TAiFeatures obj);                        

   // buffered ai->trigger features
   int32             BDAQCALL TAiFeatures_getTriggerCount(TAiFeatures obj);                        
   int8              BDAQCALL TAiFeatures_getRetriggerable(TAiFeatures obj);                       
   TArray            BDAQCALL TAiFeatures_getTriggerFilterTypes(TAiFeatures obj, int32 reserved);                      
   void              BDAQCALL TAiFeatures_getTriggerFilterCutoffFreqRange(TAiFeatures obj, int32 reserved, MathInterval *x);

   // buffered ai->trigger0/1/.../x features
   TArray            BDAQCALL TAiFeatures_getTriggerActions(TAiFeatures obj, int32 trigger);                     
   void              BDAQCALL TAiFeatures_getTriggerDelayRange(TAiFeatures obj, int32 trigger, MathInterval *x); 
   TArray            BDAQCALL TAiFeatures_getTriggerSources(TAiFeatures obj, int32 trigger);                     
   ValueRange        BDAQCALL TAiFeatures_getTriggerSourceVrg(TAiFeatures obj, int32 trigger);                   
   double            BDAQCALL TAiFeatures_getTriggerHysteresisIndexMax(TAiFeatures obj, int32 trigger);          
   int32             BDAQCALL TAiFeatures_getTriggerHysteresisIndexStep(TAiFeatures obj, int32 trigger);         

   // new: Coupling & IEPE & Impedance
   TArray            BDAQCALL TAiFeatures_getCouplingTypes(TAiFeatures obj);
   TArray            BDAQCALL TAiFeatures_getIepeTypes(TAiFeatures obj);
   TArray            BDAQCALL TAiFeatures_getImpedanceTypes(TAiFeatures obj);

   // new: timestamp resolution
   double            BDAQCALL TAiFeatures_getTimestampResolution(TAiFeatures obj);

   // new: measure type
   TArray            BDAQCALL TAiFeatures_getMeasureTypes(TAiFeatures obj);
   TArray            BDAQCALL TAiFeatures_getBridgeResistances(TAiFeatures obj);
   void              BDAQCALL TAiFeatures_getExcitingVoltageRange(TAiFeatures obj, MathInterval *value);

   // ----------------------------------------------------------
   // AiCtrlBase
   // ----------------------------------------------------------
   /* AiCtrlBase Methods */

   /* AiCtrlBase Properties */
   TAiFeatures       BDAQCALL TAiCtrlBase_getFeatures(TAiCtrlBase obj);     
   TArray            BDAQCALL TAiCtrlBase_getChannels(TAiCtrlBase obj);     
   int32             BDAQCALL TAiCtrlBase_getChannelCount(TAiCtrlBase obj);
   ErrorCode         BDAQCALL TAiCtrlBase_runSensorCalibration(TAiCtrlBase obj, int32 ch, CalibrationData const* data);

   // ----------------------------------------------------------
   // InstantAiCtrl
   // ----------------------------------------------------------
   /* InstantAiCtrl Methods */
   ErrorCode         BDAQCALL TInstantAiCtrl_ReadAny(TInstantAiCtrl obj, int32 chStart, int32 chCount, void *dataRaw, double *dataScaled); 

   /* InstantAiCtrl Properties */
   TCjcSetting       BDAQCALL TInstantAiCtrl_getCjc(TInstantAiCtrl obj);                                 
   double            BDAQCALL TInstantAiCtrl_getAutoConvertClockRate(TInstantAiCtrl obj);                
   ErrorCode         BDAQCALL TInstantAiCtrl_setAutoConvertClockRate(TInstantAiCtrl obj, double value);  
   int32             BDAQCALL TInstantAiCtrl_getAutoConvertChannelStart(TInstantAiCtrl obj);             
   ErrorCode         BDAQCALL TInstantAiCtrl_setAutoConvertChannelStart(TInstantAiCtrl obj, int32 value);
   int32             BDAQCALL TInstantAiCtrl_getAutoConvertChannelCount(TInstantAiCtrl obj);             
   ErrorCode         BDAQCALL TInstantAiCtrl_setAutoConvertChannelCount(TInstantAiCtrl obj, int32 value);

   // ----------------------------------------------------------
   // BufferedAiCtrl
   // ----------------------------------------------------------
   /* BufferedAiCtrl methods */
   ErrorCode         BDAQCALL TBufferedAiCtrl_Prepare(TBufferedAiCtrl obj);                                        
   ErrorCode         BDAQCALL TBufferedAiCtrl_RunOnce(TBufferedAiCtrl obj);                                        
   ErrorCode         BDAQCALL TBufferedAiCtrl_Start(TBufferedAiCtrl obj);                                          
   ErrorCode         BDAQCALL TBufferedAiCtrl_Stop(TBufferedAiCtrl obj);                                           
   void              BDAQCALL TBufferedAiCtrl_Release(TBufferedAiCtrl obj);                                        
   int8              BDAQCALL TBufferedAiCtrl_GetBufferStatus(TBufferedAiCtrl obj, int32 *count, int32 *offset);   
   ErrorCode         BDAQCALL TBufferedAiCtrl_GetData(TBufferedAiCtrl obj, int32 dt, int32 count, void *buffer);   

   /* BufferedAiCtrl properties */
   void*             BDAQCALL TBufferedAiCtrl_getBuffer(TBufferedAiCtrl obj);                                      
   int32             BDAQCALL TBufferedAiCtrl_getBufferCapacity(TBufferedAiCtrl obj);                              
   TScanChannel      BDAQCALL TBufferedAiCtrl_getScanChannel(TBufferedAiCtrl obj);                                 
   TConvertClock     BDAQCALL TBufferedAiCtrl_getConvertClock(TBufferedAiCtrl obj);                                
   TScanClock        BDAQCALL TBufferedAiCtrl_getScanClock(TBufferedAiCtrl obj);                                   
   TTrigger          BDAQCALL TBufferedAiCtrl_getTrigger(TBufferedAiCtrl obj, int32 trigger);                      
   int8              BDAQCALL TBufferedAiCtrl_getStreaming(TBufferedAiCtrl obj);                                   
   ErrorCode         BDAQCALL TBufferedAiCtrl_setStreaming(TBufferedAiCtrl obj, int8 value);                       

   // ----------------------------------------------------------
   // WaveformAiCtrl
   // ----------------------------------------------------------
   /* WaveformAiCtrl methods */
   ErrorCode         BDAQCALL TWaveformAiCtrl_Prepare(TWaveformAiCtrl obj);                                      
   ErrorCode         BDAQCALL TWaveformAiCtrl_Start(TWaveformAiCtrl obj);                                        
   ErrorCode         BDAQCALL TWaveformAiCtrl_Stop(TWaveformAiCtrl obj);                                         
   void              BDAQCALL TWaveformAiCtrl_Release(TWaveformAiCtrl obj);                                      
   int8              BDAQCALL TWaveformAiCtrl_GetBufferStatus(TWaveformAiCtrl obj, int32 *count, int32 *offset); 
   
   ErrorCode BDAQCALL TWaveformAiCtrl_GetData(TWaveformAiCtrl obj, int32 dt, int32 count, void *buffer, 
      int32 timeout, int32 *returned, double * startTime, int32 *markCount, DataMark *markBuf);
   
   
   /* WaveformAiCtrl properties */
   void*             BDAQCALL TWaveformAiCtrl_getBuffer(TWaveformAiCtrl obj);                                   
   int32             BDAQCALL TWaveformAiCtrl_getBufferCapacity(TWaveformAiCtrl obj);                           
   TConversion       BDAQCALL TWaveformAiCtrl_getConversion(TWaveformAiCtrl obj);                               
   TRecord           BDAQCALL TWaveformAiCtrl_getRecord(TWaveformAiCtrl obj);                                   
   TTrigger          BDAQCALL TWaveformAiCtrl_getTrigger(TWaveformAiCtrl obj, int32 trigger);                   

   // **********************************************************
   // ctrl class : AO related
   // ----------------------------------------------------------
   // AoChannel
   // ----------------------------------------------------------
   int32             BDAQCALL TAoChannel_getChannel(TAoChannel obj);                      
   ValueRange        BDAQCALL TAoChannel_getValueRange(TAoChannel obj);                   
   ErrorCode         BDAQCALL TAoChannel_setValueRange(TAoChannel obj, ValueRange value); 
   double            BDAQCALL TAoChannel_getExtRefBipolar(TAoChannel obj);               
   ErrorCode         BDAQCALL TAoChannel_setExtRefBipolar(TAoChannel obj, double value); 
   double            BDAQCALL TAoChannel_getExtRefUnipolar(TAoChannel obj);              
   ErrorCode         BDAQCALL TAoChannel_setExtRefUnipolar(TAoChannel obj, double value);

   // new: scale table
   ErrorCode         BDAQCALL TAoChannel_getScaleTable(TAoChannel obj, int32 *size, MapFuncPiece table[]);
   ErrorCode         BDAQCALL TAoChannel_setScaleTable(TAoChannel obj, int32  size, MapFuncPiece table[]);

   // ----------------------------------------------------------
   // AO features
   // ----------------------------------------------------------
   // DAC features                                                               
   int32             BDAQCALL TAoFeatures_getResolution(TAoFeatures obj);                         
   int32             BDAQCALL TAoFeatures_getDataSize(TAoFeatures obj);                           
   int32             BDAQCALL TAoFeatures_getDataMask(TAoFeatures obj);                           
                                                                                                 
   // channel features                                                           
   int32             BDAQCALL TAoFeatures_getChannelCountMax(TAoFeatures obj);                    
   TArray            BDAQCALL TAoFeatures_getValueRanges(TAoFeatures obj);                        
   int8              BDAQCALL TAoFeatures_getExternalRefAntiPolar(TAoFeatures obj);               
   void              BDAQCALL TAoFeatures_getExternalRefRange(TAoFeatures obj, MathInterval *x);  

   // buffered ao->basic features                                                
   int8              BDAQCALL TAoFeatures_getBufferedAoSupported(TAoFeatures obj);                
   SamplingMethod    BDAQCALL TAoFeatures_getSamplingMethod(TAoFeatures obj);                     
   int32             BDAQCALL TAoFeatures_getChannelStartBase(TAoFeatures obj);                   
   int32             BDAQCALL TAoFeatures_getChannelCountBase(TAoFeatures obj);                   

   // buffered ao->conversion clock features                                     
   TArray            BDAQCALL TAoFeatures_getConvertClockSources(TAoFeatures obj);                
   void              BDAQCALL TAoFeatures_getConvertClockRange(TAoFeatures obj, MathInterval *x); 
                     
   // buffered ao->trigger features                                              
   int32             BDAQCALL TAoFeatures_getTriggerCount(TAoFeatures obj);                       
   int8              BDAQCALL TAoFeatures_getRetriggerable(TAoFeatures obj);                       

   // buffered ao->trigger0/1/.../x features  
   TArray            BDAQCALL TAoFeatures_getTriggerSources(TAoFeatures obj, int32 trigger);                     
   TArray            BDAQCALL TAoFeatures_getTriggerActions(TAoFeatures obj, int32 trigger);                     
   void              BDAQCALL TAoFeatures_getTriggerDelayRange(TAoFeatures obj, int32 trigger, MathInterval *x); 

   // ----------------------------------------------------------
   // AoCtrlBase
   // ----------------------------------------------------------
   /* AoCtrlBase Methods*/

   /* AoCtrlBase Properties*/
   TAoFeatures       BDAQCALL TAoCtrlBase_getFeatures(TAoCtrlBase obj);                            
   TArray            BDAQCALL TAoCtrlBase_getChannels(TAoCtrlBase obj);                            
   int32             BDAQCALL TAoCtrlBase_getChannelCount(TAoCtrlBase obj);                        
   double            BDAQCALL TAoCtrlBase_getExtRefValueForUnipolar(TAoCtrlBase obj);              
   ErrorCode         BDAQCALL TAoCtrlBase_setExtRefValueForUnipolar(TAoCtrlBase obj, double value);
   double            BDAQCALL TAoCtrlBase_getExtRefValueForBipolar(TAoCtrlBase obj);               
   ErrorCode         BDAQCALL TAoCtrlBase_setExtRefValueForBipolar(TAoCtrlBase obj, double value); 

   // ----------------------------------------------------------
   // InstantAoCtrl
   // ----------------------------------------------------------
   /* InstantAoCtrl methods */
   ErrorCode         BDAQCALL TInstantAoCtrl_WriteAny(TInstantAoCtrl obj, int32 chStart, int32 chCount, void *dataRaw, double *dataScaled); 

   // ----------------------------------------------------------
   // BufferedAoCtrl
   // ----------------------------------------------------------
   /* BufferedAoCtrl methods */
   ErrorCode         BDAQCALL TBufferedAoCtrl_Prepare(TBufferedAoCtrl obj);                                      
   ErrorCode         BDAQCALL TBufferedAoCtrl_RunOnce(TBufferedAoCtrl obj);                                      
   ErrorCode         BDAQCALL TBufferedAoCtrl_Start(TBufferedAoCtrl obj);                                        
   ErrorCode         BDAQCALL TBufferedAoCtrl_Stop(TBufferedAoCtrl obj, int32 action);                           
   void              BDAQCALL TBufferedAoCtrl_Release(TBufferedAoCtrl obj);                                      
   int8              BDAQCALL TBufferedAoCtrl_GetBufferStatus(TBufferedAoCtrl obj, int32 *count, int32 *offset); 
   ErrorCode         BDAQCALL TBufferedAoCtrl_SetData(TBufferedAoCtrl obj, int32 dt, int32 count, void *buffer); 

   /* BufferedAoCtrl properties */
   void*             BDAQCALL TBufferedAoCtrl_getBuffer(TBufferedAoCtrl obj);                                    
   int32             BDAQCALL TBufferedAoCtrl_getBufferCapacity(TBufferedAoCtrl obj);                            
   TScanChannel      BDAQCALL TBufferedAoCtrl_getScanChannel(TBufferedAoCtrl obj);                               
   TConvertClock     BDAQCALL TBufferedAoCtrl_getConvertClock(TBufferedAoCtrl obj);                              
   TTrigger          BDAQCALL TBufferedAoCtrl_getTrigger(TBufferedAoCtrl obj, int32 trigger);                    
   int8              BDAQCALL TBufferedAoCtrl_getStreaming(TBufferedAoCtrl obj);                                 
   ErrorCode         BDAQCALL TBufferedAoCtrl_setStreaming(TBufferedAoCtrl obj, int8 value);                     

   // **********************************************************
   // ctrl class : DIO related classes
   // ----------------------------------------------------------
   // DioPort
   // ----------------------------------------------------------
   int32             BDAQCALL TDioPort_getPort(TDioPort obj);                       
   DioPortDir        BDAQCALL TDioPort_getDirection(TDioPort obj);                  
   ErrorCode         BDAQCALL TDioPort_setDirection(TDioPort obj, DioPortDir value);
   // DI port property 
   uint8             BDAQCALL TDioPort_getDiInversePort(TDioPort obj);              
   ErrorCode         BDAQCALL TDioPort_setDiInversePort(TDioPort obj, uint8 value);  
   uint8             BDAQCALL TDioPort_getDiOpenState(TDioPort obj);              
   ErrorCode         BDAQCALL TDioPort_setDiOpenState(TDioPort obj, uint8 value);  
   // DO port property
   uint8             BDAQCALL TDioPort_getDoPresetValue(TDioPort obj);
   ErrorCode         BDAQCALL TDioPort_setDoPresetValue(TDioPort obj, uint8 value);
   DoCircuitType     BDAQCALL TDioPort_getDoCircuitType(TDioPort obj);                  
   ErrorCode         BDAQCALL TDioPort_setDoCircuitType(TDioPort obj, DoCircuitType value);

   // ----------------------------------------------------------
   // DiintChannel
   // ----------------------------------------------------------
   int32             BDAQCALL TDiintChannel_getChannel(TDiintChannel obj);                     
   int8              BDAQCALL TDiintChannel_getEnabled(TDiintChannel obj);                     
   ErrorCode         BDAQCALL TDiintChannel_setEnabled(TDiintChannel obj, int8 value);         
   int8              BDAQCALL TDiintChannel_getGated(TDiintChannel obj);                       
   ErrorCode         BDAQCALL TDiintChannel_setGated(TDiintChannel obj, int8 value);           
   ActiveSignal      BDAQCALL TDiintChannel_getTrigEdge(TDiintChannel obj);                    
   ErrorCode         BDAQCALL TDiintChannel_setTrigEdge(TDiintChannel obj, ActiveSignal value);
                     
   // ----------------------------------------------------------
   // DiCosintPort
   // ----------------------------------------------------------
   int32             BDAQCALL TDiCosintPort_getPort(TDiCosintPort obj);              
   uint8             BDAQCALL TDiCosintPort_getMask(TDiCosintPort obj);              
   ErrorCode         BDAQCALL TDiCosintPort_setMask(TDiCosintPort obj, uint8 value); 

   // ----------------------------------------------------------
   // DiPmintPort
   // ----------------------------------------------------------
   int32             BDAQCALL TDiPmintPort_getPort(TDiPmintPort obj);                
   uint8             BDAQCALL TDiPmintPort_getMask(TDiPmintPort obj);                
   ErrorCode         BDAQCALL TDiPmintPort_setMask(TDiPmintPort obj, uint8 value);   
   uint8             BDAQCALL TDiPmintPort_getPattern(TDiPmintPort obj);             
   ErrorCode         BDAQCALL TDiPmintPort_setPattern(TDiPmintPort obj, uint8 value);

   // ----------------------------------------------------------
   // DIO features
   // ----------------------------------------------------------
   // Common
   int8              BDAQCALL TDioFeatures_getPortProgrammable(TDioFeatures obj); 
   int32             BDAQCALL TDioFeatures_getChannelCountMax(TDioFeatures obj);  
   int32             BDAQCALL TDioFeatures_getPortCount(TDioFeatures obj);        
   TArray            BDAQCALL TDioFeatures_getPortsType(TDioFeatures obj);        
   int8              BDAQCALL TDioFeatures_getDiSupported(TDioFeatures obj);      
   int8              BDAQCALL TDioFeatures_getDoSupported(TDioFeatures obj);      

   // DI Features
   TArray            BDAQCALL TDioFeatures_getDiDataMask(TDioFeatures obj);       

   // di noise filter features                                                            
   int8              BDAQCALL TDioFeatures_getDiNoiseFilterSupported(TDioFeatures obj);                       
   TArray            BDAQCALL TDioFeatures_getDiNoiseFilterOfChannels(TDioFeatures obj);                      
   void              BDAQCALL TDioFeatures_getDiNoiseFilterBlockTimeRange(TDioFeatures obj, MathInterval *x); 

   // di interrupt features                                                               
   int8              BDAQCALL TDioFeatures_getDiintSupported(TDioFeatures obj);     
   int8              BDAQCALL TDioFeatures_getDiintGateSupported(TDioFeatures obj); 
   int8              BDAQCALL TDioFeatures_getDiCosintSupported(TDioFeatures obj);  
   int8              BDAQCALL TDioFeatures_getDiPmintSupported(TDioFeatures obj);   
   TArray            BDAQCALL TDioFeatures_getDiintTriggerEdges(TDioFeatures obj);  
   TArray            BDAQCALL TDioFeatures_getDiintOfChannels(TDioFeatures obj);    
   TArray            BDAQCALL TDioFeatures_getDiintGateOfChannels(TDioFeatures obj);
   TArray            BDAQCALL TDioFeatures_getDiCosintOfPorts(TDioFeatures obj);    
   TArray            BDAQCALL TDioFeatures_getDiPmintOfPorts(TDioFeatures obj);     
   TArray            BDAQCALL TDioFeatures_getDiSnapEventSources(TDioFeatures obj); 

   // DO features
   TArray            BDAQCALL TDioFeatures_getDoDataMask(TDioFeatures obj);                                     
   TArray            BDAQCALL TDioFeatures_getDoFreezeSignalSources(TDioFeatures obj);                          
   void              BDAQCALL TDioFeatures_getDoReflectWdtFeedIntervalRange(TDioFeatures obj, MathInterval *x); 
   Depository        BDAQCALL TDioFeatures_getDoPresetValueDepository(TDioFeatures obj); 
   TArray            BDAQCALL TDioFeatures_getDoCircuitSelectableTypes(TDioFeatures obj);

   //buffered dio common
   int32             BDAQCALL TDioFeatures_getDataSize(TDioFeatures obj);  
   int32             BDAQCALL TDioFeatures_getResolution(TDioFeatures obj);
   
   //buffered dio feature
   int8              BDAQCALL TDioFeatures_getBufferedDiSupported(TDioFeatures obj); 
   SamplingMethod    BDAQCALL TDioFeatures_getDiSamplingMethod(TDioFeatures obj);  
   int8              BDAQCALL TDioFeatures_getBufferedDoSupported(TDioFeatures obj); 
   SamplingMethod    BDAQCALL TDioFeatures_getDoSamplingMethod(TDioFeatures obj); 
    
   // buffered dio->conversion clock features
   TArray            BDAQCALL TDioFeatures_getDiConvertClockSources(TDioFeatures obj);                    
   void              BDAQCALL TDioFeatures_getDiConvertClockRange(TDioFeatures obj, MathInterval *value);
   TArray            BDAQCALL TDioFeatures_getDoConvertClockSources(TDioFeatures obj); 
   void              BDAQCALL TDioFeatures_getDoConvertClockRange(TDioFeatures obj, MathInterval *value);

   // buffered di->trigger features
   int32             BDAQCALL TDioFeatures_getDiTriggerCount(TDioFeatures obj);                        
   int8              BDAQCALL TDioFeatures_getDiRetriggerable(TDioFeatures obj);  
   TArray            BDAQCALL TDioFeatures_getDiTriggerActions(TDioFeatures obj, int32 trigger);                     
   void              BDAQCALL TDioFeatures_getDiTriggerDelayRange(TDioFeatures obj, int32 trigger, MathInterval *x); 
   TArray            BDAQCALL TDioFeatures_getDiTriggerSources(TDioFeatures obj, int32 trigger);                     
   ValueRange        BDAQCALL TDioFeatures_getDiTriggerSourceVrg(TDioFeatures obj, int32 trigger);                   
   double            BDAQCALL TDioFeatures_getDiTriggerHysteresisIndexMax(TDioFeatures obj, int32 trigger);          
   int32             BDAQCALL TDioFeatures_getDiTriggerHysteresisIndexStep(TDioFeatures obj, int32 trigger);       

   // buffered do->trigger features
   int32             BDAQCALL TDioFeatures_getDoTriggerCount(TDioFeatures obj);                        
   int8              BDAQCALL TDioFeatures_getDoRetriggerable(TDioFeatures obj);  
   TArray            BDAQCALL TDioFeatures_getDoTriggerActions(TDioFeatures obj, int32 trigger);                     
   void              BDAQCALL TDioFeatures_getDoTriggerDelayRange(TDioFeatures obj, int32 trigger, MathInterval *x); 
   TArray            BDAQCALL TDioFeatures_getDoTriggerSources(TDioFeatures obj, int32 trigger);                     
   ValueRange        BDAQCALL TDioFeatures_getDoTriggerSourceVrg(TDioFeatures obj, int32 trigger);                   
   double            BDAQCALL TDioFeatures_getDoTriggerHysteresisIndexMax(TDioFeatures obj, int32 trigger);          
   int32             BDAQCALL TDioFeatures_getDoTriggerHysteresisIndexStep(TDioFeatures obj, int32 trigger);

   // ----------------------------------------------------------
   // DioCtrlBase
   // ----------------------------------------------------------
   /* Methods derived from DioCtrlBase */
   TDioFeatures      BDAQCALL TDioCtrlBase_getFeatures(TDioCtrlBase obj);  
   int32             BDAQCALL TDioCtrlBase_getPortCount(TDioCtrlBase obj); 
   TArray            BDAQCALL TDioCtrlBase_getPorts(TDioCtrlBase obj);     

   // ----------------------------------------------------------
   // InstantDiCtrl
   // ----------------------------------------------------------
   /* Instant DI methods */
   ErrorCode         BDAQCALL TInstantDiCtrl_ReadAny(TInstantDiCtrl obj, int32 portStart, int32 portCount, uint8 data[]); 
   ErrorCode         BDAQCALL TInstantDiCtrl_ReadBit(TInstantDiCtrl obj, int32 port, int32 bit, uint8* data);             
   ErrorCode         BDAQCALL TInstantDiCtrl_SnapStart(TInstantDiCtrl obj);                                               
   ErrorCode         BDAQCALL TInstantDiCtrl_SnapStop(TInstantDiCtrl obj);                                                

   /* Instant DI properties */
   double            BDAQCALL TInstantDiCtrl_getNoiseFilterBlockTime(TInstantDiCtrl obj);               
   ErrorCode         BDAQCALL TInstantDiCtrl_setNoiseFilterBlockTime(TInstantDiCtrl obj, double value); 
   TArray            BDAQCALL TInstantDiCtrl_getNoiseFilter(TInstantDiCtrl obj);                        
   TArray            BDAQCALL TInstantDiCtrl_getDiintChannels(TInstantDiCtrl obj);                      
   TArray            BDAQCALL TInstantDiCtrl_getDiCosintPorts(TInstantDiCtrl obj);                      
   TArray            BDAQCALL TInstantDiCtrl_getDiPmintPorts(TInstantDiCtrl obj);                       

   // ----------------------------------------------------------
   // InstantDoCtrl
   // ----------------------------------------------------------
   /* Instant DO methods */
   ErrorCode         BDAQCALL TInstantDoCtrl_WriteAny(TInstantDoCtrl obj, int32 portStart, int32 portCount, uint8 data[]);
   ErrorCode         BDAQCALL TInstantDoCtrl_ReadAny(TInstantDoCtrl obj, int32 portStart, int32 portCount, uint8 data[]); 
   ErrorCode         BDAQCALL TInstantDoCtrl_WriteBit(TInstantDoCtrl obj, int32 port, int32 bit, uint8 data);             
   ErrorCode         BDAQCALL TInstantDoCtrl_ReadBit(TInstantDoCtrl obj, int32 port, int32 bit, uint8* data);   

   // ----------------------------------------------------------
   // BufferedDiCtrl
   // ----------------------------------------------------------
   /* BufferedDiCtrl methods */
   ErrorCode         BDAQCALL TBufferedDiCtrl_Prepare(TBufferedDiCtrl obj);                                      
   ErrorCode         BDAQCALL TBufferedDiCtrl_Start(TBufferedDiCtrl obj);                                        
   ErrorCode         BDAQCALL TBufferedDiCtrl_Stop(TBufferedDiCtrl obj);                                         
   void              BDAQCALL TBufferedDiCtrl_Release(TBufferedDiCtrl obj);                                      
   int8              BDAQCALL TBufferedDiCtrl_GetBufferStatus(TBufferedDiCtrl obj, int32 *count, int32 *offset); 

   ErrorCode BDAQCALL TBufferedDiCtrl_GetData(TBufferedDiCtrl obj, int32 count, void *buffer, 
      int32 timeout, int32 *returned, double * startTime, int32 *markCount, DataMark *markBuf);

   /* BufferedDiCtrl properties */
   void*             BDAQCALL TBufferedDiCtrl_getBuffer(TBufferedDiCtrl obj);                                   
   int32             BDAQCALL TBufferedDiCtrl_getBufferCapacity(TBufferedDiCtrl obj); 
   TScanPort         BDAQCALL TBufferedDiCtrl_getScanPort(TBufferedDiCtrl obj);                               
   TConvertClock     BDAQCALL TBufferedDiCtrl_getConvertClock(TBufferedDiCtrl obj);                           
   TTrigger          BDAQCALL TBufferedDiCtrl_getTrigger(TBufferedDiCtrl obj, int32 trigger);                   
   
   // ----------------------------------------------------------
   // BufferedDoCtrl
   // ----------------------------------------------------------
   /* BufferedDoCtrl methods */
   ErrorCode         BDAQCALL TBufferedDoCtrl_Prepare(TBufferedDoCtrl obj);                                      
   ErrorCode         BDAQCALL TBufferedDoCtrl_RunOnce(TBufferedDoCtrl obj);                                      
   ErrorCode         BDAQCALL TBufferedDoCtrl_Start(TBufferedDoCtrl obj);                                        
   ErrorCode         BDAQCALL TBufferedDoCtrl_Stop(TBufferedDoCtrl obj, int32 action);                           
   void              BDAQCALL TBufferedDoCtrl_Release(TBufferedDoCtrl obj);                                      
   int8              BDAQCALL TBufferedDoCtrl_GetBufferStatus(TBufferedDoCtrl obj, int32 *count, int32 *offset); 
   ErrorCode         BDAQCALL TBufferedDoCtrl_SetData(TBufferedDoCtrl obj, int32 count, void *buffer); 

   /* BufferedDoCtrl properties */
   void*             BDAQCALL TBufferedDoCtrl_getBuffer(TBufferedDoCtrl obj);                                    
   int32             BDAQCALL TBufferedDoCtrl_getBufferCapacity(TBufferedDoCtrl obj);                            
   TScanPort         BDAQCALL TBufferedDoCtrl_getScanPort(TBufferedDoCtrl obj);                               
   TConvertClock     BDAQCALL TBufferedDoCtrl_getConvertClock(TBufferedDoCtrl obj);                              
   TTrigger          BDAQCALL TBufferedDoCtrl_getTrigger(TBufferedDoCtrl obj, int32 trigger);                    

   // ----------------------------------------------------------
   // common classes : ScanPort
   // ----------------------------------------------------------
   int32             BDAQCALL TScanPort_getPortStart(TScanPort obj);               
   ErrorCode         BDAQCALL TScanPort_setPortStart(TScanPort obj, int32 value);  
   int32             BDAQCALL TScanPort_getPortCount(TScanPort obj);               
   ErrorCode         BDAQCALL TScanPort_setPortCount(TScanPort obj, int32 value);  
   void              BDAQCALL TScanPort_getPortMap(TScanPort obj, int32 count, int8 *portMap);
   ErrorCode         BDAQCALL TScanPort_setPortMap(TScanPort obj, int32 count, int8 *portMap);
   int32             BDAQCALL TScanPort_getSectionLength(TScanPort obj);                      
   ErrorCode         BDAQCALL TScanPort_setSectionLength(TScanPort obj, int32 value);         
   int32             BDAQCALL TScanPort_getSectionCount(TScanPort obj);                       
   ErrorCode         BDAQCALL TScanPort_setSectionCount(TScanPort obj, int32 value);          
   int32             BDAQCALL TScanPort_getCycles(TScanPort obj);                             
   ErrorCode         BDAQCALL TScanPort_setCycles(TScanPort obj, int32 value);  

   // **********************************************************
   // ctrl class : Counter related
   // ----------------------------------------------------------
   // Counter Indexer
   // ----------------------------------------------------------
   void              BDAQCALL TCounterIndexer_Dispose(TCounterIndexer obj);                
   int32             BDAQCALL TCounterIndexer_getLength(TCounterIndexer obj);               
   TArray            BDAQCALL TCounterIndexer_getItem(TCounterIndexer obj, int32 channel); 

   // ----------------------------------------------------------
   // Counter features
   // ----------------------------------------------------------
   // Channel features
   int32             BDAQCALL TCntrFeatures_getChannelCountMax(TCntrFeatures obj); 
   int32             BDAQCALL TCntrFeatures_getResolution(TCntrFeatures obj);      
   int32             BDAQCALL TCntrFeatures_getDataSize(TCntrFeatures obj);        
   TCounterIndexer   BDAQCALL TCntrFeatures_getCapabilities(TCntrFeatures obj);    

   // noise filter features
   int8              BDAQCALL TCntrFeatures_getNoiseFilterSupported(TCntrFeatures obj);                      
   TArray            BDAQCALL TCntrFeatures_getNoiseFilterOfChannels(TCntrFeatures obj);                     
   void              BDAQCALL TCntrFeatures_getNoiseFilterBlockTimeRange(TCntrFeatures obj, MathInterval *x);

   // new: measurement timeout range
   void              BDAQCALL TCntrFeatures_getMeasurementTimeoutRange(TCntrFeatures obj, MathInterval *x);
                     
   // event counting features
   TCounterIndexer   BDAQCALL TCntrFeatures_getEcClockSources(TCntrFeatures obj);                    
   TArray            BDAQCALL TCntrFeatures_getEcClockPolarities(TCntrFeatures obj);                 
   TArray            BDAQCALL TCntrFeatures_getEcGatePolarities(TCntrFeatures obj);                  
   TArray            BDAQCALL TCntrFeatures_getEcGateControlOfChannels(TCntrFeatures obj);           
                     
   // frequency measurement features
   TArray            BDAQCALL TCntrFeatures_getFmMethods(TCntrFeatures obj);                         

   // one-shot features
   TCounterIndexer   BDAQCALL TCntrFeatures_getOsClockSources(TCntrFeatures obj);                    
   TArray            BDAQCALL TCntrFeatures_getOsClockPolarities(TCntrFeatures obj);                 
   TCounterIndexer   BDAQCALL TCntrFeatures_getOsGateSources(TCntrFeatures obj);                     
   TArray            BDAQCALL TCntrFeatures_getOsGatePolarities(TCntrFeatures obj);                  
   TArray            BDAQCALL TCntrFeatures_getOsOutSignals(TCntrFeatures obj);                      
   void              BDAQCALL TCntrFeatures_getOsDelayCountRange(TCntrFeatures obj, MathInterval *x);

   // timer/pulse features
   TArray            BDAQCALL TCntrFeatures_getTmrGateControlOfChannels(TCntrFeatures obj);          
   TArray            BDAQCALL TCntrFeatures_getTmrGatePolarities(TCntrFeatures obj);                 
   TArray            BDAQCALL TCntrFeatures_getTmrOutSignals(TCntrFeatures obj);                     
   void              BDAQCALL TCntrFeatures_getTmrFrequencyRange(TCntrFeatures obj, MathInterval *x);
                     
   // pulse width measurement features
   TArray            BDAQCALL TCntrFeatures_getPiCascadeGroup(TCntrFeatures obj);                   

   // pulse width modulation features
   TArray            BDAQCALL TCntrFeatures_getPoGateControlOfChannels(TCntrFeatures obj);          
   TArray            BDAQCALL TCntrFeatures_getPoGatePolarities(TCntrFeatures obj);                 
   TArray            BDAQCALL TCntrFeatures_getPoOutSignals(TCntrFeatures obj);                     
   void              BDAQCALL TCntrFeatures_getPoHiPeriodRange(TCntrFeatures obj, MathInterval *x);  
   void              BDAQCALL TCntrFeatures_getPoLoPeriodRange(TCntrFeatures obj, MathInterval *x);  
   void              BDAQCALL TCntrFeatures_getPoOutCountRange(TCntrFeatures obj, MathInterval *x); 

   // new: trigger features for pulse width modulation
   int32             BDAQCALL TCntrFeatures_getPoTriggerCount(TCntrFeatures obj);
   TArray            BDAQCALL TCntrFeatures_getPoTriggerSources(TCntrFeatures obj);
   TArray            BDAQCALL TCntrFeatures_getPoTriggerActions(TCntrFeatures obj);
   void              BDAQCALL TCntrFeatures_getPoTriggerDelayRange(TCntrFeatures obj, MathInterval *x);

   // up-down counter features
   TArray            BDAQCALL TCntrFeatures_getUdCountingTypes(TCntrFeatures obj);                  
   TArray            BDAQCALL TCntrFeatures_getUdInitialValues(TCntrFeatures obj);                  
   TArray            BDAQCALL TCntrFeatures_getUdSnapEventSources(TCntrFeatures obj);               
   void              BDAQCALL TCntrFeatures_getUdValueResetTimes(TCntrFeatures obj, MathInterval *x); 

   // new features for Counter continue comparing: outputting pulse settings
   TArray            BDAQCALL TCntrFeatures_getCcpGateControlOfChannels(TCntrFeatures obj);          
   TArray            BDAQCALL TCntrFeatures_getCcpGatePolarities(TCntrFeatures obj);                 
   TArray            BDAQCALL TCntrFeatures_getCcpOutSignals(TCntrFeatures obj);                     
   void              BDAQCALL TCntrFeatures_getCcpHiPeriodRange(TCntrFeatures obj, MathInterval *x);  
   void              BDAQCALL TCntrFeatures_getCcpLoPeriodRange(TCntrFeatures obj, MathInterval *x);  
   void              BDAQCALL TCntrFeatures_getCcpOutCountRange(TCntrFeatures obj, MathInterval *x); 

   // buffered counter features
   int32             BDAQCALL TCntrFeatures_getTriggerCount        (TCntrFeatures obj);
   TArray            BDAQCALL TCntrFeatures_getTriggerActions      (TCntrFeatures obj, int32 trigger);
   TArray            BDAQCALL TCntrFeatures_getTriggerSources      (TCntrFeatures obj, int32 trigger);
   TArray            BDAQCALL TCntrFeatures_getSamplingClockSources(TCntrFeatures obj);
   TCounterIndexer   BDAQCALL TCntrFeatures_getEcSampleClockSources(TCntrFeatures obj);
   TCounterIndexer   BDAQCALL TCntrFeatures_getPiSampleClockSources(TCntrFeatures obj);
   TCounterIndexer   BDAQCALL TCntrFeatures_getPoSampleClockSources(TCntrFeatures obj);
   TCounterIndexer   BDAQCALL TCntrFeatures_getUdSampleClockSources(TCntrFeatures obj);

   
   // ----------------------------------------------------------
   // CntrCtrlBase
   // ----------------------------------------------------------
   /* Methods */
   TCntrFeatures     BDAQCALL TCntrCtrlBase_getFeatures(TCntrCtrlBase obj);                          
   int32             BDAQCALL TCntrCtrlBase_getChannelStart(TCntrCtrlBase obj);                      
   ErrorCode         BDAQCALL TCntrCtrlBase_setChannelStart(TCntrCtrlBase obj, int32 value);         
   int32             BDAQCALL TCntrCtrlBase_getChannelCount(TCntrCtrlBase obj);                      
   ErrorCode         BDAQCALL TCntrCtrlBase_setChannelCount(TCntrCtrlBase obj, int32 value);         
   int8              BDAQCALL TCntrCtrlBase_getEnabled(TCntrCtrlBase obj);                           
   ErrorCode         BDAQCALL TCntrCtrlBase_setEnabled(TCntrCtrlBase obj, int8 enabled);             
   int8              BDAQCALL TCntrCtrlBase_getRunning(TCntrCtrlBase obj);                           
   double            BDAQCALL TCntrCtrlBase_getNoiseFilterBlockTime(TCntrCtrlBase obj);              
   ErrorCode         BDAQCALL TCntrCtrlBase_setNoiseFilterBlockTime(TCntrCtrlBase obj, double value);
   TNosFltChannel    BDAQCALL TCntrCtrlBase_getNoiseFilter(TCntrCtrlBase obj);                       
   double            BDAQCALL TCntrCtrlBase_getMeasurementTimeout(TCntrCtrlBase obj);              
   ErrorCode         BDAQCALL TCntrCtrlBase_setMeasurementTimeout(TCntrCtrlBase obj, double value);

   // ----------------------------------------------------------
   // EcChannel
   // ----------------------------------------------------------
   int32             BDAQCALL TEcChannel_getChannel(TEcChannel obj);                                 
   int8              BDAQCALL TEcChannel_getNoiseFiltered(TEcChannel obj);                           
   ErrorCode         BDAQCALL TEcChannel_setNoiseFiltered(TEcChannel obj, int8 value);               
   SignalDrop        BDAQCALL TEcChannel_getClockSource(TEcChannel obj);                           
   ErrorCode         BDAQCALL TEcChannel_setClockSource(TEcChannel obj, SignalDrop value);     
   SignalPolarity    BDAQCALL TEcChannel_getClockPolarity(TEcChannel obj);                           
   ErrorCode         BDAQCALL TEcChannel_setClockPolarity(TEcChannel obj, SignalPolarity value);     
   SignalPolarity    BDAQCALL TEcChannel_getGatePolarity(TEcChannel obj);                            
   ErrorCode         BDAQCALL TEcChannel_setGatePolarity(TEcChannel obj, SignalPolarity value);      
   int8              BDAQCALL TEcChannel_getGated(TEcChannel obj);                                   
   ErrorCode         BDAQCALL TEcChannel_setGated(TEcChannel obj, int8 value);                       
                     
   // ----------------------------------------------------------
   // EventCounterCtrl
   // ----------------------------------------------------------
   /* Event counter methods */
   ErrorCode         BDAQCALL TEventCounterCtrl_Read(TEventCounterCtrl obj, int32 count, int32 *buffer); 
   TArray            BDAQCALL TEventCounterCtrl_getChannels(TEventCounterCtrl obj);                      

   // ----------------------------------------------------------
   // FmChannel
   // ----------------------------------------------------------
   int32             BDAQCALL TFmChannel_getChannel(TFmChannel obj);                           
   int8              BDAQCALL TFmChannel_getNoiseFiltered(TFmChannel obj);                     
   ErrorCode         BDAQCALL TFmChannel_setNoiseFiltered(TFmChannel obj, int8 value);         
   FreqMeasureMethod BDAQCALL TFmChannel_getFmMethod(TFmChannel obj);                          
   ErrorCode         BDAQCALL TFmChannel_setFmMethod(TFmChannel obj, FreqMeasureMethod value); 
   double            BDAQCALL TFmChannel_getCollectionPeriod(TFmChannel obj);                  
   ErrorCode         BDAQCALL TFmChannel_setCollectionPeriod(TFmChannel obj, double value);    

   // ----------------------------------------------------------
   // FreqMeterCtrl
   // ----------------------------------------------------------
   /* Frequency meter methods */
   ErrorCode         BDAQCALL TFreqMeterCtrl_Read(TFreqMeterCtrl obj, int32 count, double *buffer); 
   TArray            BDAQCALL TFreqMeterCtrl_getChannels(TFreqMeterCtrl obj);                       

   // ----------------------------------------------------------
   // OsChannel
   // ----------------------------------------------------------
   int32             BDAQCALL TOsChannel_getChannel(TOsChannel obj);                            
   int8              BDAQCALL TOsChannel_getNoiseFiltered(TOsChannel obj);                      
   ErrorCode         BDAQCALL TOsChannel_setNoiseFiltered(TOsChannel obj, int8 value);          
   int32             BDAQCALL TOsChannel_getDelayCount(TOsChannel obj);                         
   ErrorCode         BDAQCALL TOsChannel_setDelayCount(TOsChannel obj, int32 value);            
   SignalDrop        BDAQCALL TOsChannel_getClockSource(TOsChannel obj);                        
   ErrorCode         BDAQCALL TOsChannel_setClockSource(TOsChannel obj, SignalDrop value);      
   SignalPolarity    BDAQCALL TOsChannel_getClockPolarity(TOsChannel obj);                      
   ErrorCode         BDAQCALL TOsChannel_setClockPolarity(TOsChannel obj, SignalPolarity value);
   SignalDrop        BDAQCALL TOsChannel_getGateSource(TOsChannel obj);                         
   ErrorCode         BDAQCALL TOsChannel_setGateSource(TOsChannel obj, SignalDrop value);       
   SignalPolarity    BDAQCALL TOsChannel_getGatePolarity(TOsChannel obj);                       
   ErrorCode         BDAQCALL TOsChannel_setGatePolarity(TOsChannel obj, SignalPolarity value); 
   OutSignalType     BDAQCALL TOsChannel_getOutSignal(TOsChannel obj);                          
   ErrorCode         BDAQCALL TOsChannel_setOutSignal(TOsChannel obj, OutSignalType value);     

   // ----------------------------------------------------------
   // OneShotCtrl
   // ----------------------------------------------------------
   /* one shot methods */
   TArray            BDAQCALL TOneShotCtrl_getChannels(TOneShotCtrl obj);                       

   // ----------------------------------------------------------
   // TmrChannel
   // ----------------------------------------------------------
   int32             BDAQCALL TTmrChannel_getChannel(TTmrChannel obj);                            
   int8              BDAQCALL TTmrChannel_getNoiseFiltered(TTmrChannel obj);                      
   ErrorCode         BDAQCALL TTmrChannel_setNoiseFiltered(TTmrChannel obj, int8 value);          
   double            BDAQCALL TTmrChannel_getFrequency(TTmrChannel obj);                          
   ErrorCode         BDAQCALL TTmrChannel_setFrequency(TTmrChannel obj, double value);            
   int8              BDAQCALL TTmrChannel_getGated(TTmrChannel obj);                              
   ErrorCode         BDAQCALL TTmrChannel_setGated(TTmrChannel obj, int8 value);                  
   SignalPolarity    BDAQCALL TTmrChannel_getGatePolarity(TTmrChannel obj);                       
   ErrorCode         BDAQCALL TTmrChannel_setGatePolarity(TTmrChannel obj, SignalPolarity value); 
   OutSignalType     BDAQCALL TTmrChannel_getOutSignal(TTmrChannel obj);                          
   ErrorCode         BDAQCALL TTmrChannel_setOutSignal(TTmrChannel obj, OutSignalType value);     
                     
   // ----------------------------------------------------------
   // TimerPulseCtrl
   // ----------------------------------------------------------
   /* Timer/Pulse methods */
   TArray            BDAQCALL TTimerPulseCtrl_getChannels(TTimerPulseCtrl obj);             

   // ----------------------------------------------------------
   // PiChannel
   // ----------------------------------------------------------
   int32             BDAQCALL TPiChannel_getChannel(TPiChannel obj);                        
   int8              BDAQCALL TPiChannel_getNoiseFiltered(TPiChannel obj);                  
   ErrorCode         BDAQCALL TPiChannel_setNoiseFiltered(TPiChannel obj, int8 value);      

   // ----------------------------------------------------------
   // PwMeterCtrl
   // ----------------------------------------------------------
   /* PwMeterCtrl Method */
   TArray            BDAQCALL TPwMeterCtrl_getChannels(TPwMeterCtrl obj);                            
   ErrorCode         BDAQCALL TPwMeterCtrl_Read(TPwMeterCtrl obj, int32 count, PulseWidth *buffer);  

   // ----------------------------------------------------------
   // PoChannel
   // ----------------------------------------------------------
   int32             BDAQCALL TPoChannel_getChannel(TPoChannel obj);                            
   int8              BDAQCALL TPoChannel_getNoiseFiltered(TPoChannel obj);                      
   ErrorCode         BDAQCALL TPoChannel_setNoiseFiltered(TPoChannel obj, int8 value);          
   void              BDAQCALL TPoChannel_getPulseWidth(TPoChannel obj, PulseWidth *x);          
   ErrorCode         BDAQCALL TPoChannel_setPulseWidth(TPoChannel obj, PulseWidth *x);          
   int8              BDAQCALL TPoChannel_getGated(TPoChannel obj);                              
   ErrorCode         BDAQCALL TPoChannel_setGated(TPoChannel obj, int8 value);                  
   SignalPolarity    BDAQCALL TPoChannel_getGatePolarity(TPoChannel obj);                       
   ErrorCode         BDAQCALL TPoChannel_setGatePolarity(TPoChannel obj, SignalPolarity value); 
   OutSignalType     BDAQCALL TPoChannel_getOutSignal(TPoChannel obj);                          
   ErrorCode         BDAQCALL TPoChannel_setOutSignal(TPoChannel obj, OutSignalType value);     
   int32             BDAQCALL TPoChannel_getOutCount(TPoChannel obj);                           
   ErrorCode         BDAQCALL TPoChannel_setOutCount(TPoChannel obj, int32 value);              

   // new : trigger settings
   SignalDrop        BDAQCALL TPoChannel_getTriggerSource(TPoChannel obj);
   ErrorCode         BDAQCALL TPoChannel_setTriggerSource(TPoChannel obj, SignalDrop value);
   ActiveSignal      BDAQCALL TPoChannel_getTriggerEdge(TPoChannel obj);
   ErrorCode         BDAQCALL TPoChannel_setTriggerEdge(TPoChannel obj, ActiveSignal value);
   TriggerAction     BDAQCALL TPoChannel_getTriggerAction(TPoChannel obj);
   ErrorCode         BDAQCALL TPoChannel_setTriggerAction(TPoChannel obj, TriggerAction value);
   double            BDAQCALL TPoChannel_getTriggerDelayCount(TPoChannel obj);
   ErrorCode         BDAQCALL TPoChannel_setTriggerDelayCount(TPoChannel obj, double value);

   // ----------------------------------------------------------
   // PwModulatorCtrl
   // ----------------------------------------------------------
   /* Pulse width modulator methods */
   TArray            BDAQCALL TPwModulatorCtrl_getChannels(TPwModulatorCtrl obj);               

   // ----------------------------------------------------------
   // UdChannel
   // ----------------------------------------------------------
   int32             BDAQCALL TUdChannel_getChannel(TUdChannel obj);                            
   int8              BDAQCALL TUdChannel_getNoiseFiltered(TUdChannel obj);                      
   ErrorCode         BDAQCALL TUdChannel_setNoiseFiltered(TUdChannel obj, int8 value);          
   CountingType      BDAQCALL TUdChannel_getCountingType(TUdChannel obj);                       
   ErrorCode         BDAQCALL TUdChannel_setCountingType(TUdChannel obj, CountingType value);   
   int32             BDAQCALL TUdChannel_getInitialValue(TUdChannel obj);                       
   ErrorCode         BDAQCALL TUdChannel_setInitialValue(TUdChannel obj, int32 value);          
   int32             BDAQCALL TUdChannel_getResetTimesByIndex(TUdChannel obj);                  
   ErrorCode         BDAQCALL TUdChannel_setResetTimesByIndex(TUdChannel obj, int32 value);     

   // new properties for Counter continue comparing: outputting pulse settings
   void              BDAQCALL TUdChannel_getPulseWidth(TUdChannel obj, PulseWidth *x);          
   ErrorCode         BDAQCALL TUdChannel_setPulseWidth(TUdChannel obj, PulseWidth *x);          
   int8              BDAQCALL TUdChannel_getGated(TUdChannel obj);                              
   ErrorCode         BDAQCALL TUdChannel_setGated(TUdChannel obj, int8 value);                  
   SignalPolarity    BDAQCALL TUdChannel_getGatePolarity(TUdChannel obj);                       
   ErrorCode         BDAQCALL TUdChannel_setGatePolarity(TUdChannel obj, SignalPolarity value); 
   OutSignalType     BDAQCALL TUdChannel_getOutSignal(TUdChannel obj);                          
   ErrorCode         BDAQCALL TUdChannel_setOutSignal(TUdChannel obj, OutSignalType value);     
   int32             BDAQCALL TUdChannel_getOutCount(TUdChannel obj);                           
   ErrorCode         BDAQCALL TUdChannel_setOutCount(TUdChannel obj, int32 value);              

   // ----------------------------------------------------------
   // UdCounterCtrl
   // ----------------------------------------------------------
   /* UdCounterCtrl methods */
   ErrorCode         BDAQCALL TUdCounterCtrl_SnapStart(TUdCounterCtrl obj, int32 srcId);                                                      
   ErrorCode         BDAQCALL TUdCounterCtrl_SnapStop(TUdCounterCtrl obj, int32 srcId);                                                       
   ErrorCode         BDAQCALL TUdCounterCtrl_CompareSetTable(TUdCounterCtrl obj, int32 channel, int32 count, int32 *table);                   
   ErrorCode         BDAQCALL TUdCounterCtrl_CompareSetInterval(TUdCounterCtrl obj, int32 channel, int32 start, int32 increment,int32 count); 
   ErrorCode         BDAQCALL TUdCounterCtrl_CompareClear(TUdCounterCtrl obj, int32 channel);                                                 
   ErrorCode         BDAQCALL TUdCounterCtrl_ValueReset(TUdCounterCtrl obj);                                                                  
   ErrorCode         BDAQCALL TUdCounterCtrl_Read(TUdCounterCtrl obj, int32 count, int32 *buffer);                                            
   TArray            BDAQCALL TUdCounterCtrl_getChannels(TUdCounterCtrl obj);                                                                 

   // Buffered Event Counter
   // ----------------------------------------------------------
   /* Buffered Event Counter methods*/
   int32             BDAQCALL TBfdEcCtrl_getBufferCapacity(TBfdEventCounterCtrl obj);
   void              BDAQCALL TBfdEcCtrl_getChannelMap(TBfdEventCounterCtrl obj, int32 count, int8 *chMap);
   ErrorCode         BDAQCALL TBfdEcCtrl_setChannelMap(TBfdEventCounterCtrl obj, int32 count, int8 *chMap);
   TTrigger          BDAQCALL TBfdEcCtrl_getTrigger(TBfdEventCounterCtrl obj, int32 trigger);
   TRecord           BDAQCALL TBfdEcCtrl_getRecord(TBfdEventCounterCtrl obj);
   ErrorCode         BDAQCALL TBfdEcCtrl_setSampleClkSrc(TBfdEventCounterCtrl obj, SignalDrop drop);
   SignalDrop        BDAQCALL TBfdEcCtrl_getSampleClkSrc(TBfdEventCounterCtrl obj);
   TArray            BDAQCALL TBfdEcCtrl_getChannels(TBfdEventCounterCtrl obj);
   ErrorCode         BDAQCALL TBfdEcCtrl_Prepare(TBfdEventCounterCtrl obj);
   void              BDAQCALL TBfdEcCtrl_Release(TBfdEventCounterCtrl obj);
   ErrorCode         BDAQCALL TBfdEcCtrl_GetData(TBfdEventCounterCtrl obj, int32 cntr, int32 count, void *buffer, int32 timeout, int32 *returned, double *startTime);
   int8              BDAQCALL TBfdEcCtrl_getBufferStatus(TBfdEventCounterCtrl obj, int32 ch, int32 *count, int32 *offset);

   /* Buffered Pulse width meter methods*/
   int32             BDAQCALL TBfdPwMeterCtrl_getBufferCapacity(TBfdPwMeterCtrl obj); 
   void              BDAQCALL TBfdPwMeterCtrl_getChannelMap(TBfdPwMeterCtrl obj, int32 count, int8 *chMap);
   ErrorCode         BDAQCALL TBfdPwMeterCtrl_setChannelMap(TBfdPwMeterCtrl obj, int32 count, int8 *chMap);
   TTrigger          BDAQCALL TBfdPwMeterCtrl_getTrigger(TBfdPwMeterCtrl obj, int32 trigger);
   TRecord           BDAQCALL TBfdPwMeterCtrl_getRecord(TBfdPwMeterCtrl obj);
   ErrorCode         BDAQCALL TBfdPwMeterCtrl_setSampleClkSrc(TBfdPwMeterCtrl obj, SignalDrop drop);
   SignalDrop        BDAQCALL TBfdPwMeterCtrl_getSampleClkSrc(TBfdPwMeterCtrl obj);
   TArray            BDAQCALL TBfdPwMeterCtrl_getChannels(TBfdPwMeterCtrl obj);
   ErrorCode         BDAQCALL TBfdPwMeterCtrl_Prepare(TBfdPwMeterCtrl obj);
   void              BDAQCALL TBfdPwMeterCtrl_Release(TBfdPwMeterCtrl obj);
   ErrorCode         BDAQCALL TBfdPwMeterCtrl_GetData(TBfdPwMeterCtrl obj, int32 cntr, int32 count, void *buffer, int32 timeout, int32 *returned, double *startTime);
   int8              BDAQCALL TBfdPwMeterCtrl_getBufferStatus(TBfdPwMeterCtrl obj, int32 ch, int32 *count, int32 *offset);

   /* Buffered Up Down Counter methods*/
   int32             BDAQCALL TBfdUdCounterCtrl_getBufferCapacity(TBfdUdCounterCtrl obj); 
   void              BDAQCALL TBfdUdCounterCtrl_getChannelMap(TBfdUdCounterCtrl obj, int32 count, int8 *chMap);
   ErrorCode         BDAQCALL TBfdUdCounterCtrl_setChannelMap(TBfdUdCounterCtrl obj, int32 count, int8 *chMap);
   TTrigger          BDAQCALL TBfdUdCounterCtrl_getTrigger(TBfdUdCounterCtrl obj, int32 trigger);
   TRecord           BDAQCALL TBfdUdCounterCtrl_getRecord(TBfdUdCounterCtrl obj);
   ErrorCode         BDAQCALL TBfdUdCounterCtrl_setSampleClkSrc(TBfdUdCounterCtrl obj, SignalDrop drop);
   SignalDrop        BDAQCALL TBfdUdCounterCtrl_getSampleClkSrc(TBfdUdCounterCtrl obj);
   TArray            BDAQCALL TBfdUdCounterCtrl_getChannels(TBfdUdCounterCtrl obj);
   ErrorCode         BDAQCALL TBfdUdCounterCtrl_Prepare(TBfdUdCounterCtrl obj);
   void              BDAQCALL TBfdUdCounterCtrl_Release(TBfdUdCounterCtrl obj);
   ErrorCode         BDAQCALL TBfdUdCounterCtrl_GetData(TBfdUdCounterCtrl obj, int32 cntr, int32 count, void *buffer, int32 timeout, int32 *returned, double *startTime);
   int8              BDAQCALL TBfdUdCounterCtrl_getBufferStatus(TBfdUdCounterCtrl obj, int32 ch, int32 *count, int32 *offset);

   /* Buffered Pulse width modulator methods*/
   int32             BDAQCALL TBfdPwModulatorCtrl_getBufferCapacity(TBfdPwModulatorCtrl obj); 
   void              BDAQCALL TBfdPwModulatorCtrl_getChannelMap(TBfdPwModulatorCtrl obj, int32 count, int8 *chMap);
   ErrorCode         BDAQCALL TBfdPwModulatorCtrl_setChannelMap(TBfdPwModulatorCtrl obj, int32 count, int8 *chMap);
   TTrigger          BDAQCALL TBfdPwModulatorCtrl_getTrigger(TBfdPwModulatorCtrl obj, int32 trigger);

   int32             BDAQCALL TBfdPwModulatorCtrl_getSamples(TBfdPwModulatorCtrl obj);
   ErrorCode         BDAQCALL TBfdPwModulatorCtrl_setSamples(TBfdPwModulatorCtrl obj, int32 value);
   int32             BDAQCALL TBfdPwModulatorCtrl_getIntervalCount(TBfdPwModulatorCtrl obj);
   ErrorCode         BDAQCALL TBfdPwModulatorCtrl_setIntervalCount(TBfdPwModulatorCtrl obj, int32 value);

   ErrorCode         BDAQCALL TBfdPwModulatorCtrl_setSampleClkSrc(TBfdPwModulatorCtrl obj, SignalDrop drop);
   SignalDrop        BDAQCALL TBfdPwModulatorCtrl_getSampleClkSrc(TBfdPwModulatorCtrl obj);
   TArray            BDAQCALL TBfdPwModulatorCtrl_getChannels(TBfdPwModulatorCtrl obj);
   ErrorCode         BDAQCALL TBfdPwModulatorCtrl_Prepare(TBfdPwModulatorCtrl obj);
   void              BDAQCALL TBfdPwModulatorCtrl_Release(TBfdPwModulatorCtrl obj);
   ErrorCode         BDAQCALL TBfdPwModulatorCtrl_SetData(TBfdPwModulatorCtrl obj, int32 cntr, uint32 count, void *buffer);
   int8              BDAQCALL TBfdPwModulatorCtrl_getStreaming(TBfdPwModulatorCtrl obj);                                 
   ErrorCode         BDAQCALL TBfdPwModulatorCtrl_setStreaming(TBfdPwModulatorCtrl obj, int8 value); 
   int8              BDAQCALL TBfdPwModulatorCtrl_getBufferStatus(TBfdPwModulatorCtrl obj, int32 ch, int32 *count, int32 *offset); 


   // **********************************************************
   // ctrl class : calibration related
   // ----------------------------------------------------------
   // ----------------------------------------------------------
   // CaliSubject
   // ----------------------------------------------------------
   wchar_t const *   BDAQCALL TCaliSubject_getDescription(TCaliSubject obj);
   wchar_t const *   BDAQCALL TCaliSubject_getInstruction(TCaliSubject obj);
   wchar_t const *   BDAQCALL TCaliSubject_getTargetRange(TCaliSubject obj);

   CaliState         BDAQCALL TCaliSubject_AdjCodeGetCurrentState(TCaliSubject obj, double *value, uint32 *count, uint32 code[]);
   void              BDAQCALL TCaliSubject_AdjCodeGetRange(TCaliSubject obj, uint32 lower[], uint32 upper[]);
   ErrorCode         BDAQCALL TCaliSubject_ManualAdjStart(TCaliSubject obj);
   ErrorCode         BDAQCALL TCaliSubject_ManualAdjStop(TCaliSubject obj);
   ErrorCode         BDAQCALL TCaliSubject_ManualAdjSetCode(TCaliSubject obj, uint32 count, uint32 code[]);

   // ----------------------------------------------------------
   // CaliSection
   // ----------------------------------------------------------
   wchar_t const *   BDAQCALL TCaliSection_getTypeName(TCaliSection obj);
   wchar_t const *   BDAQCALL TCaliSection_getDescription(TCaliSection obj);
   wchar_t const *   BDAQCALL TCaliSection_getInstruction(TCaliSection obj);
   TArray            BDAQCALL TCaliSection_getSubjects(TCaliSection obj);       

   ErrorCode         BDAQCALL TCaliSection_Prepare(TCaliSection obj);
   ErrorCode         BDAQCALL TCaliSection_BatchStart(TCaliSection obj);               
   void              BDAQCALL TCaliSection_BatchTerminate(TCaliSection obj);  

   // ----------------------------------------------------------
   // CaliSolution
   // ----------------------------------------------------------
   wchar_t const *   BDAQCALL TCaliSolution_getTypeName(TCaliSolution obj);
   wchar_t const *   BDAQCALL TCaliSolution_getDescription(TCaliSolution obj);
   wchar_t const *   BDAQCALL TCaliSolution_getInstruction(TCaliSolution obj);
   uint8   const *   BDAQCALL TCaliSolution_getAuxiliaryImage(TCaliSolution obj, uint32 *size);
   TArray            BDAQCALL TCaliSolution_getSections(TCaliSolution obj);       

   ErrorCode         BDAQCALL TCaliSolution_AdjCodesSave(TCaliSolution obj);               
   ErrorCode         BDAQCALL TCaliSolution_AdjCodesLoad(TCaliSolution obj);               
   ErrorCode         BDAQCALL TCaliSolution_AdjCodesSaveToGoldBackup(TCaliSolution obj);              
   ErrorCode         BDAQCALL TCaliSolution_AdjCodesLoadFromGoldBackup(TCaliSolution obj, int32 action);

   // ----------------------------------------------------------
   // CalibrationCtrl
   // ----------------------------------------------------------
   TArray            BDAQCALL TCalibrationCtrl_getSolutions(TCalibrationCtrl obj);       

   // **********************************************************
   // ctrl class : firmware related
   // ----------------------------------------------------------
   // ----------------------------------------------------------
   // Firmware
   // ----------------------------------------------------------
   wchar_t const *   BDAQCALL TFirmware_getDescription(TFirmware obj);
   wchar_t const *   BDAQCALL TFirmware_getNotice(TFirmware obj);
   wchar_t const *   BDAQCALL TFirmware_getActivationTitle(TFirmware obj);
   wchar_t const *   BDAQCALL TFirmware_getVersionOnDevice(TFirmware obj);
   wchar_t const *   BDAQCALL TFirmware_getVersionOnFile(TFirmware obj);
   int32             BDAQCALL TFirmware_getOverwriteProgressing(TFirmware obj);       

   ErrorCode         BDAQCALL TFirmware_LoadFwFile(TFirmware obj, wchar_t const * filePath);               
   ErrorCode         BDAQCALL TFirmware_Overwrite(TFirmware obj, FwAction action, wchar_t const *activationCode);               

   // ----------------------------------------------------------
   // FirmwareCtrl
   // ----------------------------------------------------------
   TArray            BDAQCALL TFirmwareCtrl_getFirmwares(TFirmwareCtrl obj);       

#ifdef __cplusplus
}
#endif

#endif
