#ifndef _DAQNAVI_DI_INT_CHANNEL_IMPL_H
#define _DAQNAVI_DI_INT_CHANNEL_IMPL_H

class DioCtrlBaseImpl;

//*****
// CAUTION: SHARED WITH DN3, DONOT CHANGE THE CLASS LAYOUT AND METHODS(NAME,
// PARAMETERS, etc.). BUT YOU CAN APPEND NEW METHODS TO THE CLASS, IF NECESSARY.
//*****
class DiintChannelImpl
{
public:
   virtual int32        BDAQCALL getChannel();
   virtual bool         BDAQCALL getEnabled();
   virtual ErrorCode    BDAQCALL setEnabled(bool value);
   virtual bool         BDAQCALL getGated();
   virtual ErrorCode    BDAQCALL setGated(bool value);
   virtual ActiveSignal BDAQCALL getTrigEdge();
   virtual ErrorCode    BDAQCALL setTrigEdge(ActiveSignal value);

public:
   DiintChannelImpl(DioCtrlBaseImpl * owner = NULL, int tag = -1)
   {
      m_owner = owner;
      m_tag   = tag;
      m_intEnabled = 0;
   }

   void setOwner(DioCtrlBaseImpl * owner, int tag) 
   {
      m_owner = owner;
      m_tag   = tag;
   }

protected:
   DioCtrlBaseImpl *m_owner;
   int32           m_tag;
   uint8           m_intEnabled;  
};

#endif
