#ifndef _DAQNAVI_DIO_PORT_IMPL_H
#define _DAQNAVI_DIO_PORT_IMPL_H

class DioCtrlBaseImpl;

//*****
// CAUTION: SHARED WITH DN3, DONOT CHANGE THE CLASS LAYOUT AND METHODS(NAME,
// PARAMETERS, etc.). BUT YOU CAN APPEND NEW METHODS TO THE CLASS, IF NECESSARY.
//*****
class DioPortImpl
{
public:
   virtual int32      BDAQCALL getPort();
   virtual DioPortDir BDAQCALL getDirection();
   virtual ErrorCode  BDAQCALL setDirection(DioPortDir value);
   // DI port property
   virtual uint8      BDAQCALL getDiInversePort();
   virtual ErrorCode  BDAQCALL setDiInversePort(uint8 value);
   virtual uint8      BDAQCALL getDiOpenState();
   virtual ErrorCode  BDAQCALL setDiOpenState(uint8 value);
   // DO port property
   virtual uint8         BDAQCALL getDoPresetValue();
   virtual ErrorCode     BDAQCALL setDoPresetValue(uint8 value);
   virtual DoCircuitType BDAQCALL getDoCircuitType();
   virtual ErrorCode     BDAQCALL setDoCircuitType(DoCircuitType value);

public:
   DioPortImpl(DioCtrlBaseImpl * owner = NULL, int tag = -1, DioPortDir wanted = Input)
   {
      m_owner  = owner;
      m_tag    = tag;
      m_wanted = wanted;
   }

   void setOwner(DioCtrlBaseImpl * owner, int tag, DioPortDir wanted) 
   {
      m_owner  = owner;
      m_tag    = tag;
      m_wanted = wanted;
   }

protected:
   DioCtrlBaseImpl *m_owner;
   int32           m_tag;
   DioPortDir      m_wanted;
};

#endif
