#ifndef _DAQNAVI_DIO_TRIGGER_IMPL_H
#define _DAQNAVI_DIO_TRIGGER_IMPL_H

// -----------------------------------------------------------------
// implementation of Trigger, multi-trigger supported
// -----------------------------------------------------------------

class DioCtrlBaseImpl;

class DioTriggerImpl
{
public:
   SignalDrop     getSource();
   ErrorCode      setSource(SignalDrop value);
   ActiveSignal   getEdge();
   ErrorCode      setEdge(ActiveSignal value);
   double         getLevel();
   ErrorCode      setLevel(double value);
   TriggerAction  getAction();
   ErrorCode      setAction(TriggerAction value);
   int32          getDelayCount();
   ErrorCode      setDelayCount(int32 value);
                 
   double         getHysteresisIndex();
   ErrorCode      setHysteresisIndex(double value);

public:
   DioTriggerImpl(DioCtrlBaseImpl *owner = NULL, int32 tag = 0)
   {
      m_owner = owner;
      m_tag   = tag;
      m_trigDelayPerChan = 0;
   }
   void setOwner(DioCtrlBaseImpl *owner, int32 tag)
   {
      m_owner = owner;
      m_tag   = tag;
   }
   void adjustDelayCount(int32 value)
   {
      m_trigDelayPerChan = value;
   }

protected:
   DioCtrlBaseImpl *m_owner;
   int32           m_tag;
   int             m_trigDelayPerChan; // cached value which can not be mapped directly to a driver define property.
};

#endif

