#ifndef _DAQNAVI_SCAN_PORT_IMPL_H
#define _DAQNAVI_SCAN_PORT_IMPL_H

// -----------------------------------------------------------------
// implementation of ScanPort
// -----------------------------------------------------------------

class DioCtrlBaseImpl;

class ScanPortImpl
{
public:
   int32     getPortStart();
   ErrorCode setPortStart(int32 value);
   int32     getPortCount();
   ErrorCode setPortCount(int32 value);

   void      getPortMap(int32 count, int8 *data);
   ErrorCode setPortMap(int32 count, int8 *data);

   int32     getSectionLength();
   ErrorCode setSectionLength(int32 value);
   int32     getSectionCount();
   ErrorCode setSectionCount(int32 value);
   int32     getCycles();
   ErrorCode setCycles(int32 value);

public:
   ScanPortImpl(DioCtrlBaseImpl *owner = NULL) 
   { 
      m_owner = owner; 
   }
   void setOwner(DioCtrlBaseImpl *owner) 
   { 
      m_owner = owner; 
   }

private:
   DioCtrlBaseImpl * m_owner;

};

#endif

