#ifndef _DAQNAVI_CSCL_STD_DECL
#define _DAQNAVI_CSCL_STD_DECL

#if defined(_WIN32) || defined(WIN32)
#  include <windows.h>
#  include <vadefs.h>
#  include <io.h>
#  include <winioctl.h>
#else
#  include <stdio.h>
#  include <fcntl.h>
#  include <sys/ioctl.h>
#  include <sys/mman.h>
#  include <semaphore.h>
#endif

#include <stddef.h>
#include <assert.h>
#include <vector>
#include <map>
#include <string>
#include <algorithm>
#include <deque>
#include <clocale>

#define _BDAQ_NO_NAMESPACE
#define DAQNAVI_CORE
#include <bdaqctrl.h>
#include <bdaq_def.h>
#include <bdaq_util.h>
#include <lock.h>
#include <property_id.h>
#include <device_adaptor.h>

#include <oal.h>
#include <delegate.h>
#include <smart_ptr.h>
#include <thread.h>
#include <const.h>
#include <base/array.h>

#include <tinyxml.h>

#include <legacy/daqnavi3_adaptor.h>
#include <daq_property.h>
#include <xdev_factory.h>
#include <xdev_manager.h>
#include <xdev_enumerator.h>
#include <daq_event.h>

#include <base/event_monitor.h>
#include <base/device_ctrl.h>
#include <base/daq_ctrl_base.h>
#include <base/convert_clock.h>
#include <base/scan_clock.h>
#include <base/nos_flt_channel.h>
#include <base/trigger.h>
#include <base/scan_channel.h>
#include <base/conversion.h>
#include <base/record.h>
#include <base/bfd_cntr_record.h>
#include <base/bfd_cntr_trigger.h>

#endif
