#ifndef _DAQNAVI_EVENT_ACCESSOR_H
#define _DAQNAVI_EVENT_ACCESSOR_H

// **********************************************************
// helper class to access device event
// **********************************************************
class DaqEvent
{
public:
   DaqEvent(DaqModule *owner)
   {
      m_owner = owner;
   }
   DaqEvent(DaqModule &owner)
   {
      m_owner = &owner;
   }
   // ------------------------------------------------------------------------
   // Helpers for property access
   // ------------------------------------------------------------------------
   ErrorCode GetHandle(EventId id, HANDLE & eventHandle)
   {
      return m_owner->EventGetHandle(id, eventHandle);
   }
   
   ErrorCode GetStatus(EventId id, EventStatus &es)
   {
      return m_owner->EventGetStatus(id, es);
   }

   void ClearFlag(EventId id, uint32 lParam = 0, uint32 rParam = 0)
   {
      EventStatus flags;
      flags.Size = sizeof(flags);
      flags.General.lParam = lParam;
      flags.General.rParam = rParam;
      ClearFlag(id, flags);
   }
   void ClearFlag(EventId id, EventStatus &flags)
   {
      m_owner->EventClearFlag(id, flags);
   }
protected:
   DaqModule * m_owner;
};

#endif
