#include <bdaq_util.h>
#include <oal.h>
#include "functiontable.h"

// daqnavi3apistub.cpp : Default implementation of DAQNAVI3 APIS
//
#define BDAQ_API_DEF_IMPL(fn, args) \
   ErrorCode BDAQCALL fn##NotSpted args { return ErrorFuncNotSpted; }

#define BDAQ_API_DEF_IMPL_NOT_SPTED(fn) fn##NotSpted

BDAQ_API_DEF_IMPL(AdxGetLastError,              (HANDLE, wchar_t *, uint32, uint32*))  
BDAQ_API_DEF_IMPL(AdxEventGetHandle,            (HANDLE, uint32, HANDLE *))
BDAQ_API_DEF_IMPL(AdxEventGetLastStatus,        (HANDLE, uint32, uint32 *, uint32 *))
BDAQ_API_DEF_IMPL(AdxEventClearFlag,            (HANDLE, uint32, uint32, uint32))

BDAQ_API_DEF_IMPL(AdxPropertyRead,              (HANDLE, uint32, uint32, void *, uint32 *, uint32 *))
BDAQ_API_DEF_IMPL(AdxPropertyWrite,             (HANDLE, uint32, uint32, void *, uint32))

BDAQ_API_DEF_IMPL(AdxPropertyReadFromRegistry,  (HANDLE, uint32, uint32, void *, uint32 *))
BDAQ_API_DEF_IMPL(AdxPropertyWriteToRegistry,   (HANDLE, uint32, uint32, void *))

BDAQ_API_DEF_IMPL(AdxDeviceOpen,                (int32, uint32, HANDLE *))
BDAQ_API_DEF_IMPL(AdxDeviceClose,               (HANDLE))
BDAQ_API_DEF_IMPL(AdxDeviceReset,               (HANDLE, uint32))
BDAQ_API_DEF_IMPL(AdxDeviceGetFunctionHandle,   (HANDLE, uint32, uint32, HANDLE *))
BDAQ_API_DEF_IMPL(AdxDeviceRefreshProperties,   (HANDLE))
BDAQ_API_DEF_IMPL(AdxDeviceReadPorts,           (HANDLE, uint32, uint32, void *))
BDAQ_API_DEF_IMPL(AdxDeviceWritePorts,          (HANDLE, uint32, uint32, void *))
BDAQ_API_DEF_IMPL(AdxDeviceShowConfigDialogBox, (HANDLE, HWND, LPRECT, uint32, uint32, HWND*))
BDAQ_API_DEF_IMPL(AdxDevicePrivateRegionRead,   (HANDLE, uint32, uint32, uint8 *))
BDAQ_API_DEF_IMPL(AdxDevicePrivateRegionWrite,  (HANDLE, uint32, uint32, uint8 *))

BDAQ_API_DEF_IMPL(AdxAiGetChannelMapping,       (HANDLE, uint32, uint32 *))
BDAQ_API_DEF_IMPL(AdxAiReadSamples,             (HANDLE, uint32, uint32, void *, double*))
BDAQ_API_DEF_IMPL(AdxBufferedAiPrepare,         (HANDLE, uint32, void **))
BDAQ_API_DEF_IMPL(AdxBufferedAiRunOnce,         (HANDLE, uint32))
BDAQ_API_DEF_IMPL(AdxBufferedAiRun,             (HANDLE))
BDAQ_API_DEF_IMPL(AdxBufferedAiStop,            (HANDLE))
BDAQ_API_DEF_IMPL(AdxBufferedAiRelease,         (HANDLE))
BDAQ_API_DEF_IMPL(AdxBufferedAiScaleData,       (HANDLE, void *, double*,uint32, uint32 *))
BDAQ_API_DEF_IMPL(AdxAiGetScaleTable,           (HANDLE, uint32, uint32 *, PMapFuncPiece))
BDAQ_API_DEF_IMPL(AdxAiSetScaleTable,           (HANDLE, uint32, uint32,  PMapFuncPiece))
BDAQ_API_DEF_IMPL(AdxAiGenerateNewValueRange,   (HANDLE, uint32, uint32,  PMapFuncPiece, uint32 *))
BDAQ_API_DEF_IMPL(AdxAiGetCjcScaleTable,        (HANDLE, uint32 *, PMapFuncPiece))
BDAQ_API_DEF_IMPL(AdxAiSetCjcScaleTable,        (HANDLE, uint32,  PMapFuncPiece))

BDAQ_API_DEF_IMPL(AdxAoWriteSamples,            (HANDLE, uint32, uint32, void *, double*))
BDAQ_API_DEF_IMPL(AdxBufferedAoPrepare,         (HANDLE, uint32, void **))
BDAQ_API_DEF_IMPL(AdxBufferedAoRunOnce,         (HANDLE, uint32))
BDAQ_API_DEF_IMPL(AdxBufferedAoRun,             (HANDLE))
BDAQ_API_DEF_IMPL(AdxBufferedAoStop,            (HANDLE, uint32))
BDAQ_API_DEF_IMPL(AdxBufferedAoRelease,         (HANDLE))
BDAQ_API_DEF_IMPL(AdxBufferedAoScaleData,       (HANDLE, double*, void *, uint32, uint32 *))
BDAQ_API_DEF_IMPL(AdxAoGetScaleTable,           (HANDLE, uint32, uint32 *, PMapFuncPiece))
BDAQ_API_DEF_IMPL(AdxAoSetScaleTable,           (HANDLE, uint32, uint32,  PMapFuncPiece))
BDAQ_API_DEF_IMPL(AdxAoGenerateNewValueRange,   (HANDLE, uint32, uint32,  PMapFuncPiece, uint32 *))
BDAQ_API_DEF_IMPL(AdxDiReadPorts,               (HANDLE, uint32, uint32,  uint8 *))
BDAQ_API_DEF_IMPL(AdxDoWritePorts,              (HANDLE, uint32, uint32,  uint8 *))
BDAQ_API_DEF_IMPL(AdxDoReadBackPorts,           (HANDLE, uint32, uint32,  uint8 *))
BDAQ_API_DEF_IMPL(AdxBufferedDiPrepare,         (HANDLE, uint32, void **))
BDAQ_API_DEF_IMPL(AdxBufferedDiRunOnce,         (HANDLE, uint32))
BDAQ_API_DEF_IMPL(AdxBufferedDiRun,             (HANDLE))
BDAQ_API_DEF_IMPL(AdxBufferedDiStop,            (HANDLE))
BDAQ_API_DEF_IMPL(AdxBufferedDiRelease,         (HANDLE))
BDAQ_API_DEF_IMPL(AdxBufferedDoPrepare,         (HANDLE, uint32, void **))
BDAQ_API_DEF_IMPL(AdxBufferedDoRunOnce,         (HANDLE, uint32))
BDAQ_API_DEF_IMPL(AdxBufferedDoRun,             (HANDLE))
BDAQ_API_DEF_IMPL(AdxBufferedDoStop,            (HANDLE, uint32))
BDAQ_API_DEF_IMPL(AdxBufferedDoRelease,         (HANDLE))
BDAQ_API_DEF_IMPL(AdxDiSnapStart,               (HANDLE, uint32, uint32, uint32, uint8 **))
BDAQ_API_DEF_IMPL(AdxDiSnapStop,                (HANDLE, uint32))
BDAQ_API_DEF_IMPL(AdxDoReflectWdtLockStart,     (HANDLE))
BDAQ_API_DEF_IMPL(AdxDoReflectWdtFeed,          (HANDLE))
BDAQ_API_DEF_IMPL(AdxDoReflectWdtLockStop,      (HANDLE))
BDAQ_API_DEF_IMPL(AdxDiReadBit,                 (HANDLE, uint32, uint32,  uint8 *))
BDAQ_API_DEF_IMPL(AdxDoWriteBit,                (HANDLE, uint32, uint32,  uint8))
BDAQ_API_DEF_IMPL(AdxDoReadBackBit,             (HANDLE, uint32, uint32,  uint8 *))

BDAQ_API_DEF_IMPL(AdxCounterReset,              (HANDLE, uint32, uint32))
BDAQ_API_DEF_IMPL(AdxCounterRead,               (HANDLE, uint32, uint32, uint32*,uint32*))
BDAQ_API_DEF_IMPL(AdxCounterStart,              (HANDLE, uint32, uint32))
BDAQ_API_DEF_IMPL(AdxEventCountStart,           (HANDLE, uint32, uint32))
BDAQ_API_DEF_IMPL(AdxEventCountRead,            (HANDLE, uint32, uint32, uint32*))
BDAQ_API_DEF_IMPL(AdxOneShotStart,              (HANDLE, uint32, uint32))
BDAQ_API_DEF_IMPL(AdxTimerPulseStart,           (HANDLE, uint32, uint32))
BDAQ_API_DEF_IMPL(AdxFrequencyMeasureStart,     (HANDLE, uint32, uint32))
BDAQ_API_DEF_IMPL(AdxFrequencyMeasureRead,      (HANDLE, uint32, uint32, double*))
BDAQ_API_DEF_IMPL(AdxPwmInStart,                (HANDLE, uint32, uint32))
BDAQ_API_DEF_IMPL(AdxPwmInRead,                 (HANDLE, uint32, uint32, double*, double*))
BDAQ_API_DEF_IMPL(AdxPwmOutStart,               (HANDLE, uint32, uint32))

BDAQ_API_DEF_IMPL(AdxUpDownCountStart,          (HANDLE, uint32, uint32, uint32))
BDAQ_API_DEF_IMPL(AdxUpDownCountValueReset,     (HANDLE, uint32, uint32))
BDAQ_API_DEF_IMPL(AdxUpDownCountRead,           (HANDLE, uint32, uint32, uint32*))
BDAQ_API_DEF_IMPL(AdxCounterSnapStart,          (HANDLE, uint32, uint32, uint32, uint32**, uint32**))
BDAQ_API_DEF_IMPL(AdxCounterSnapStop,           (HANDLE, uint32))
BDAQ_API_DEF_IMPL(AdxCounterCompareSetTable,    (HANDLE, uint32, uint32, uint32*))
BDAQ_API_DEF_IMPL(AdxCounterCompareSetInterval, (HANDLE, uint32, uint32, uint32, uint32))
BDAQ_API_DEF_IMPL(AdxCounterCompareClear,       (HANDLE, uint32))

BDAQ_API_DEF_IMPL(AdxFirmwareDownload,          (HANDLE, uint32, uint32, uint32, void *))

extern BioDriverFunctionTable const g_dn3apiStub = {
   BDAQ_API_DEF_IMPL_NOT_SPTED(AdxEventGetHandle),
   BDAQ_API_DEF_IMPL_NOT_SPTED(AdxEventGetLastStatus),
   BDAQ_API_DEF_IMPL_NOT_SPTED(AdxEventClearFlag),
   BDAQ_API_DEF_IMPL_NOT_SPTED(AdxPropertyRead),
   BDAQ_API_DEF_IMPL_NOT_SPTED(AdxPropertyReadFromRegistry),
   BDAQ_API_DEF_IMPL_NOT_SPTED(AdxPropertyWrite),
   BDAQ_API_DEF_IMPL_NOT_SPTED(AdxPropertyWriteToRegistry),
   BDAQ_API_DEF_IMPL_NOT_SPTED(AdxGetLastError),

   // device routines
   BDAQ_API_DEF_IMPL_NOT_SPTED(AdxDeviceOpen),
   BDAQ_API_DEF_IMPL_NOT_SPTED(AdxDeviceClose),
   BDAQ_API_DEF_IMPL_NOT_SPTED(AdxDeviceReset),
   BDAQ_API_DEF_IMPL_NOT_SPTED(AdxDeviceGetFunctionHandle),
   BDAQ_API_DEF_IMPL_NOT_SPTED(AdxDeviceRefreshProperties),
   BDAQ_API_DEF_IMPL_NOT_SPTED(AdxDeviceReadPorts),
   BDAQ_API_DEF_IMPL_NOT_SPTED(AdxDeviceWritePorts),
   BDAQ_API_DEF_IMPL_NOT_SPTED(AdxDeviceShowConfigDialogBox),

   // AI routines
   BDAQ_API_DEF_IMPL_NOT_SPTED(AdxAiGetChannelMapping),
   BDAQ_API_DEF_IMPL_NOT_SPTED(AdxAiReadSamples),
   BDAQ_API_DEF_IMPL_NOT_SPTED(AdxBufferedAiPrepare),
   BDAQ_API_DEF_IMPL_NOT_SPTED(AdxBufferedAiRunOnce),
   BDAQ_API_DEF_IMPL_NOT_SPTED(AdxBufferedAiRun),
   BDAQ_API_DEF_IMPL_NOT_SPTED(AdxBufferedAiStop),
   BDAQ_API_DEF_IMPL_NOT_SPTED(AdxBufferedAiRelease),
   BDAQ_API_DEF_IMPL_NOT_SPTED(AdxBufferedAiScaleData),
   BDAQ_API_DEF_IMPL_NOT_SPTED(AdxAiGetScaleTable),
   BDAQ_API_DEF_IMPL_NOT_SPTED(AdxAiSetScaleTable),
   BDAQ_API_DEF_IMPL_NOT_SPTED(AdxAiGenerateNewValueRange),
   BDAQ_API_DEF_IMPL_NOT_SPTED(AdxAiGetCjcScaleTable),
   BDAQ_API_DEF_IMPL_NOT_SPTED(AdxAiSetCjcScaleTable),

   // AO routines
   BDAQ_API_DEF_IMPL_NOT_SPTED(AdxAoWriteSamples),
   BDAQ_API_DEF_IMPL_NOT_SPTED(AdxBufferedAoPrepare),
   BDAQ_API_DEF_IMPL_NOT_SPTED(AdxBufferedAoRunOnce),
   BDAQ_API_DEF_IMPL_NOT_SPTED(AdxBufferedAoRun),
   BDAQ_API_DEF_IMPL_NOT_SPTED(AdxBufferedAoStop),
   BDAQ_API_DEF_IMPL_NOT_SPTED(AdxBufferedAoRelease),
   BDAQ_API_DEF_IMPL_NOT_SPTED(AdxBufferedAoScaleData),
   BDAQ_API_DEF_IMPL_NOT_SPTED(AdxAoGetScaleTable),
   BDAQ_API_DEF_IMPL_NOT_SPTED(AdxAoSetScaleTable),
   BDAQ_API_DEF_IMPL_NOT_SPTED(AdxAoGenerateNewValueRange),

   // DIO routines
   BDAQ_API_DEF_IMPL_NOT_SPTED(AdxDiReadPorts),
   BDAQ_API_DEF_IMPL_NOT_SPTED(AdxDoWritePorts),
   BDAQ_API_DEF_IMPL_NOT_SPTED(AdxDoReadBackPorts),
   BDAQ_API_DEF_IMPL_NOT_SPTED(AdxBufferedDiPrepare),
   BDAQ_API_DEF_IMPL_NOT_SPTED(AdxBufferedDiRunOnce),
   BDAQ_API_DEF_IMPL_NOT_SPTED(AdxBufferedDiRun),
   BDAQ_API_DEF_IMPL_NOT_SPTED(AdxBufferedDiStop),
   BDAQ_API_DEF_IMPL_NOT_SPTED(AdxBufferedDiRelease),
   BDAQ_API_DEF_IMPL_NOT_SPTED(AdxBufferedDoPrepare),
   BDAQ_API_DEF_IMPL_NOT_SPTED(AdxBufferedDoRunOnce),
   BDAQ_API_DEF_IMPL_NOT_SPTED(AdxBufferedDoRun),
   BDAQ_API_DEF_IMPL_NOT_SPTED(AdxBufferedDoStop),
   BDAQ_API_DEF_IMPL_NOT_SPTED(AdxBufferedDoRelease),
   BDAQ_API_DEF_IMPL_NOT_SPTED(AdxDiSnapStart),
   BDAQ_API_DEF_IMPL_NOT_SPTED(AdxDiSnapStop),
   BDAQ_API_DEF_IMPL_NOT_SPTED(AdxDoReflectWdtLockStart),
   BDAQ_API_DEF_IMPL_NOT_SPTED(AdxDoReflectWdtFeed),
   BDAQ_API_DEF_IMPL_NOT_SPTED(AdxDoReflectWdtLockStop),

   // Counter routines
   BDAQ_API_DEF_IMPL_NOT_SPTED(AdxCounterReset),
   BDAQ_API_DEF_IMPL_NOT_SPTED(AdxCounterRead),
   BDAQ_API_DEF_IMPL_NOT_SPTED(AdxCounterStart),
   BDAQ_API_DEF_IMPL_NOT_SPTED(AdxEventCountStart),
   BDAQ_API_DEF_IMPL_NOT_SPTED(AdxEventCountRead),
   BDAQ_API_DEF_IMPL_NOT_SPTED(AdxOneShotStart),
   BDAQ_API_DEF_IMPL_NOT_SPTED(AdxTimerPulseStart),
   BDAQ_API_DEF_IMPL_NOT_SPTED(AdxFrequencyMeasureStart),
   BDAQ_API_DEF_IMPL_NOT_SPTED(AdxFrequencyMeasureRead),

   //##xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
   // V1.1, added the H/W private region read/write
   //##xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
   BDAQ_API_DEF_IMPL_NOT_SPTED(AdxDevicePrivateRegionRead),
   BDAQ_API_DEF_IMPL_NOT_SPTED(AdxDevicePrivateRegionWrite),

   //##xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
   // V1.2, API prototype, Pulse width measure and Pulse width modulation
   //##xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
   BDAQ_API_DEF_IMPL_NOT_SPTED(AdxPwmInStart),
   BDAQ_API_DEF_IMPL_NOT_SPTED(AdxPwmInRead),
   BDAQ_API_DEF_IMPL_NOT_SPTED(AdxPwmOutStart),

   //##xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
   // V1.3, API prototype, Up-down count
   //##xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
   BDAQ_API_DEF_IMPL_NOT_SPTED(AdxUpDownCountStart),     
   BDAQ_API_DEF_IMPL_NOT_SPTED(AdxUpDownCountValueReset),     
   BDAQ_API_DEF_IMPL_NOT_SPTED(AdxUpDownCountRead),           
   BDAQ_API_DEF_IMPL_NOT_SPTED(AdxCounterSnapStart),          
   BDAQ_API_DEF_IMPL_NOT_SPTED(AdxCounterSnapStop),           
   BDAQ_API_DEF_IMPL_NOT_SPTED(AdxCounterCompareSetTable),    
   BDAQ_API_DEF_IMPL_NOT_SPTED(AdxCounterCompareSetInterval), 
   BDAQ_API_DEF_IMPL_NOT_SPTED(AdxCounterCompareClear),       

   //##xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
   // V1.4, write the Dio Bit
   //##xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
   BDAQ_API_DEF_IMPL_NOT_SPTED(AdxDoWriteBit),

   //##xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
   // V1.5, firmware download
   //##xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
   BDAQ_API_DEF_IMPL_NOT_SPTED(AdxFirmwareDownload),
};
