/*******************************************************************************
              Copyright (c) 1983-2009 Advantech Co., Ltd.
********************************************************************************
THIS IS AN UNPUBLISHED WORK CONTAINING CONFIDENTIAL AND PROPRIETARY INFORMATION
WHICH IS THE PROPERTY OF ADVANTECH CORP., ANY DISCLOSURE, USE, OR REPRODUCTION,
WITHOUT WRITTEN AUTHORIZATION FROM ADVANTECH CORP., IS STRICTLY PROHIBITED. 

================================================================================
REVISION HISTORY
--------------------------------------------------------------------------------
$Log: $
--------------------------------------------------------------------------------
$NoKeywords:  $
*/

/****************************************************************************
*                                                                           *
* FunctionTable.h -- Bionic driver function and function table structure    *
*                    definition                                             *
*                                                                           *
****************************************************************************/

#ifndef _BIONIC_FUNCTION_TABLE_DEFINITION
#define _BIONIC_FUNCTION_TABLE_DEFINITION

//##xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// V1.0, API prototype(initial version)
//##xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// component common routines
typedef ErrorCode (BDAQCALL *FPEventGetHandle)(HANDLE, uint32, HANDLE*);
typedef ErrorCode (BDAQCALL *FPEventGetLastStatus)(HANDLE, uint32, uint32*, uint32*);
typedef ErrorCode (BDAQCALL *FPEventClearFlag)(HANDLE, uint32, uint32, uint32);
typedef ErrorCode (BDAQCALL *FPPropertyRead)(HANDLE, uint32, uint32, void *, uint32*, uint32*);
typedef ErrorCode (BDAQCALL *FPPropertyReadFromRegistry)(HANDLE, uint32, uint32, void *, uint32*);
typedef ErrorCode (BDAQCALL *FPPropertyWrite)(HANDLE, uint32, uint32, void *, uint32);
typedef ErrorCode (BDAQCALL *FPPropertyWriteToRegistry)(HANDLE, uint32, uint32, void *);
typedef ErrorCode (BDAQCALL *FPGetLastError)(HANDLE, wchar_t *, uint32, uint32*);

// device routines
typedef ErrorCode (BDAQCALL *FPDeviceOpen)(int32, uint32, HANDLE*);
typedef ErrorCode (BDAQCALL *FPDeviceClose)(HANDLE);
typedef ErrorCode (BDAQCALL *FPDeviceReset)(HANDLE, uint32);
typedef ErrorCode (BDAQCALL *FPDeviceGetFuncHandle)(HANDLE, uint32, uint32, HANDLE*);
typedef ErrorCode (BDAQCALL *FPDeviceRefresh)(HANDLE);
typedef ErrorCode (BDAQCALL *FPDeviceReadPorts)(HANDLE, uint32, uint32, void *);
typedef ErrorCode (BDAQCALL *FPDeviceWritePorts)(HANDLE, uint32, uint32, void *);
typedef ErrorCode (BDAQCALL *FPDeviceShowCfgDlgBox)(HANDLE, HWND, RECT *, uint32, uint32, HWND*);

// AI routines
typedef ErrorCode (BDAQCALL *FPAiGetChanMapping)(HANDLE, uint32, uint32*);
typedef ErrorCode (BDAQCALL *FPAiReadSamples)(HANDLE, uint32, uint32, void *, double*);

typedef ErrorCode (BDAQCALL *FPBufferedAiPrepare)(HANDLE, uint32, void * *);
typedef ErrorCode (BDAQCALL *FPBufferedAiRunOnce)(HANDLE, uint32);
typedef ErrorCode (BDAQCALL *FPBufferedAiRun)(HANDLE);
typedef ErrorCode (BDAQCALL *FPBufferedAiStop)(HANDLE);
typedef ErrorCode (BDAQCALL *FPBufferedAiRelease)(HANDLE);
typedef ErrorCode (BDAQCALL *FPBufferedAiScaleData)(HANDLE, void *, double*, uint32, uint32*);

typedef ErrorCode (BDAQCALL *FPAiGetScaleTable)(HANDLE, uint32, uint32*, PMapFuncPiece);
typedef ErrorCode (BDAQCALL *FPAiSetScaleTable)(HANDLE, uint32, uint32, PMapFuncPiece);
typedef ErrorCode (BDAQCALL *FPAiGenerateNewVrg)(HANDLE, uint32, uint32, PMapFuncPiece, uint32*);
typedef ErrorCode (BDAQCALL *FPAiGetCjcScaleTable)(HANDLE, uint32*, PMapFuncPiece);
typedef ErrorCode (BDAQCALL *FPAiSetCjcScaleTable)(HANDLE, uint32, PMapFuncPiece);

// AO routines
typedef ErrorCode (BDAQCALL *FPAoWriteSamples)(HANDLE, uint32, uint32, void *, double*);

typedef ErrorCode (BDAQCALL *FPBufferedAoPrepare)(HANDLE, uint32, void **);
typedef ErrorCode (BDAQCALL *FPBufferedAoRunOnce)(HANDLE, uint32);
typedef ErrorCode (BDAQCALL *FPBufferedAoRun)(HANDLE);
typedef ErrorCode (BDAQCALL *FPBufferedAoStop)(HANDLE, uint32);
typedef ErrorCode (BDAQCALL *FPBufferedAoRelease)(HANDLE);
typedef ErrorCode (BDAQCALL *FPBufferedAoScaleData)(HANDLE, double*, void *, uint32, uint32*);

typedef ErrorCode (BDAQCALL *FPAoGetScaleTable)(HANDLE, uint32, uint32*, PMapFuncPiece);
typedef ErrorCode (BDAQCALL *FPAoSetScaleTable)(HANDLE, uint32, uint32, PMapFuncPiece);
typedef ErrorCode (BDAQCALL *FPAoGenerateNewVrg)(HANDLE, uint32, uint32, PMapFuncPiece, uint32*);

// DIO routines
typedef ErrorCode (BDAQCALL *FPDiReadPorts)(HANDLE, uint32, uint32, uint8 *);
typedef ErrorCode (BDAQCALL *FPDoWritePorts)(HANDLE, uint32, uint32, uint8 *);
typedef ErrorCode (BDAQCALL *FPDoReadBackPorts)(HANDLE, uint32, uint32, uint8 *);

typedef ErrorCode (BDAQCALL *FPBufferedDiPrepare)(HANDLE, uint32, void **);
typedef ErrorCode (BDAQCALL *FPBufferedDiRunOnce)(HANDLE, uint32);
typedef ErrorCode (BDAQCALL *FPBufferedDiRun)(HANDLE);
typedef ErrorCode (BDAQCALL *FPBufferedDiStop)(HANDLE);
typedef ErrorCode (BDAQCALL *FPBufferedDiRelease)(HANDLE);

typedef ErrorCode (BDAQCALL *FPBufferedDoPrepare)(HANDLE, uint32, void **);
typedef ErrorCode (BDAQCALL *FPBufferedDoRunOnce)(HANDLE, uint32);
typedef ErrorCode (BDAQCALL *FPBufferedDoRun)(HANDLE);
typedef ErrorCode (BDAQCALL *FPBufferedDoStop)(HANDLE, uint32);
typedef ErrorCode (BDAQCALL *FPBufferedDoRelease)(HANDLE);

typedef ErrorCode (BDAQCALL *FPDiSnapStart)(HANDLE, uint32, uint32, uint32, uint8 **);
typedef ErrorCode (BDAQCALL *FPDiSnapStop)(HANDLE, uint32);
typedef ErrorCode (BDAQCALL *FPDoReflectWdtLockStart)(HANDLE);
typedef ErrorCode (BDAQCALL *FPDoReflectWdtFeed)(HANDLE);
typedef ErrorCode (BDAQCALL *FPDoReflectWdtLockStop)(HANDLE);

// Counter routines
typedef ErrorCode (BDAQCALL *FPCounterReset)(HANDLE, uint32, uint32);
typedef ErrorCode (BDAQCALL *FPCounterRead)(HANDLE, uint32, uint32, uint32*,uint32*);
typedef ErrorCode (BDAQCALL *FPCounterStart)(HANDLE, uint32, uint32);
typedef ErrorCode (BDAQCALL *FPEventCountStart)(HANDLE, uint32, uint32);
typedef ErrorCode (BDAQCALL *FPEventCountRead)(HANDLE, uint32, uint32, uint32*);
typedef ErrorCode (BDAQCALL *FPOneShotStart)(HANDLE, uint32, uint32);
typedef ErrorCode (BDAQCALL *FPTimerPulseStart)(HANDLE, uint32, uint32);
typedef ErrorCode (BDAQCALL *FPFreqMeasureStart)(HANDLE, uint32, uint32);
typedef ErrorCode (BDAQCALL *FPFreqMeasureRead)(HANDLE, uint32, uint32, double*);

//##xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// V1.1, API prototype, read/write the H/W private region read/write
//##xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
typedef ErrorCode (BDAQCALL *FPDevicePrivateRegionRead)(HANDLE, uint32, uint32, uint8 *);
typedef ErrorCode (BDAQCALL *FPDevicePrivateRegionWrite)(HANDLE, uint32, uint32, uint8 *);

//##xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// V1.2, API prototype, Pulse width measure and Pulse width modulation
//##xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
typedef ErrorCode (BDAQCALL *FPPwmInStart)(HANDLE, uint32, uint32);
typedef ErrorCode (BDAQCALL *FPPwmInRead)(HANDLE, uint32, uint32, double*, double*);
typedef ErrorCode (BDAQCALL *FPPwmOutStart)(HANDLE, uint32, uint32);

//##xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// V1.3, API prototype, Up-down count
//##xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
typedef ErrorCode (BDAQCALL *FPUpDownCountStart)(HANDLE, uint32, uint32, uint32);
typedef ErrorCode (BDAQCALL *FPUpDownCountValueReset)(HANDLE, uint32, uint32);
typedef ErrorCode (BDAQCALL *FPUpDownCountRead)(HANDLE, uint32, uint32, uint32*);
typedef ErrorCode (BDAQCALL *FPCounterSnapStart)(HANDLE, uint32, uint32, uint32, uint32**, uint32**);
typedef ErrorCode (BDAQCALL *FPCounterSnapStop)(HANDLE, uint32);
typedef ErrorCode (BDAQCALL *FPCounterCompareSetTable)(HANDLE, uint32, uint32, uint32*);
typedef ErrorCode (BDAQCALL *FPCounterCompareSetInterval)(HANDLE, uint32, uint32, uint32, uint32);
typedef ErrorCode (BDAQCALL *FPCounterCompareClear)(HANDLE, uint32);

//##xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// V1.4, write the Dio Bit
//##xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
typedef ErrorCode (BDAQCALL *FPDoWriteBit)(HANDLE, uint32, uint32, uint8);

//##xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// V1.5, firmware download
//##xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
typedef enum FWDLCMD {
   FWDL_LOAD_FW_FILE = 0,
   FWDL_OVERWRITE,
   FWDL_GET_COUNT,
   FWDL_GET_DESCRIPTION,
   FWDL_GET_NOTICE,
   FWDL_GET_VERSION_ON_DEVICE,
   FWDL_GET_VERSION_ON_FILE,
   FWDL_GET_OVERWRITE_PROGRESSING
} FWDLCMD;

typedef struct FWDLParam {
   FwAction Action;
   wchar_t  ActivationCode[64];
} FWDLParam;

typedef ErrorCode (BDAQCALL * FPFirmwareDownload)(
   HANDLE fwHdl,
   uint32 index,
   uint32 cmd,  
   uint32 size,
   void  *buffer);

//##xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
//Function table definition.
//Note: 
//   the fields of this structure must not be removed or moved.
//   the new fields must be put at the tail of the structure.
//##xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
typedef struct tagBioDriverFunctionTable
{
   //##xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
   // V1.0, initial version
   //##xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
   // component common routines
   FPEventGetHandle              pfnEventGetHandle;
   FPEventGetLastStatus          pfnEventGetLastStatus;
   FPEventClearFlag              pfnEventClearFlag;
   FPPropertyRead                pfnPropertyRead;
   FPPropertyReadFromRegistry    pfnPropertyReadFromRegistry;
   FPPropertyWrite               pfnPropertyWrite;
   FPPropertyWriteToRegistry     pfnPropertyWriteToRegistry;
   FPGetLastError                pfnGetLastError;

   // device routines
   FPDeviceOpen                  pfnDeviceOpen;
   FPDeviceClose                 pfnDeviceClose;
   FPDeviceReset                 pfnDeviceReset;
   FPDeviceGetFuncHandle         pfnDeviceGetFuncHandle;
   FPDeviceRefresh               pfnDeviceRefresh;
   FPDeviceReadPorts             pfnDeviceReadPorts;
   FPDeviceWritePorts            pfnDeviceWritePorts;
   FPDeviceShowCfgDlgBox         pfnDeviceShowCfgDlgBox;

   // AI routines
   FPAiGetChanMapping		      pfnAiGetChanMapping;
   FPAiReadSamples					pfnAiReadSamples;
   FPBufferedAiPrepare           pfnBufferedAiPrepare;
   FPBufferedAiRunOnce				pfnBufferedAiRunOnce;
   FPBufferedAiRun               pfnBufferedAiRun;
   FPBufferedAiStop					pfnBufferedAiStop;
   FPBufferedAiRelease           pfnBufferedAiRelease;
   FPBufferedAiScaleData			pfnBufferedAiScaleData;
   FPAiGetScaleTable				   pfnAiGetScaleTable;
   FPAiSetScaleTable				   pfnAiSetScaleTable;
   FPAiGenerateNewVrg				pfnAiGenerateNewVrg;
   FPAiGetCjcScaleTable			   pfnAiGetCjcScaleTable;
   FPAiSetCjcScaleTable			   pfnAiSetCjcScaleTable;

   // AO routines
   FPAoWriteSamples					pfnAoWriteSamples;
   FPBufferedAoPrepare           pfnBufferedAoPrepare;
   FPBufferedAoRunOnce				pfnBufferedAoRunOnce;
   FPBufferedAoRun               pfnBufferedAoRun;
   FPBufferedAoStop					pfnBufferedAoStop;
   FPBufferedAoRelease           pfnBufferedAoRelease;
   FPBufferedAoScaleData			pfnBufferedAoScaleData;
   FPAoGetScaleTable					pfnAoGetScaleTable;
   FPAoSetScaleTable					pfnAoSetScaleTable;
   FPAoGenerateNewVrg				pfnAoGenerateNewVrg;

   // DIO routines
   FPDiReadPorts                 pfnDiReadPorts;
   FPDoWritePorts                pfnDoWritePorts;
   FPDoReadBackPorts             pfnDoReadBackPorts;
   FPBufferedDiPrepare           pfnBufferedDiPrepare;
   FPBufferedDiRunOnce           pfnBufferedDiRunOnce;
   FPBufferedDiRun               pfnBufferedDiRun;
   FPBufferedDiStop              pfnBufferedDiStop;
   FPBufferedDiRelease           pfnBufferedDiRelease;
   FPBufferedDoPrepare           pfnBufferedDoPrepare;
   FPBufferedDoRunOnce           pfnBufferedDoRunOnce;
   FPBufferedDoRun               pfnBufferedDoRun;
   FPBufferedDoStop              pfnBufferedDoStop;
   FPBufferedDoRelease           pfnBufferedDoRelease;
   FPDiSnapStart                 pfnDiSnapStart;
   FPDiSnapStop                  pfnDiSnapStop;
   FPDoReflectWdtLockStart       pfnDoReflectWdtLockStart;
   FPDoReflectWdtFeed            pfnDoReflectWdtFeed;
   FPDoReflectWdtLockStop        pfnDoReflectWdtLockStop;

   // Counter routines
   FPCounterReset                pfnCounterReset;
   FPCounterRead                 pfnCounterRead;
   FPCounterStart                pfnCounterStart;
   FPEventCountStart             pfnEventCountStart;
   FPEventCountRead              pfnEventCountRead;
   FPOneShotStart                pfnOneShotStart;
   FPTimerPulseStart             pfnTimerPulseStart;
   FPFreqMeasureStart            pfnFreqMeasureStart;
   FPFreqMeasureRead             pfnFreqMeasureRead;

   //##xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
   // V1.1, read/write the H/W private region read/write
   //##xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
   FPDevicePrivateRegionRead     pfnDevicePrivateRegionRead;
   FPDevicePrivateRegionWrite    pfnDevicePrivateRegionWrite;

   //##xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
   // V1.2, API prototype, Pulse width measure and Pulse width modulation
   //##xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
   FPPwmInStart                  pfnPwmInStart;
   FPPwmInRead                   pfnPwmInRead;
   FPPwmOutStart                 pfnPwmOutStart;

   //##xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
   // V1.3, API prototype, Up-down count
   //##xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
   FPUpDownCountStart            pfnUpDownCountStart;
   FPUpDownCountValueReset       pfnUpDownCountValueReset;
   FPUpDownCountRead             pfnUpDownCountRead;
   FPCounterSnapStart            pfnCounterSnapStart;
   FPCounterSnapStop             pfnCounterSnapStop;
   FPCounterCompareSetTable      pfnCounterCompareSetTable;
   FPCounterCompareSetInterval   pfnCounterCompareSetInterval;
   FPCounterCompareClear         pfnCounterCompareClear;

   //##xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
   // V1.4, write the Dio Bit
   //##xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
   FPDoWriteBit                  pfnDoWriteBit;

   //##xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
   // V1.5, firmware download
   //##xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
   FPFirmwareDownload            pfnFirmwareDownload;
} BioDriverFunctionTable, *PBioDriverFunctionTable;

#endif

