//
// stddecl.h : include file for standard system include files,
// or project specific include files that are used frequently, but
// are changed infrequently
//

#ifndef _DAQ_HELPER_STD_DECL
#define _DAQ_HELPER_STD_DECL

#if defined(_WIN32) || defined(WIN32)
#  ifndef _WIN32_WINNT		      // Allow use of features specific to Windows XP or later.                   
#     define _WIN32_WINNT 0x0501	// Change this to the appropriate value to target other versions of Windows.
#  endif
#endif

#ifndef WIN32_LEAN_AND_MEAN
#  define WIN32_LEAN_AND_MEAN		// Exclude rarely-used stuff from Windows headers
#endif

#ifndef _CRT_SECURE_NO_WARNINGS
#  define _CRT_SECURE_NO_WARNINGS
#endif

#if defined(_WIN32) || defined(WIN32)
#  include <windows.h>
#  include <winioctl.h>
#else
#  include <unistd.h>
#  include <fcntl.h>
#  include <pthread.h>
#  include <errno.h>
#  include <sys/ioctl.h>
#  include <sys/mman.h>
#  include <sys/stat.h>
#endif

#include <malloc.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <math.h>
#include <float.h>
#include <assert.h>
#include <wchar.h>

#include <bdaq_util.h>
#include <stdarg.h>
#include <x_buffer.h>
#include <lock.h>
#include <ioctl_helper.hpp>

#endif

