#ifndef ENUM_STRINGS_H
#define ENUM_STRINGS_H

//
// The string using 'unicode' string due to Bionic DAQ DRIVER SPEC.
//

// AccessMode
#define ModeRead_String           L"Read"
#define ModeWrite_String          L"Write"
#define ModeWriteWithReset_String L"Write with Reset"

// AiSignalType
#define SingleEnded_String       L"Single-Ended"
#define Differential_String      L"Differential"

// AiCouplingType
#define ACCoupling_String       L"AC"
#define DCCoupling_String       L"DC"

// AiImpedanceType
#define Ipd1Momh_String         L"1M ohm"
#define Ipd50omh_String         L"50 ohm"

// AiIEPEType
#define IEPENone_String        L"None" 
#define IEPE4mA_String         L"4mA" 
#define IEPE10mA_String        L"10mA" 

// ActiveSignal
#define ActiveNone_String        L"None"
#define RisingEdge_String        L"Rising"
#define FallingEdge_String       L"Falling"
#define BothEdge_String          L"Both"
#define HighLevel_String         L"High"
#define LowLevel_String          L"Low"

// FilterType
#define FilterNone_String        L"FilterNone"
#define LowPass_String           L"LowPass"
#define HighPass_String          L"HighPass"
#define BandPass_String          L"BandPass"
#define BandStop_String          L"BandStop"

/*-------------------------------------------------------------------
* Value range type string
*-------------------------------------------------------------------*/
#define V_Neg15To15_String            L"+/- 15 V" 
#define V_Neg10To10_String            L"+/- 10 V" 
#define V_Neg5To5_String              L"+/- 5 V"
#define V_Neg2pt5To2pt5_String        L"+/- 2.5 V"
#define V_Neg1pt25To1pt25_String      L"+/- 1.25 V"
#define V_Neg1To1_String              L"+/- 1 V"
#define V_Neg2To2_String              L"+/- 2 V"
#define V_Neg4To4_String              L"+/- 4 V"
#define V_Neg20To20_String            L"+/- 20 V"
#define V_0To15_String                L"0 ~ 15 V" 
#define V_0To10_String                L"0 ~ 10 V" 
#define V_0To5_String                 L"0 ~ 5 V"
#define V_0To2pt5_String              L"0 ~ 2.5 V"
#define V_0To1pt25_String             L"0 ~ 1.25 V"
#define V_0To1_String                 L"0 ~ 1 V"
#define mV_Neg625To625_String         L"+/- 625 mV"
#define mV_Neg500To500_String         L"+/- 500 mV"
#define mV_Neg312pt5To312pt5_String   L"+/- 312.5 mV"
#define mV_Neg200To200_String         L"+/- 200 mV"
#define mV_Neg150To150_String         L"+/- 150 mV"
#define mV_Neg100To100_String         L"+/- 100 mV"
#define mV_Neg50To50_String           L"+/- 50 mV"
#define mV_Neg30To30_String           L"+/- 30 mV"
#define mV_Neg20To20_String           L"+/- 20 mV"
#define mV_Neg15To15_String           L"+/- 15 mV" 
#define mV_Neg10To10_String           L"+/- 10 mV"
#define mV_Neg5To5_String             L"+/- 5 mV"
#define mV_0To625_String              L"0 ~ 625 mV"
#define mV_0To500_String              L"0 ~ 500 mV"
#define mV_0To150_String              L"0 ~ 150 mV"
#define mV_0To100_String              L"0 ~ 100 mV"
#define mV_0To50_String               L"0 ~ 50 mV"
#define mV_0To20_String               L"0 ~ 20 mV"
#define mV_0To15_String               L"0 ~ 15 mV"
#define mV_0To10_String               L"0 ~ 10 mV"
#define mA_Neg20To20_String           L"+/- 20 mA"
#define mA_0To20_String               L"0 ~ 20 mA"
#define mA_4To20_String               L"4 ~ 20 mA"
#define mA_0To24_String               L"0 ~ 24 mA"
#define Jtype_0To760C_String          L"T/C J type 0 ~ 760 degree C"
#define Ktype_0To1370C_String		     L"T/C K type 0 ~ 1370 degree C"
#define Ttype_Neg100To400C_String     L"T/C T type -100 ~ 400 degree C"
#define Etype_0To1000C_String		     L"T/C E type 0 ~ 1000 degree C"
#define Rtype_500To1750C_String	     L"T/C R type 500 ~ 1750 degree C"
#define Stype_500To1750C_String	     L"T/C S type 500 ~ 1750 degree C"
#define Btype_500To1800C_String	     L"T/C B type 500 ~ 1800 degree C"
#define Pt392_Neg50To150_String	     L"Pt392 -50 ~ 150 degree C" 
#define Pt385_Neg200To200_String	     L"Pt385 -200 ~ 200 degree C"
#define Pt385_0To400_String		     L"Pt385 0 ~ 400 degree C"
#define Pt385_Neg50To150_String	     L"Pt385 -50 ~ 150 degree C"
#define Pt385_Neg100To100_String      L"Pt385 -100 ~ 100 degree C"
#define Pt385_0To100_String		     L"Pt385 0 ~ 100 degree C" 
#define Pt385_0To200_String		     L"Pt385 0 ~ 200 degree C"
#define Pt385_0To600_String		     L"Pt385 0 ~ 600 degree C"
#define Pt392_Neg100To100_String      L"Pt392 -100 ~ 100 degree C" 
#define Pt392_0To100_String           L"Pt392 0 ~ 100 degree C"
#define Pt392_0To200_String           L"Pt392 0 ~ 200 degree C"
#define Pt392_0To600_String           L"Pt392 0 ~ 600 degree C"
#define Pt392_0To400_String           L"Pt392 0 ~ 400 degree C"
#define Pt392_Neg200To200_String      L"Pt392 -200 ~ 200 degree C" 
#define Pt1000_Neg40To160_String      L"Pt1000 -40 ~ 160 degree C" 
#define Balcon500_Neg30To120_String   L"Balcon500 -30 ~ 120 degree C" 
#define Ni518_Neg80To100_String       L"Ni518 -80 ~ 100 degree C"
#define Ni518_0To100_String           L"Ni518 0 ~ 100 degree C"
#define Ni508_0To100_String           L"Ni508 0 ~ 100 degree C"
#define Ni508_Neg50To200_String       L"Ni508 -50 ~ 200 degree C"
#define Thermistor_3K_0To100_String   L"Thermistor 3K 0 ~ 100 degree C"
#define Thermistor_10K_0To100_String  L"Thermistor 10K 0 ~ 100 degree C"

#define Jtype_Neg210To1200C_String    L"T/C J type -210 ~ 1200 degree C"
#define Ktype_Neg270To1372C_String    L"T/C K type -270 ~ 1372 degree C"
#define Ttype_Neg270To400C_String     L"T/C T type -270 ~ 400 degree C"
#define Etype_Neg270To1000C_String    L"T/C E type -270 ~ 1000 degree C"
#define Rtype_Neg50To1768C_String     L"T/C R type -50 ~ 1768 degree C"
#define Stype_Neg50To1768C_String     L"T/C S type -50 ~ 1768 degree C"
#define Btype_40To1820C_String        L"T/C B type 40 ~ 1820 degree C"

#define Jtype_Neg210To870C_String     L"T/C J type -210 ~ 870 degree C"
#define Rtype_0To1768C_String         L"T/C R type 0 ~ 1768 degree C"
#define Stype_0To1768C_String         L"T/C S type 0 ~ 1768 degree C"

#define Ttype_Neg20To135C_String      L"T/C T type -20 ~ 135 degree C"

#define V_0To30_String                L"0 ~ 30 V"
#define A_0To3_String                 L"0 ~ 3 A"

#define V_ExternalRefBipolar_String   L"External Reference Bipolar"
#define V_ExternalRefUnipolar_String  L"External Reference Unipolar"

/*-------------------------------------------------------------------
* signal connection type string, for the none regular type. other
*-------------------------------------------------------------------*/
#define SignalNone_String               L"None"
#define SigInternalClock_String         L"Internal Clock" 
#define SigInternal1KHz_String          L"Internal Clock, 1KHz"
#define SigInternal10KHz_String         L"Internal Clock, 10KHz"
#define SigInternal100KHz_String        L"Internal Clock, 100KHz" 
#define SigInternal1MHz_String          L"Internal Clock, 1MHz"
#define SigInternal10MHz_String         L"Internal Clock, 10MHz"
#define SigInternal20MHz_String         L"Internal Clock, 20MHz"
#define SigInternal30MHz_String         L"Internal Clock, 30MHz"
#define SigInternal40MHz_String         L"Internal Clock, 40MHz"
#define SigInternal50MHz_String         L"Internal Clock, 50MHz"
#define SigInternal60MHz_String         L"Internal Clock, 60MHz"
#define SigDiPatternMatch_String        L"DI Pattern Match Interrupt"
#define SigDiStatusChange_String        L"DI Status Change Interrupt"
#define SigExtAnaClock_String           L"External Analog Clock"
#define SigExtAnaScanClock_String       L"External Analog Scan Clock"
#define SigExtAnaTrigger_String         L"External Analog Trigger/0"
#define SigExtAnaTrigger1_String        L"External Analog Trigger 1"
#define SigExtDigClock_String           L"External Digital Clock"
#define SigExtDigTrigger0_String        L"External Digital Trigger 0"
#define SigExtDigTrigger1_String        L"External Digital Trigger 1"
#define SigExtDigTrigger2_String        L"External Digital Trigger 2"
#define SigExtDigTrigger3_String        L"External Digital Trigger 3"
#define SigCHFrzDo_String               L"Channel freeze DO ports pin" 
#define SigInternal2Hz_String           L"Internal Clock, 2Hz"
#define SigInternal20Hz_String          L"Internal Clock, 20Hz"
#define SigInternal200Hz_String         L"Internal Clock, 200Hz"
#define SigInternal2KHz_String          L"Internal Clock, 2KHz"
#define SigInternal20KHz_String         L"Internal Clock, 20KHz"
#define SigInternal200KHz_String        L"Internal Clock, 200KHz"
#define SigInternal2MHz_String          L"Internal Clock, 2MHz"
#define SigInternal100MHz_String        L"Internal Clock, 100MHz"

/* format of the regular signal connection type string */
#define SigAiStringFmt        L"Ai%d"
#define SigAoStringFmt        L"Ao%d"
#define SigDiStringFmt        L"Di%d"
#define SigDioStringFmt       L"Dio%d"
#define SigCntrClkStringFmt   L"Counter%d clock"
#define SigCntrGateStringFmt  L"Counter%d gate"
#define SigCntrOutStringFmt   L"Counter%d out"
#define SigCntrFoutStringFmt  L"Counter%d fout"
#define SigAmsiStringFmt      L"AMSI%d"

/* reference clock*/
#define SigExtDigRefClock_String           L"External Digital Ref Clock"

/*-------------------------------------------------------------------
* Error Code type string
*-------------------------------------------------------------------*/
#define Success_String                     L"The operation is completed successfully."
#define WarningIntrNotAvailable_String     L"The interrupt resource is not available."
#define WarningParamOutOfRange_String      L"The parameter is out of the range."
#define WarningPropValueOutOfRange_String  L"The property value is out of range."
#define WarningPropValueNotSpted_String    L"The property value is not supported."
#define WarningPropValueConflict_String    L"The property value conflicts with the current state."
#define WarningVrgOfGroupNotSame_String    L"The value range of all channels in a group should be same, such as 4~20mA of PCI-1724."
#define ErrorHandleNotValid_String         L"The handle is NULL or its type doesn't match the required operation."
#define ErrorParamOutOfRange_String        L"The parameter value is out of range."
#define ErrorParamNotSpted_String          L"The parameter value is not supported."
#define ErrorParamFmtUnexpted_String       L"The parameter value format is not the expected."
#define ErrorMemoryNotEnough_String        L"Not enough memory is available to complete the operation."
#define ErrorBufferIsNull_String           L"The data buffer is null."
#define ErrorBufferTooSmall_String         L"The data buffer is too small for the operation."
#define ErrorDataLenExceedLimit_String     L"The data length exceeded the limitation."
#define ErrorFuncNotSpted_String           L"The required function is not supported."
#define ErrorEventNotSpted_String          L"The required event is not supported."
#define ErrorPropNotSpted_String           L"The required property is not supported."
#define ErrorPropReadOnly_String           L"The required property is read-only."
#define ErrorPropValueConflict_String      L"The specified property value conflicts with the current state."
#define ErrorPropValueOutOfRange_String    L"The specified property value is out of range."
#define ErrorPropValueNotSpted_String      L"The specified property value is not supported."
#define ErrorPrivilegeNotHeld_String       L"The handle hasn't own the privilege of the operation the user wanted."
#define ErrorPrivilegeNotAvailable_String  L"The required privilege is not available because someone else had own it."
#define ErrorDriverNotFound_String         L"The driver of specified device was not found."
#define ErrorDriverVerMismatch_String      L"The driver version of the specified device mismatched."
#define ErrorDriverCountExceedLimit_String L"The loaded driver count exceeded the limitation."
#define ErrorDeviceNotOpened_String        L"The device is not opened."
#define ErrorDeviceNotExist_String         L"The required device does not exist."
#define ErrorDeviceUnrecognized_String     L"The required device is unrecognized by driver."
#define ErrorConfigDataLost_String         L"The configuration data of the specified device is lost or unavailable."
#define ErrorFuncNotInited_String          L"The function is not initialized and can't be started."
#define ErrorFuncBusy_String               L"The function is busy."
#define ErrorIntrNotAvailable_String       L"The interrupt resource is not available."
#define ErrorDmaNotAvailable_String        L"The DMA channel is not available."
#define ErrorDeviceIoTimeOut_String        L"Time out when reading/writing the device."
#define ErrorSignatureNotMatch_String      L"The given signature does not match with the device current one."
#define ErrorFuncConflictWithBfdAi_String  L"The function cannot be executed while the buffered AI is running."
#define ErrorVrgNotAvailableInSeMode_String  L"The value range is not available in single-ended mode."
#define ErrorVrgNotAvailableIn50ohmMode_String  L"The value range is not available in 50omh input impedance mode."
#define ErrorCouplingNotAvailableIn50ohmMode_String  L"The coupling type is not available in 50omh input impedance mode."
#define ErrorUndefined_String                L"Undefined error"

/*-------------------------------------------------------------------
* BurnoutRetType string
*-------------------------------------------------------------------*/
#define Current_String                     L"Return current"
#define ParticularValue_String             L"Return particular value"
#define UpLimit_String                     L"Return up limit"
#define LowLimit_String                    L"Return low limit"
#define LastCorrectValue_String            L"Return last currect value"
#endif /* ENUM_STRINGS_H */
