//
// Thin wrapper of OS character operation methods
//
#ifndef _DAQNAVI_X_CHAR_H
#define _DAQNAVI_X_CHAR_H

//---------------------------------------------------------------
// Windows Character Methods
//---------------------------------------------------------------
#if defined(_WIN32) || defined(WIN32) 
// ANSI
#  define x_strncpy    strncpy
#  define x_stricmp    _stricmp
#  define x_vsnprintf  _vsnprintf
#  define x_snprintf   _snprintf
#  define x_strdup     _strdup
#  define x_strtoui64  _strtoui64

// WCHAR
#  define x_wcsicmp    _wcsicmp
#  define x_wcstoui64  _wcstoui64
#  define x_swprintf   swprintf_s

#  define x_wcsncpy(dst, src, nchars)   wcsncpy_s(dst, nchars, src, _TRUNCATE)
#  define x_wcstombs(mbs, wcs, nbytes)  wcstombs_s(NULL, mbs, nbytes, wcs, _TRUNCATE)
#  define x_mbstowcs(wcs, mbs, nchars)  mbstowcs_s(NULL, wcs, nchars, mbs, _TRUNCATE)

#else
//---------------------------------------------------------------
// Linux/GCC Character Methods
//---------------------------------------------------------------
// ANSI
#  define x_strncpy    strncpy
#  define x_stricmp    strcasecmp
#  define x_vsnprintf  vsnprintf
#  define x_snprintf   snprintf
#  define x_strdup     strdup
#  define x_strtoui64  strtoull

// WCHAR
#  define x_swprintf   swprintf
#  define x_wcsicmp    wcscasecmp
#  define x_wcstoui64  wcstoull

#  define x_wcsncpy    wcsncpy
#  define x_wcstombs   wcstombs
#  define x_mbstowcs   mbstowcs

#endif


#endif
